#!/usr/bin/perl -w

# modified from group_seq_var2.pl

# INPUT: xxx_mask_nr_cons_plus_gr_mask.fas a fasta file with short sequences in it. Microsatellites are printed in lowercase letters
#	xxx_mask_nr_unique.fas (only sequneces that are no hit or only redundant)

# makes a all agints all blast with soft filtering '-F m -U T -m 8'
#selects sequences that did not have hit (apart from autohit) and makes a fasta file with it.

# OUTPUT: 	xxx_pipe3.fas consensus sequences that did not have hit to other sequences of the same file + 
# original unique sequences 

  use warnings;
  use strict;
  use subprogramEM;


my $e = '';
my $blast_path = '';
my $syst = '';
my $folder = '';
my $outfolder = '';
my $file_mot = '';

if ( scalar@ARGV == 6)
{
	$e = $ARGV[0];
	$blast_path = $ARGV[1];
	$syst = $ARGV[2];
	$folder = $ARGV[3];
	$outfolder = $ARGV[4];
	$file_mot = $ARGV[5];
}
else
{
	$e = '1E-40';
	#$blast_path = '/home/user0/bin/blast-2.2.19/bin/';
	#$blast_path = '/usr/local/bin/blast-2.2.13/bin/';
	$blast_path = 'c:/BLAST2_2_18/bin/';
	$syst = 'win';
	#$syst = 'linux';
	$folder = 'datatemp1';
	$outfolder = 'temp1';
	$file_mot = '_mask_nr_cons_plus_gr_mask\.fas';
}



  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);




foreach my $filename (@filenames)
{
if ($filename =~ /$file_mot$/)
{
	my $blast_out = $filename;
	$blast_out =~ s/\.fas/_m8\.tbl/;
	$blast_out = $outfolder.'/'.$blast_out;
	my $fasta_out = $filename;
	$fasta_out =~ s/_pipe2.*/_pipe3\.fas/;
	$fasta_out = $outfolder.'/'.$fasta_out;

      $filename = $folder.'/'.$filename;
	my $unique = $filename;
	$unique =~ s/_cons_plus_gr_mask/_unique/;
##############################################
my $file_bool = check_if_first_line_empty($filename);
   call_blast_tbl_soft_filter($filename, $blast_out, $e, $blast_path);
	if ($syst eq 'win' and $file_bool ==1)
	{
	    delete_blast_temp_files_win1($folder);
	}
	elsif ($syst eq 'linux'  and $file_bool ==1)
	{
	    delete_blast_temp_files($folder);
	}
###############################################

	my %hit = ();
	open_file_in($blast_out, 'BL');
	while(my $line = <BL>)
	{
		my @line = split(' ', $line);
		if ($line[0] =~ /cons/ or $line[1] =~ /cons/ )
		{
		unless($line[0] eq $line[1])
		{
			$hit{$line[0]} = '';
			$hit{$line[1]} = '';
		}
		}
	}
	close BL;

###########
# wrie cons seq that had no hit to a fasta file
	open_file_out($fasta_out, 'OUT');
	open_file_in($filename, 'IN');
	$/ = ">";
	while (my $seq = <IN>)
	{
		$seq =~ s/>//;
		unless ($seq eq '')
		{
			$seq =~ /.*\n/;
			my $code = $&;
			$seq =~ s/$code//;
			$seq =~ s/\s//g;
			$code =~ s/\s.*//;
			$code =~ s/\s//;
			if ($code =~ /cons/)
			{
				unless(exists $hit{$code})
				{
					print OUT ">$code\n$seq\n";
				}
			}
		}
# end while
	}
	$/ = "\n";
	close IN;
# add original unique sequenes to the outfile

	open_file_in($unique, 'UNI');
	while(my $line = <UNI>)
	{
		print OUT "$line";
	}
	close UNI;
	close OUT;

# end if file mot
}
# end foreach filename
}
exit;
