#!/usr/bin/perl -w


  use warnings;
  use strict;
  use subprogramEM;

# if $direct_par = 1 all parameters except input folder are defined in the program; 
# if $direct_par = 0 set_file is read and the user is asked if the settings are correct and can change them
# parameters non_visibles (data2 is produced by pipe1.pl)
# if $direct_par = 2 the set_file is read and the user cannot change the parameters (option for running behind a windows interface)


##############
# parameters non-visibles
my $direct_par = 0;
my $set_file = 'set_pipe1.txt';
####################

##################
# parameters read from file
# if del_files = 0 leave all temp files, if 1 leave only the most informatives, (xxx_length.tbl, and infiles fro step2)
#the results of primer3
my $del_files = 0;
my $blast_path = '';
my $folder = '';
my $length_limit = 0;
my $min1 = 0;
my $min2 = 0;
my $min3 = 0;
my $min4 = 0;
my $min5 = 0;
my $min6 = 0;
my $e_tag = '';
my $word_size = 0; 
my $Evector = '';
#If $tag ==1 run sort_tag_beg_orig.pl 
my $tag = '';
my $adapter = '';
my $syst = '';

#####################

if ($direct_par == 1)
{
	$del_files = 0;
#	$blast_path = 'c:/BLAST2_2_18/bin/';
	$blast_path = '/home/user0/bin/blast-2.2.19/bin/';
	$folder = 'data1';
	$length_limit = '80';
	$min1 = 1000000;
	$min2 = 4;
	$min3 = 4;
	$min4 = 4;
	$min5 = 4;
	$min6 = 4;
	$e_tag = '1E-1';
	$word_size = 7; 
	$Evector = '1E-3';
	$tag = 1;
	$adapter = 1;
	$syst = 'linux';

}
elsif ($direct_par == 0)
{
print "**********************************************************\n";
print "QDD version1.2 22 February 2010\n";
print "Emese Meglecz, Aix-Marseille University, Marseille, France\n";
print 'emese.meglecz@univ-provence.fr';
print "\n";
print "Plesae, read the Documentation_QDD.pdf\n";
print "**********************************************************\n";

param_input($set_file,\$del_files,\$blast_path,\$folder,\$length_limit,\$min1,\$min2,\$min3,\$min4,\$min5,\$min6,\$e_tag,\$word_size,\$Evector,\$tag,\$adapter,\$syst);
}
else
{
	open(SET, $set_file);
	my @setings = <SET>;

	$del_files = $setings[0];
	chomp $del_files;
	$blast_path = $setings[1];
	chomp $blast_path;
	$folder = $setings[2];
	chomp $folder;
	$length_limit = $setings[3];
	chomp $length_limit;
	$min1 = $setings[4];
	chomp $min1;
	$min2 = $setings[5];
	chomp $min2;
	$min3 = $setings[6];
	chomp $min3;
	$min4 = $setings[7];
	chomp $min4;
	$min5 = $setings[8];
	chomp $min5;
	$min6 = $setings[9];
	chomp $min6;
	$e_tag = $setings[10];
	chomp $e_tag;
	$word_size = $setings[11]; 
	chomp $word_size;
	$Evector = $setings[12];
	chomp $Evector;
	$tag = $setings[13];
	chomp $tag;
	$adapter = $setings[14];
	chomp $adapter;
	$syst = $setings[15];
	chomp $syst;

	close SET;
	
  open(OLDOUT, ">&STDOUT");
  open(OLDERR, ">&STDERR");
	open(STDOUT, "> logfile.log") or die "Can't open STDOUT to logfile $!\n";
	open(STDERR, ">> errors.log") or die "Can't open STDERR to logfile $!\n";
}

# check if '\' or '/'is present at the end of the prorgam path and add if it it missing
check_path(\$blast_path, $syst);

print "del_files = $del_files\nblast_path = $blast_path\nfolder = $folder\nlength_limit = $length_limit\n";
print "min1 = $min1\nmin2 = $min2\nmin3 = $min3\nmin4 = $min4\nmin5 = $min5\nmin6 = $min6\n";
print "e_tag = $e_tag\nword_size = $word_size\nEvector = $Evector\ntag = $tag\nadapter = $adapter\nsystem = $syst\n";


##################
##################
##################
# to make windows fans happy to be able to use file names with spaces in it
# copy input files into c:\QDD_tetetemp
my $make_folder = '';
my $copy = '';
my $orig_folder = $folder;
if ($syst eq 'win')
{
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');

	$make_folder = 'md c:\QDD_tetetemp';
	system $make_folder;

	unless ( opendir(FOLDER, $orig_folder) )
	{
   	   print "Cannot access to folder $orig_folder\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);
	foreach my $file (@files)
	{
		if ($file =~ /\.fas$/)
		{
			my $orig_file = $file;
			$file =~ s/\s/_/g;
			my $rename = 'ren "'.$folder.'\\'.$orig_file.'" '.$file;
			system $rename;
			$copy = 'copy "'.$folder.'\\'.$file.'" c:\QDD_tetetemp\\';
			system $copy; 	
		}
	}

	$folder = 'c:\QDD_tetetemp';
	
}
##################
##################
##################

unless ( opendir(FOLDER, $folder) )
{
      print "Cannot access to folder $folder\n";
      exit;
}
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
my $tag_file = '';
my $adapter_file = '';
my @fas = ();
foreach my $file (sort @filenames)
{
	if ($file eq 'tag.fas')
	{
		$tag_file = $folder.'/'.$file;
	}
	elsif ($file eq 'adapter.fas' )
	{
		$adapter_file = $folder.'/'.$file;
	}
	elsif ($file =~ /\.fas$/)
	{
		push(@fas, $file);
	}
}

if ($tag_file eq '' and $tag==1)
{
	print "There is no tag.fas in the input folder!\n";
	exit;
}
if ($adapter_file eq ''and $adapter==1)
{
	print "There is no adapter.fas in the input folder!\n";
	exit;
}

# check if no folder exist with the same name as the files to be analised (WO extesion)
check_and_rename_folder(\@fas, \@filenames, $folder, $syst);

my @data2 = ('data2');
check_and_rename_folder(\@data2, \@filenames, $folder, $syst);



#my $make_folder = ''; 
#my $copy = '';

if ($syst eq 'win')
{
	$make_folder = 'md '.$folder.'\\data2';
	system $make_folder;
}
elsif ($syst eq 'linux')
{
	$make_folder = 'mkdir '.$folder.'/data2';
	system $make_folder;
}

foreach my $file (@fas)
{
	print "********** $file **********\n";

	$file =~ /.+?\./;
	my $tempfolder = $&;
	$tempfolder =~ s/\.//;
	my $outfolder = '';

	if ($syst eq 'win')
	{
	    $outfolder = $folder.'\\'.$tempfolder;
		$make_folder = 'md '.$outfolder;
		system $make_folder;
		$copy = 'copy '.$folder.'\\'.$file.' '.$outfolder.'\\';
		system $copy; 
#		$outfolder = $folder.'/'.$tempfolder;
	}
	elsif ($syst eq 'linux')
	{
	    $outfolder = $folder.'/'.$tempfolder;
		$make_folder = 'mkdir '.$outfolder;
		system $make_folder;
		$copy = 'cp '.$folder.'/'.$file.' '.$outfolder.'/';
	        system $copy;
	}

if ($tag ==1 and $adapter ==1)
{
	if ($syst eq 'win')
	{
   my $sort_tag = 'perl sort_tag_beg_orig.pl '.$syst.' '.$outfolder.' '.$outfolder.' "'.$blast_path.'\" '.$e_tag.' '.$word_size.' '.$tag_file;
	print "\n$sort_tag\n";
   system $sort_tag;

   my $vector = 'perl cut_vector_brut.pl '.$syst.' '.$outfolder.' '.$outfolder.' "'.$blast_path.'\" '.$Evector.' '.$adapter_file.' \.tag';
	print "\n$vector\n";
   system $vector;
	}
	elsif ($syst eq 'linux')
	{
   my $sort_tag = 'perl sort_tag_beg_orig.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$blast_path.' '.$e_tag.' '.$word_size.' '.$tag_file;
	print "\n$sort_tag\n";
   system $sort_tag;

   my $vector = 'perl cut_vector_brut.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$blast_path.' '.$Evector.' '.$adapter_file.' \.tag';
	print "\n$vector\n";
   system $vector;
	}

   my $length = 'perl sort_length.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$length_limit.' \.wov';
	print "\n$length\n";
   system $length;

}
elsif ($adapter == 1 and not($tag == 1))
{
	if ($syst eq 'win')
	{
   my $vector = 'perl cut_vector_brut.pl '.$syst.' '.$outfolder.' '.$outfolder.' "'.$blast_path.'\" '.$Evector.' '.$adapter_file.' \.fas';
	print "\n$vector\n";
   system $vector;
	}
	elsif ($syst eq 'linux')
	{
   my $vector = 'perl cut_vector_brut.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$blast_path.' '.$Evector.' '.$adapter_file.' \.fas';
	print "\n$vector\n";
   system $vector;
	}
   my $length = 'perl sort_length.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$length_limit.' \.wov';
	print "\n$length\n";
   system $length;
}
elsif(not($adapter == 1) and $tag == 1)
{
	if ($syst eq 'win')
	{
	my $sort_tag = 'perl sort_tag_beg_orig.pl '.$syst.' '.$outfolder.' '.$outfolder.' "'.$blast_path.'\" '.$e_tag.' '.$word_size.' '.$tag_file;
	print "\n$sort_tag\n";
   system $sort_tag;
	}
	elsif ($syst eq 'linux')
	{
	my $sort_tag = 'perl sort_tag_beg_orig.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$blast_path.' '.$e_tag.' '.$word_size.' '.$tag_file;
	print "\n$sort_tag\n";
   system $sort_tag;
	}

   my $length = 'perl sort_length.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$length_limit.' \.tag';
	print "\n$length\n";
   system $length;
}
else
{
   my $length = 'perl sort_length.pl '.$syst.' '.$outfolder.' '.$outfolder.' '.$length_limit.' \.fas';
	print "\n$length\n";
   system $length;
}

   my $find_ms1 = 'perl find_and_mask_ms.pl '.$min1.' '.$min2.' '.$min3.' '.$min4.' '.$min5.' '.$min6.' 1 0 '.$outfolder.' '.$outfolder.' bp\.fas';
	print "\n$find_ms1\n";
   system $find_ms1;


#rename and replace outfile for pipe2 input
unless ( opendir(FOLDER, $outfolder) )
{
      print "Cannot access to folder $folder\n";
      exit;
}
@filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
foreach my $file (@filenames)
{
	my $m = $length_limit.'bp_mask';
	if ($file =~ /$m/)
	{
		my $new_file = $file;
		$new_file =~ s/$m/pipe2/;
		if ($syst eq 'win')
		{
			my $rename = 'rename '.$outfolder.'\\'.$file.' '.$new_file; 
			system $rename;
			$copy = 'copy '.$outfolder.'\\'.$new_file.' '.$folder.'\\data2\\';
#			print "$copy";
			system $copy; 
			delete_files_motif_win($outfolder, $new_file);

		}
		elsif ($syst eq 'linux')
		{
			my $rename = 'mv '.$outfolder.'/'.$file.' '.$folder.'/data2/'.$new_file; 
			system $rename;
#			delete_files_motif($outfolder, $file);
		}

	}
}

#delete original file from temp folder

my $file_orig = $tempfolder.'.fas';
delete_win_linux($file_orig, $outfolder, $syst);

#read all file in the outfolder and deletes then is unnecessary
unless ( opendir(FOLDER, $outfolder) )
{
      print "Cannot access to folder $folder\n";
      exit;
}
my @filenames_del = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
foreach my $file (@filenames_del)
{
    if ($del_files == 1)
    {
	if ($file =~ /\.tag/ or $file=~ /bp\.fas/ or $file=~ /bellow.*\.fas/)
	{
	    delete_win_linux($file, $outfolder, $syst);
	}
    }
}


# end foreach @fas
}

##################
##################
##################
# copy output folders back into the original folder and delete c:\QDD_tetetemp
if ($syst eq 'win')
{
# check if no folder exist with the same name as the files to be analised (WO extesion)
	unless ( opendir(FOLDER, $orig_folder) )
	{
   	   print "Cannot access to folder $orig_folder\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);

check_and_rename_folder(\@fas, \@files, $orig_folder, $syst);

my @data2 = ('data2');
check_and_rename_folder(\@data2, \@files, $orig_folder, $syst);

	unless ( opendir(FOLDER, $folder) )
	{
   	   print "Cannot access to folder $folder\n";
  	    exit;
	}
	@files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);
	foreach my $file (@files)
	{
		if (not($file =~ /\./))
		{
			$make_folder = 'md "'.$orig_folder.'\\'.$file.'"';
			system $make_folder;

			$copy = 'xcopy /s /q "c:\QDD_tetetemp\\'.$file.'" "'.$orig_folder.'\\'.$file.'\\"';
			system $copy; 	
		}
	}
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');
}
##################
##################
##################


print "Analysis is finished";

if ($direct_par == 2)
{
	close(STDOUT);
	close(STDERR);
	open(STDOUT, ">&OLDOUT");
	open(STDERR, ">&OLDERR");
}

exit;

###################################

sub param_input
{
    my ($set_file, $del_files,$blast_path,$folder,$length_limit,$min1,$min2,$min3,$min4,$min5,$min6,$e_tag,$word_size,$Evector,$tag,$adapter,$syst) = @_;


	open(SET, $set_file);
	my @setings = <SET>;

	if (scalar @setings == 0)
	{
		close SET;
		open_file_out($set_file, 'SET');
		open_file_in('set_pipe1_linux_backup.txt', 'SETL');
		my @par_backup = <SETL>;
		close SETL;
		foreach my $par (@par_backup)
		{
			print SET "$par";
		}
		close SET;
		open_file_in($set_file, 'SET');
		@setings = <SET>;
	}

	$$del_files = $setings[0];
	chomp $$del_files;
	$$blast_path = $setings[1];
	chomp $$blast_path;
	$$folder = $setings[2];
	chomp $$folder;
	$$length_limit = $setings[3];
	chomp $$length_limit;
	$$min1 = $setings[4];
	chomp $$min1;
	$$min2 = $setings[5];
	chomp $$min2;
	$$min3 = $setings[6];
	chomp $$min3;
	$$min4 = $setings[7];
	chomp $$min4;
	$$min5 = $setings[8];
	chomp $$min5;
	$$min6 = $setings[9];
	chomp $$min6;
	$$e_tag = $setings[10];
	chomp $$e_tag;
	$$word_size = $setings[11]; 
	chomp $$word_size;
	$$Evector = $setings[12];
	chomp $$Evector;
	$$tag = $setings[13];
	chomp $$tag;
	$$adapter = $setings[14];
	chomp $$adapter;
	$$syst = $setings[15];
	chomp $$syst;

	close SET;

	my $reply = '';

    print "\n0: Operating system (win/linux): $$syst\n";    
    print "1: Input folder: $$folder\n";  
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Sort sequences by tag (YES=1/NO=0): $$tag\n";
    print "4: Remeove adapter (YES=1/NO=0): $$adapter\n";
    print "5: Minimum sequence length: $$length_limit\n";
    print "6: Minimum number of monobase repetitions in MS search: $$min1\n";
    print "7: Minimum number of dibase repetitions in MS search: $$min2\n";
    print "8: Minimum number of tribase repetitions in MS search: $$min3\n";
    print "9: Minimum number of tetrabase repetitions in MS search: $$min4\n";
    print "10: Minimum number of pentabase repetitions in MS search: $$min5\n";
    print "11: Minimum number of hexabase repetitions in MS search: $$min6\n";
    print "12: Pathway to BLAST: $$blast_path\n\n";

    print "Press enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";

    $reply = <STDIN>;

while ( not ($reply eq "\n"))
{
	open_file_out($set_file, 'SETOUT');


    if ($reply eq "\n")
    {
	print SETOUT "$$del_files\n$$blast_path\n$$folder\n$$length_limit\n";
	print SETOUT "$$min1\n$$min2\n$$min3\n$$min4\n$$min5\n$$min6\n";
	print SETOUT "$$e_tag\n$$word_size\n$$Evector\n$$tag\n$$adapter\n$$syst\n";
	next;
    }

    else
    {
	chomp $reply;

	if ($reply == 2 )
	{
	    print "Do you wish to delete intermedite files? (YES=1/NO=0)\n";
	    $$del_files = <STDIN>;
	    chomp $$del_files;
	}
	elsif ($reply == 12 )
	{
	    print "Enter the path to BLAST executables\n";
	    $$blast_path = <STDIN>;
	    chomp $$blast_path;
	}
	elsif ($reply == 1 )
	{
	    print "Enter the name of the input folder\n";
	    $$folder= <STDIN>;
	    chomp $$folder;
	}
	elsif ($reply == 5 )
	{
	    print "Enter the minimum length of the sequneces to be selected for further analyses (in bp)\n";
	    $$length_limit= <STDIN>;
	    chomp $$length_limit;
	}
	elsif ($reply == 6 )
	{
	    print "Enter the minimum number of mono-base repetitions in MS search\n";
	    $$min1= <STDIN>;
	    chomp $$min1;
	}
	elsif ($reply == 7 )
	{
	    print "Enter the minimum number of di-base repetitions in MS search\n";
	    $$min2= <STDIN>;
	    chomp $$min2;
	}
	elsif ($reply == 8 )
	{
	    print "Enter the minimum number of tri-base repetitions in MS search\n";
	    $$min3= <STDIN>;
	    chomp $$min3;
	}
	elsif ($reply == 9 )
	{
	    print "Enter the minimum number of tetra-base repetitions in MS search\n";
	    $$min4= <STDIN>;
	    chomp $$min4;
	}
	if ($reply == 10 )
	{
	    print "Enter the minimum number of penta-base repetitions in MS search\n";
	    $$min5= <STDIN>;
	    chomp $$min5;
	}
	elsif ($reply == 11 )
	{
	    print "Enter the minimum number of hexa-base repetitions in MS search\n";
	    $$min6= <STDIN>;
	    chomp $$min6;
	}

	elsif ($reply == 3 )
	{
	    print "Do you wish to sort sequences by tag? (YES=1/NO=0)\n";
	    $$tag= <STDIN>;
	    chomp $$tag;
	}
#	elsif ($reply == 4 )
#	{
#	    print "Do you wish to remove adapters/vectors? (YES=1/NO=0; We strongly advise to set it to 1; If sequences are sorted by tag, you cannot set this option to 0!)\n";
#	    $$adapter= <STDIN>;
#	    chomp $$adapter;
#		if ($$tag ==1)
#		{
#			$$adapter = 1;
#		}
#
#	}
	elsif ($reply == 4 )
	{
	    print "Do you wish to remove adapters/vectors? (YES=1/NO=0)\n";
	    $$adapter= <STDIN>;
	    chomp $$adapter;
	}

	elsif ($reply == 0 )
	{
	    print "Enter your operating system (win/linux)\n";
	    $$syst = <STDIN>;
	    chomp $$syst;
	}
	print SETOUT "$$del_files\n$$blast_path\n$$folder\n$$length_limit\n";
	print SETOUT "$$min1\n$$min2\n$$min3\n$$min4\n$$min5\n$$min6\n";
	print SETOUT "$$e_tag\n$$word_size\n$$Evector\n$$tag\n$$adapter\n$$syst\n";

    print "\n0: Operating system (win/linux): $$syst\n";    
    print "1: Input folder: $$folder\n";  
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Sort sequences by tag (YES=1/NO=0): $$tag\n";
    print "4: Remeove adapter (YES=1/NO=0): $$adapter\n";
    print "5: Minimum sequence length: $$length_limit\n";
    print "6: Minimum number of monobase repetitions in MS search: $$min1\n";
    print "7: Minimum number of dibase repetitions in MS search: $$min2\n";
    print "8: Minimum number of tribase repetitions in MS search: $$min3\n";
    print "9: Minimum number of tetrabase repetitions in MS search: $$min4\n";
    print "10: Minimum number of pentabase repetitions in MS search: $$min5\n";
    print "11: Minimum number of hexabase repetitions in MS search: $$min6\n";
    print "12: Pathway to BLAST: $$blast_path\n\n";

    print "Press enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";
	$reply = <STDIN>;

    }

    close SETOUT;
# end while ( not ($reply eq "\n"))
}
# end sub
}
