#!/usr/bin/perl -w


  use warnings;
  use strict;
  use subprogramEM;

# if $direct_par = 1 all parameters except input folder are defined in the program; 
# if $direct_par = 0 set_file is read and the user is asked if the settings are correct and can change them
# parameters non_visibles (data2 is produced by pipe1.pl)
# if $direct_par = 2 the set_file is read and the user cannot change the parameters (option for running behind a windows interface)

my $direct_par = 0;
my $set_file = 'set_pipe3.txt';
my $trans_file = 'motifs_transmot_hach1_6.txt';

# parameters that can be read from the set_pipe3.txt file
my $del_files = 0;
my $flank_min = 0;
my $ampl_min = 0;
my $mono_max = 0;
my $non_mono_max = 0;
my $min_mot_l = 0;
my $max_mot_l = 0;
my $min_rep = 0;
my $primer3_path = '';
my $pcr_min = '';
my $pcr_max = '';
my $pcr_step = ''; 
my $min1s = 0;
my $min2s = 0;
my $min3s = 0;
my $min4s = 0;
my $min5s = 0;
my $min6s = 0;
my $syst = '';
my $folder = '';
my $select_pool = '';
my $PRIMER_GC_CLAMP = '';
my $PRIMER_OPT_SIZE = '';
my $PRIMER_MIN_SIZE = '';
my $PRIMER_MAX_SIZE = '';
my $PRIMER_OPT_TM = '';
my $PRIMER_MIN_TM = '';
my $PRIMER_MAX_TM = '';
my $PRIMER_MAX_DIFF_TM = '';
my $PRIMER_MIN_GC = '';
my $PRIMER_OPT_GC_PERCENT = '';
my $PRIMER_MAX_GC = '';
my $PRIMER_SELF_ANY = '';
my $PRIMER_SELF_END = '';
my $PRIMER_MAX_POLY_X = '';
my $PRIMER_NUM_RETURN = '';


if ($direct_par == 1)
{
	$del_files = 1;
	$flank_min = 30;
	$ampl_min = 100;
	$mono_max = 4;
	$non_mono_max = 2;
	$min_mot_l = 2;
	$max_mot_l = 6;
	$min_rep = 5;
	$primer3_path = 'c:/primer3-1.1.4/bin/';
#	$primer3_path = '/usr/bin/';
	$pcr_min = 80;
	$pcr_max = 320;
	$pcr_step = 30;
	$min1s = 4;
	$min2s = 2;
	$min3s = 2;
	$min4s = 2;
	$min5s = 2;
	$min6s = 2;
	$syst = 'win';
	$folder = 'sample';
	$select_pool = 1;
	$PRIMER_GC_CLAMP = 0;
	$PRIMER_OPT_SIZE = 20;
	$PRIMER_MIN_SIZE = 18;
	$PRIMER_MAX_SIZE = 27;
	$PRIMER_OPT_TM = 60.0;
	$PRIMER_MIN_TM = 57.0;
	$PRIMER_MAX_TM = 63.0;
	$PRIMER_MAX_DIFF_TM = 100.0;
	$PRIMER_MIN_GC = 20.0;
	$PRIMER_OPT_GC_PERCENT = 50.0;
	$PRIMER_MAX_GC = 80.0;
	$PRIMER_SELF_ANY = 8.00;
	$PRIMER_SELF_END = 3.00;
	$PRIMER_MAX_POLY_X = 5;
	$PRIMER_NUM_RETURN = 2;

}
elsif ($direct_par == 0)
{
print "**********************************************************\n";
print "QDD version1.2 22 February 2010\n";
print "Emese Meglecz, Aix-Marseille University, Marseille, France\n";
print 'emese.meglecz@univ-provence.fr';
print "\n";
print "Plesae, read the Documentation_QDD.pdf\n";
print "**********************************************************\n";

param_input($set_file,\$del_files,\$flank_min,\$ampl_min,\$mono_max,\$non_mono_max,\$min_mot_l,\$max_mot_l,\$min_rep,\$primer3_path,\$pcr_min,\$pcr_max,\$pcr_step,\$min1s,\$min2s,\$min3s,\$min4s,\$min5s,\$min6s,\$syst,\$folder,\$select_pool,\$PRIMER_GC_CLAMP,\$PRIMER_OPT_SIZE,\$PRIMER_MIN_SIZE,\$PRIMER_MAX_SIZE,\$PRIMER_OPT_TM,\$PRIMER_MIN_TM,\$PRIMER_MAX_TM,\$PRIMER_MAX_DIFF_TM,\$PRIMER_MIN_GC,\$PRIMER_OPT_GC_PERCENT,\$PRIMER_MAX_GC,\$PRIMER_SELF_ANY,\$PRIMER_SELF_END,\$PRIMER_MAX_POLY_X,\$PRIMER_NUM_RETURN);
}
else
{
    open(SET, $set_file);
	my @setings = <SET>;

	$del_files = $setings[0];
	chomp $del_files;
	$flank_min = $setings[1];
	chomp $flank_min;
	$ampl_min = $setings[2];
	chomp $ampl_min;
	$mono_max = $setings[3];
	chomp $mono_max;
	$non_mono_max = $setings[4];
	chomp $non_mono_max;
	$min_mot_l = $setings[5];
	chomp $min_mot_l;
	$max_mot_l = $setings[6];
	chomp $max_mot_l;
	$min_rep = $setings[7];
	chomp $min_rep;
	$primer3_path = $setings[8];
	chomp $primer3_path;
	$pcr_min = $setings[9];
	chomp $pcr_min;
	$pcr_max = $setings[10];
	chomp $pcr_max;
	$pcr_step = $setings[11];
	chomp $pcr_step;
	$min1s = $setings[12];
	chomp $min1s;
	$min2s = $setings[13];
	chomp $min2s;
	$min3s = $setings[14];
	chomp $min3s;
	$min4s = $setings[15];
	chomp $min4s;
	$min5s = $setings[16];
	chomp $min5s;
	$min6s = $setings[17];
	chomp $min6s;
	$syst = $setings[18];
	chomp $syst;
	$folder = $setings[19];
	chomp $folder;
	$select_pool = $setings[20];
	chomp $select_pool;
	$PRIMER_GC_CLAMP = $setings[21];
	chomp $PRIMER_GC_CLAMP;
	$PRIMER_OPT_SIZE = $setings[22];
	chomp $PRIMER_OPT_SIZE;
	$PRIMER_MIN_SIZE = $setings[23];
	chomp $PRIMER_MIN_SIZE;
	$PRIMER_MAX_SIZE = $setings[24];
	chomp $PRIMER_MAX_SIZE;
	$PRIMER_OPT_TM = $setings[25];
	chomp $PRIMER_OPT_TM;
	$PRIMER_MIN_TM = $setings[26];
	chomp $PRIMER_MIN_TM;
	$PRIMER_MAX_TM =$setings[27];
	chomp $PRIMER_MAX_TM;
	$PRIMER_MAX_DIFF_TM = $setings[28];
	chomp $PRIMER_MAX_DIFF_TM;
	$PRIMER_MIN_GC = $setings[29];
	chomp $PRIMER_MIN_GC;
	$PRIMER_OPT_GC_PERCENT = $setings[30];
	chomp $PRIMER_OPT_GC_PERCENT;
	$PRIMER_MAX_GC = $setings[31];
	chomp $PRIMER_MAX_GC;
	$PRIMER_SELF_ANY = $setings[32];
	chomp $PRIMER_SELF_ANY;
	$PRIMER_SELF_END = $setings[33];
	chomp $PRIMER_SELF_END;
	$PRIMER_MAX_POLY_X = $setings[34];
	chomp $PRIMER_MAX_POLY_X ;
	$PRIMER_NUM_RETURN = $setings[35];
	chomp $PRIMER_NUM_RETURN ;

	close SET;
	
	open(OLDOUT, ">&STDOUT");
  open(OLDERR, ">&STDERR");
	open(STDOUT, "> logfile.log") or die "Can't open STDOUT to logfile $!\n";
	open(STDERR, ">> errors.log") or die "Can't open STDERR to logfile $!\n";
}

if ($mono_max > $min_rep)
{
	$mono_max = $min_rep;
}
if ($non_mono_max > $min_rep)
{
	$non_mono_max = $min_rep;
}

check_path(\$primer3_path, $syst);


print "del_files = $del_files\nflank_rep = $flank_min\nampl_min = $ampl_min\nmono_max = $mono_max\nnon_mono_max = $non_mono_max\n";
print "min_mot_l = $min_mot_l\nmax_mot_l = $max_mot_l\nmin_rep = $min_rep\nprimer3_path = $primer3_path\n";
print "pcr_min = $pcr_min\npcr_max = $pcr_max\npcr_step = $pcr_step\n";
print "min1s = $min1s\nmin2s = $min2s\nmin3s = $min3s\nmin4s = $min4s\nmin5s = $min5s\nmin6s = $min6s\nsystem = $syst\nfolder = $folder\n";
print "select_pool = $select_pool\n";
print "PRIMER_GC_CLAMP = $PRIMER_GC_CLAMP\nPRIMER_OPT_SIZE = $PRIMER_OPT_SIZE\nPRIMER_MIN_SIZE = $PRIMER_MIN_SIZE\,PRIMER_MAX_SIZE = $PRIMER_MAX_SIZE\n";
print "PRIMER_OPT_TM = $PRIMER_OPT_TM\nPRIMER_MIN_TM = $PRIMER_MIN_TM\nPRIMER_MAX_TM = $PRIMER_MAX_TM\n";
print "PRIMER_MAX_DIFF_TM = $PRIMER_MAX_DIFF_TM\nPRIMER_MIN_GC = $PRIMER_MIN_GC\nPRIMER_OPT_GC_PERCENT = $PRIMER_OPT_GC_PERCENT\nPRIMER_MAX_GC = $PRIMER_MAX_GC\n";
print "PRIMER_SELF_ANY = $PRIMER_SELF_ANY\nPRIMER_SELF_END = $PRIMER_SELF_END\nPRIMER_MAX_POLY_X = $PRIMER_MAX_POLY_X\nPRIMER_NUM_RETURN = $PRIMER_NUM_RETURN\n";


##################
##################
##################
# to make windows fans happy to be able to use file names with spaces in it
# copy input files into c:\QDD_tetetemp
my $make_folder = '';
my $copy = '';
my $orig_folder = $folder;
if ($syst eq 'win')
{
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');

	$make_folder = 'md c:\QDD_tetetemp\data3';
	system $make_folder;

	my $data3 = $orig_folder.'\\data3';
	unless ( opendir(FOLDER, $data3) )
	{
   	   print "Cannot access to folder $data3\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);


	foreach my $file (@files)
	{
		my $orig_file = $file;
		$file =~ s/\s/_/g;
		my $rename = 'ren "'.$folder.'\\data3\\'.$orig_file.'" '.$file;
		system $rename;
		$copy = 'copy "'.$folder.'\\data3\\'.$file.'" c:\QDD_tetetemp\\data3\\';
		system $copy; 	
	}

	$folder = 'c:\QDD_tetetemp';
	
}
##################
##################
##################


my $folder_data3 = '';
if ($syst eq 'win')
{
    $folder_data3 = $folder.'\\data3';
}
elsif ($syst eq 'linux')
{
    $folder_data3 = $folder.'/data3';
}

unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @folder_files = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

unless ( opendir(FOLDER, $folder_data3) )
{
      print "Cannot access to folder $folder_data3\n";
      exit;
}
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

# check if no folder exist with the smae name as the files to be analised (WO extesion)
check_and_rename_folder(\@filenames, \@folder_files, $folder, $syst);

my $make_folder = '';
my $set_numbers = $flank_min.$ampl_min.$min_rep;
foreach my $file (sort @filenames)
{
	print "********** $file **********\n";

	$file =~ /.+?\./;
	my $tempfolder = $&;
	my $outfolder = '';
	$tempfolder =~ s/\.//;
	my $copy = '';
	if ($syst eq 'win')
	{
	    $outfolder = $folder.'\\'.$tempfolder;
		$make_folder = 'md '.$outfolder;
		system $make_folder;
		$copy = 'copy '.$folder_data3.'\\'.$file.' '.$outfolder.'\\';
		system $copy; 
	}
	elsif ($syst eq 'linux')
	{
	    $outfolder = $folder.'/'.$tempfolder;
		$make_folder = 'mkdir '.$outfolder;
		system $make_folder;
		$copy = 'cp '.$folder_data3.'/'.$file.' '.$outfolder.'/';
		system $copy; 
	}

  my $find_ms3 = 'perl find_and_mask_ms.pl '.$min1s.' '.$min2s.' '.$min3s.' '.$min4s.' '.$min5s.' '.$min6s.' 1 0 '.$outfolder.' '.$outfolder.' .fas';
	print "\n$find_ms3\n";
  system $find_ms3;

   my $select_best = 'perl select_best_ms_info_in_def_line2.pl '.$outfolder.' '.$outfolder.' '.$flank_min.' '.$ampl_min.' '.$mono_max.' '.$non_mono_max.' '.$min_mot_l.' '.$max_mot_l.' '.$min_rep.' \.seq';
	print "\n$select_best\n";
  system $select_best;

  my $primer3 = 'perl primer3_input_lc.pl '.$outfolder.' '.$outfolder.' '.$min_rep.' '.$ampl_min.' '.$flank_min.' _select'.$set_numbers.'\.fas';
	print "\n$primer3\n";
  system $primer3;

my $primer = $folder.'/primer_number.txt';
#   my $primer3_tbl = 'perl read_primer3_results.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' '.$primer3_path.' '.$set_numbers.'_primer3.txt '.$syst.' >>'.$primer;
#   my $primer3_tbl = 'perl read_primer3_results.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' '.$primer3_path.' '.$set_numbers.'_primer3.txt '.$syst;
	
my $primer3_tbl = '';
	if ($syst eq 'win')
	{
   $primer3_tbl = 'perl read_primer3_results_param.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' "'.$primer3_path.'\" '.$set_numbers.'_primer3.txt '.$syst.' '.$PRIMER_GC_CLAMP.' '.$PRIMER_OPT_SIZE.' '.$PRIMER_MIN_SIZE.' '.$PRIMER_MAX_SIZE.' '.$PRIMER_OPT_TM.' '.$PRIMER_MIN_TM.' '.$PRIMER_MAX_TM.' '.$PRIMER_MAX_DIFF_TM.' '.$PRIMER_MIN_GC.' '.$PRIMER_OPT_GC_PERCENT.' '.$PRIMER_MAX_GC.' '.$PRIMER_SELF_ANY.' '.$PRIMER_SELF_END.' '.$PRIMER_MAX_POLY_X.' '.$PRIMER_NUM_RETURN;
	}
	elsif ($syst eq 'linux')
	{
   $primer3_tbl = 'perl read_primer3_results_param.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' '.$primer3_path.' '.$set_numbers.'_primer3.txt '.$syst.' '.$PRIMER_GC_CLAMP.' '.$PRIMER_OPT_SIZE.' '.$PRIMER_MIN_SIZE.' '.$PRIMER_MAX_SIZE.' '.$PRIMER_OPT_TM.' '.$PRIMER_MIN_TM.' '.$PRIMER_MAX_TM.' '.$PRIMER_MAX_DIFF_TM.' '.$PRIMER_MIN_GC.' '.$PRIMER_OPT_GC_PERCENT.' '.$PRIMER_MAX_GC.' '.$PRIMER_SELF_ANY.' '.$PRIMER_SELF_END.' '.$PRIMER_MAX_POLY_X.' '.$PRIMER_NUM_RETURN;
	}

	print "\n$primer3_tbl\n";
   system $primer3_tbl;

if ($select_pool == 1)
{
	my $pool_ms = 'perl pool_int_comp_ms_nuisible.pl '.$outfolder.' '.$outfolder.' 2 _pipe3\.seq '.$mono_max.' '.$non_mono_max;
	print "\n$pool_ms\n";
  system $pool_ms;

	my $select_best_pool = 'perl select_best_pooled_ms.pl '.$outfolder.' '.$outfolder.' '.$flank_min.' '.$ampl_min.' '.$mono_max.' '.$non_mono_max.' '.$min_rep.' _compound\.seq';
	print "\n$select_best_pool\n";
  system $select_best_pool;

  my $primer3_pool = 'perl primer3_input_lc.pl '.$outfolder.' '.$outfolder.' '.$min_rep.' '.$ampl_min.' '.$flank_min.' _compound_select'.$set_numbers.'\.fas';
	print "\n$primer3_pool\n";
  system $primer3_pool;

#   $primer3_tbl = 'perl read_primer3_results.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' '.$primer3_path.' _pooled_select'.$set_numbers.'_primer3.txt '.$syst;
  
	if ($syst eq 'linux')
	{
	$primer3_tbl = 'perl read_primer3_results_param.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' '.$primer3_path.' _compound_select'.$set_numbers.'_primer3.txt '.$syst.' '.$PRIMER_GC_CLAMP.' '.$PRIMER_OPT_SIZE.' '.$PRIMER_MIN_SIZE.' '.$PRIMER_MAX_SIZE.' '.$PRIMER_OPT_TM.' '.$PRIMER_MIN_TM.' '.$PRIMER_MAX_TM.' '.$PRIMER_MAX_DIFF_TM.' '.$PRIMER_MIN_GC.' '.$PRIMER_OPT_GC_PERCENT.' '.$PRIMER_MAX_GC.' '.$PRIMER_SELF_ANY.' '.$PRIMER_SELF_END.' '.$PRIMER_MAX_POLY_X.' '.$PRIMER_NUM_RETURN;
	print "\n$primer3_tbl\n";
   system $primer3_tbl;
	}
	elsif ($syst eq 'win')
	{
	$primer3_tbl = 'perl read_primer3_results_param.pl '.$outfolder.' '.$outfolder.' '.$pcr_min.' '.$pcr_max.' '.$pcr_step.' "'.$primer3_path.'\" _compound_select'.$set_numbers.'_primer3.txt '.$syst.' '.$PRIMER_GC_CLAMP.' '.$PRIMER_OPT_SIZE.' '.$PRIMER_MIN_SIZE.' '.$PRIMER_MAX_SIZE.' '.$PRIMER_OPT_TM.' '.$PRIMER_MIN_TM.' '.$PRIMER_MAX_TM.' '.$PRIMER_MAX_DIFF_TM.' '.$PRIMER_MIN_GC.' '.$PRIMER_OPT_GC_PERCENT.' '.$PRIMER_MAX_GC.' '.$PRIMER_SELF_ANY.' '.$PRIMER_SELF_END.' '.$PRIMER_MAX_POLY_X.' '.$PRIMER_NUM_RETURN;
	print "\n$primer3_tbl\n";
   system $primer3_tbl;
	}

}

unless ( opendir(FOLDER, $outfolder) )
  {
      print "Cannot access to folder $outfolder\n";
      exit;
  }
my @out = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

#print "@out\n";

foreach my $out (@out)
{
	if ($out =~ /[0-9]+_primers\.tbl/)
	{
		
		my $mot = $&;
		my $mot1 = $mot;
		$mot1 =~ s/_primers\.tbl/\.fas/;
		$mot1 = 'select'.$mot1;
		my $fas = $out;
		$fas =~ s/$mot/$mot1/;
		my $pretty = '';
		my $folder_html = 'html_perfect';
		if ($out =~ /compound/)
		{
			$folder_html = 'html_compound';
		}
		if ($syst eq 'win')
		{
			$pretty = 'perl pretty.pl '.$outfolder.'\\'.$out.' '.$outfolder.'\\'.$fas.' '.$outfolder.'\\'.$folder_html;
#			print "\n$pretty\n";
			system $pretty; 
		}
		elsif ($syst eq 'linux')
		{
			$pretty = 'perl pretty.pl '.$outfolder.'/'.$out.' '.$outfolder.'/'.$fas.' '.$outfolder.'/'.$folder_html;
#			print "\n$pretty\n";
			system $pretty; 
		}

	}
}


#read all file in the outfolder and deletes then if unnecessary
unless ( opendir(FOLDER, $outfolder) )
{
      print "Cannot access to folder $folder\n";
      exit;
}
my @filenames_del = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);
my $file_orig = $tempfolder.'.fas';
foreach my $file (@filenames_del)
{
    if ($file eq $file_orig )
    {
	delete_win_linux($file, $outfolder, $syst);
    }
    elsif ($del_files == 1)
    {
	if ($file =~ /_mask\.fas/ or $file =~ /\.seq/ or $file =~ /_output\.txt/ or $file =~ /_temp\.txt/)
	{
	    delete_win_linux($file, $outfolder, $syst);
	}
    }
}


# end foreach @fas
}

##################
##################
##################
# copy output folders back into the original folder and delete c:\QDD_tetetemp
if ($syst eq 'win')
{
	check_and_delete_folder('c:\QDD_tetetemp\data3');

# check if no folder exists with the same name as the files to be analised (WO extesion)
	unless ( opendir(FOLDER, $orig_folder) )
	{
   	   print "Cannot access to folder $orig_folder\n";
  	    exit;
	}
	my @files = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);

	unless ( opendir(FOLDER, 'c:\QDD_tetetemp') )
	{
   	   print "Cannot access to folder c:\\QDD_tetetemp\n";
  	    exit;
	}
	my @folders_to_move = grep ( !/^\.\.?$/, readdir(FOLDER) );
	closedir(FOLDER);


check_and_rename_folder(\@folders_to_move, \@files, $orig_folder, $syst);

	$copy = 'xcopy "c:\QDD_tetetemp" "'.$orig_folder.'" /E /C /I /Y /Q';
	system $copy; 	
#DO NOT FIDDLE WITH THIS LINE!!!!! IT DELETES A FOLDER WITHOUT ASKING FOR COMFIRMATION
	check_and_delete_folder('c:\QDD_tetetemp');
}
##################
##################
##################


print "Analysis is finished";

if ($direct_par == 2)
{
	close(STDOUT);
	close(STDERR);
	open(STDOUT, ">&OLDOUT");
	open(STDERR, ">&OLDERR");
}

exit;

###################################

sub param_input
{
    my ($set_file,$del_files,$flank_min,$ampl_min,$mono_max,$non_mono_max,$min_mot_l,$max_mot_l,$min_rep,$primer3_path,$pcr_min,$pcr_max,$pcr_step,$min1s,$min2s,$min3s,$min4s,$min5s,$min6s,$syst,$folder,$select_pool,$PRIMER_GC_CLAMP,$PRIMER_OPT_SIZE,$PRIMER_MIN_SIZE,$PRIMER_MAX_SIZE,$PRIMER_OPT_TM,$PRIMER_MIN_TM,$PRIMER_MAX_TM,$PRIMER_MAX_DIFF_TM,$PRIMER_MIN_GC,$PRIMER_OPT_GC_PERCENT,$PRIMER_MAX_GC,$PRIMER_SELF_ANY,$PRIMER_SELF_END,$PRIMER_MAX_POLY_X,$PRIMER_NUM_RETURN) = @_;

	open(SET, $set_file);
	my @setings = <SET>;
	if (scalar @setings == 0)
	{
		close SET;
		open_file_out($set_file, 'SET');
		open_file_in('set_pipe3_linux_backup.txt', 'SETL');
		my @par_backup = <SETL>;
		close SETL;
		foreach my $par (@par_backup)
		{
			print SET "$par";
		}
		close SET;
		open_file_in($set_file, 'SET');
		@setings = <SET>;
	}

	$$del_files = $setings[0];
	chomp $$del_files;
	$$flank_min = $setings[1];
	chomp $$flank_min;
	$$ampl_min = $setings[2];
	chomp $$ampl_min;
	$$mono_max = $setings[3];
	chomp $$mono_max;
	$$non_mono_max = $setings[4];
	chomp $$non_mono_max;
	$$min_mot_l = $setings[5];
	chomp $$min_mot_l;
	$$max_mot_l = $setings[6];
	chomp $$max_mot_l;
	$$min_rep = $setings[7];
	chomp $$min_rep;
	$$primer3_path = $setings[8];
	chomp $$primer3_path;
	$$pcr_min = $setings[9];
	chomp $$pcr_min;
	$$pcr_max = $setings[10];
	chomp $$pcr_max;
	$$pcr_step = $setings[11];
	chomp $$pcr_step;
	$$min1s = $setings[12];
	chomp $$min1s;
	$$min2s = $setings[13];
	chomp $$min2s;
	$$min3s = $setings[14];
	chomp $$min3s;
	$$min4s = $setings[15];
	chomp $$min4s;
	$$min5s = $setings[16];
	chomp $$min5s;
	$$min6s = $setings[17];
	chomp $$min6s;
	$$syst = $setings[18];
	chomp $$syst;
	$$folder = $setings[19];
	chomp $$folder;
	$$select_pool = $setings[20];
	chomp $$select_pool;
	$$PRIMER_GC_CLAMP = $setings[21];
	chomp $$PRIMER_GC_CLAMP;
	$$PRIMER_OPT_SIZE = $setings[22];
	chomp $$PRIMER_OPT_SIZE;
	$$PRIMER_MIN_SIZE = $setings[23];
	chomp $$PRIMER_MIN_SIZE;
	$$PRIMER_MAX_SIZE = $setings[24];
	chomp $$PRIMER_MAX_SIZE;
	$$PRIMER_OPT_TM = $setings[25];
	chomp $$PRIMER_OPT_TM;
	$$PRIMER_MIN_TM = $setings[26];
	chomp $$PRIMER_MIN_TM;
	$$PRIMER_MAX_TM =$setings[27];
	chomp $$PRIMER_MAX_TM;
	$$PRIMER_MAX_DIFF_TM = $setings[28];
	chomp $$PRIMER_MAX_DIFF_TM;
	$$PRIMER_MIN_GC = $setings[29];
	chomp $$PRIMER_MIN_GC;
	$$PRIMER_OPT_GC_PERCENT = $setings[30];
	chomp $$PRIMER_OPT_GC_PERCENT;
	$$PRIMER_MAX_GC = $setings[31];
	chomp $$PRIMER_MAX_GC;
	$$PRIMER_SELF_ANY = $setings[32];
	chomp $$PRIMER_SELF_ANY;
	$$PRIMER_SELF_END = $setings[33];
	chomp $$PRIMER_SELF_END;
	$$PRIMER_MAX_POLY_X = $setings[34];
	chomp $$PRIMER_MAX_POLY_X ;
	$$PRIMER_NUM_RETURN = $setings[35];
	chomp $$PRIMER_NUM_RETURN ;

	close SET;


	my $reply = '';

    print "\n0: Operating system (win/linux): $$syst\n";
    print "1: Input folder: $$folder\n";
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Minimum length of flanking region : $$flank_min\n";
    print "4: Minimum length of PCR product (in sequence selection step) : $$ampl_min\n";
    print "5: Maximum number of monobase repeats in flanking region : $$mono_max\n";
    print "6: Maximum number of di-hexabase repeats in flanking region : $$non_mono_max\n";
    print "7: Select microsatellites for primer design if the motif length is at least : $$min_mot_l\n";
    print "8: Select microsatellites for primer design if the motif length is at most : $$max_mot_l\n";
    print "9: Select microsatellites for primer design if the number of repeats is at least : $$min_rep\n";
    print "10: Select interrupted and compound microsatellites (YES=1/NO=0): $$select_pool\n";	
	print "\nPRIMER3 parameters\n";
    print "11: Pathway to Primer3 : $$primer3_path\n"; 
    print "12: Minimum length of PCR product for primer design: $$pcr_min\n";
    print "13: Maximum length of PCR product for primer design: $$pcr_max\n";
    print "14: Interval of length of PCR product for primer design: $$pcr_step\n";
	print "15: Number of consecutive Gs and Cs at the 3'of primer (PRIMER_GC_CLAMP): $$PRIMER_GC_CLAMP\n";
	print "16: Optimum length of a primer (PRIMER_OPT_SIZE ): $$PRIMER_OPT_SIZE\n";
	print "17: Minimum length of a primer (PRIMER_MIN_SIZE): $$PRIMER_MIN_SIZE\n";
	print "18: Maxuimum length of a primer (PRIMER_MAX_SIZE): $$PRIMER_MAX_SIZE\n";
	print "19: Optimum melting temperature(Celsius) for a primer(PRIMER_OPT_TM): $$PRIMER_OPT_TM\n";
	print "20: Minimum melting temperature(Celsius) for a primer(PRIMER_MIN_TM): $$PRIMER_MIN_TM\n";
	print "21: Maximum melting temperature(Celsius) for a primer(PRIMER_MAX_TM): $$PRIMER_MAX_TM\n";
	print "22: Maximum acceptable difference between the melting temperatures of primers(PRIMER_MAX_DIFF_TM): $$PRIMER_MAX_DIFF_TM\n";
	print "23: Minimum percentage of Gs and Cs in any primer (PRIMER_MIN_GC): $$PRIMER_MIN_GC\n";
	print "24: Optimum GC percent of primers (PRIMER_OPT_GC_PERCENT): $$PRIMER_OPT_GC_PERCENT\n";
	print "25: Maximum percentage of Gs and Cs in any primer (PRIMER_MAX_GC): $$PRIMER_MAX_GC\n";
	print "26: The maximum allowable local alignment score for self- or pairwise-complementarity (PRIMER_SELF_ANY): $$PRIMER_SELF_ANY\n";
	print "27: The maximum allowable 3'-anchored global alignment score for self- or pairwise-complementarity (PRIMER_SELF_END): $$PRIMER_SELF_END\n";
	print "28: The maximum allowable length of a mononucleotide repeat in primer (PRIMER_MAX_POLY_X): $$PRIMER_MAX_POLY_X\n";
	print "29: The maximum number of primer pairs to return for each PCR product length interval (PRIMER_NUM_RETURN): $$PRIMER_NUM_RETURN\n";

    print "\nPress enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";

    $reply = <STDIN>;

while ( not ($reply eq "\n"))
{
	open_file_out($set_file, 'SETOUT');


    if ($reply eq "\n")
    {
	print SETOUT "$$del_files\n$$flank_min\n$$ampl_min\n$$mono_max\n$$non_mono_max\n$$min_mot_l\n$$max_mot_l\n$$min_rep\n$$primer3_path\n$$pcr_min\n$$pcr_max\n$$pcr_step\n$$min1s\n$$min2s\n$$min3s\n$$min4s\n$$min5s\n$$min6s\n$$syst\n$$folder\n$$select_pool\n$$PRIMER_GC_CLAMP\n$$PRIMER_OPT_SIZE\n$$PRIMER_MIN_SIZE\n$$PRIMER_MAX_SIZE\n$$PRIMER_OPT_TM\n$$PRIMER_MIN_TM\n$$PRIMER_MAX_TM\n$$PRIMER_MAX_DIFF_TM\n$$PRIMER_MIN_GC\n$$PRIMER_OPT_GC_PERCENT\n$$PRIMER_MAX_GC\n$$PRIMER_SELF_ANY\n$$PRIMER_SELF_END\n$$PRIMER_MAX_POLY_X\n$$PRIMER_NUM_RETURN\n";
	next;
    }

    else
    {
	chomp $reply;

	if ($reply == 2 )
	{
	    print "Do you wish to delete intermedite files? (YES=1/NO=0)\n";
	    $$del_files = <STDIN>;
	    chomp $$del_files;
	}
	elsif ($reply == 3 )
	{
	    print "Enter minimum length of nano-satellie free flanking region\n";
	    $$flank_min = <STDIN>;
	    chomp $$flank_min;
	}
	elsif ($reply == 4 )
	{
	    print "Enter the minimum length of PCR product\n";
	    $$ampl_min = <STDIN>;
	    chomp $$ampl_min;
	}
	elsif ($reply == 5 )
	{
	    print "Enter the maximum number of monobase repetitions in the flanking region (must be greater then 3 and smaller or egal to minimum repeat number for target microsat)\n";
	    $$mono_max = <STDIN>;
	    chomp $$mono_max;
		if ($$mono_max > $$min_rep)
		{
			$$mono_max = $$min_rep;
		}
	}
	elsif ($reply == 6 )
	{
	    print "Enter the maximum number of di-hexabase repetitions in the flanking region (Must be smaller or egal to minimum repeat number for target microsat)\n";
	    $$non_mono_max = <STDIN>;
	    chomp $$non_mono_max;
		if ($$non_mono_max > $$min_rep)
		{
			$$non_mono_max = $$min_rep;
		}

	}
	elsif ($reply == 7 )
	{
	    print "Enter the minimum repeat length of a target microsatellite\n";
	    $$min_mot_l= <STDIN>;
	    chomp $$min_mot_l;
	}
	elsif ($reply == 8 )
	{
	    print "Enter the maximum repeat length of a target microsatellite(must be smaller than 7) \n";
	    $$max_mot_l= <STDIN>;
	    chomp $$max_mot_l;
	}
	elsif ($reply == 9 )
	{
	    print "Enter the minimum number of repeats for the target microsatellite\n";
	    $$min_rep= <STDIN>;
	    chomp $$min_rep;
	}
	elsif ($reply == 11 )
	{
	    print "Enter the path to Primer3\n";
	    $$primer3_path= <STDIN>;
	    chomp $$primer3_path;
	}
	elsif ($reply == 12 )
	{
	    print "Enter the minimum length of PCR product for primer design\n";
	    $$pcr_min = <STDIN>;
	    chomp $$pcr_min;
	}
	elsif ($reply == 13 )
	{
	    print "Enter the maximum length of PCR product for primer design\n";
	    $$pcr_max = <STDIN>;
	    chomp $$pcr_max;
	}
	elsif ($reply == 14 )
	{
	    print "Enter the interval of PCR product for primer design\n";
	    $$pcr_step = <STDIN>;
	    chomp $$pcr_step;
	}
	elsif ($reply == 0 )
	{
	    print "Enter your operating system (win/linux)\n";
	    $$syst = <STDIN>;
	    chomp $$syst;
	}
	elsif ($reply == 1 )
	{
	    print "Enter your input folder\n";
	    $$folder = <STDIN>;
	    chomp $$folder;
	}
	elsif ($reply == 10 )
	{
	    print "Do you wish to select interrupted and compound microsatellites as a target? (YES=1/NO=0)\n";
	    $$select_pool = <STDIN>;
	    chomp $$select_pool;
	}
	elsif ($reply ==  15)
	{
	    print "Number of consecutive Gs and Cs at the 3'of primer (PRIMER_GC_CLAMP)\n";
	    $$PRIMER_GC_CLAMP= <STDIN>;
	    chomp $$PRIMER_GC_CLAMP;
	}
	elsif ($reply ==  16)
	{
	    print "Optimum length of a primer (PRIMER_OPT_SIZE)\n";
	    $$PRIMER_OPT_SIZE = <STDIN>;
	    chomp $$PRIMER_OPT_SIZE ;
	}
	elsif ($reply ==  17)
	{
	    print "Minimum length of a primer (PRIMER_MIN_SIZE)\n";
	    $$PRIMER_MIN_SIZE= <STDIN>;
	    chomp $$PRIMER_MIN_SIZE;
	}
	elsif ($reply ==  18)
	{
	    print "Maxuimum length of a primer (PRIMER_MAX_SIZE)\n";
	    $$PRIMER_MAX_SIZE= <STDIN>;
	    chomp $$PRIMER_MAX_SIZE;
	}
	elsif ($reply ==  19)
	{
	    print "Optimum melting temperature(Celsius) for a primer(PRIMER_OPT_TM)\n";
	    $$PRIMER_OPT_TM= <STDIN>;
	    chomp $$PRIMER_OPT_TM;
	}
	elsif ($reply ==  20)
	{
	    print "Minimum melting temperature(Celsius) for a primer(PRIMER_MIN_TM)\n";
	    $$PRIMER_MIN_TM= <STDIN>;
	    chomp $$PRIMER_MIN_TM;
	}
	elsif ($reply ==  21)
	{
	    print "Maximum melting temperature(Celsius) for a primer(PRIMER_MAX_TM)\n";
	    $$PRIMER_MAX_TM= <STDIN>;
	    chomp $$PRIMER_MAX_TM;
	}
	elsif ($reply ==  22)
	{
	    print "Maximum acceptable difference between the melting temperatures of primers(PRIMER_MAX_DIFF_TM)\n";
	    $$PRIMER_MAX_DIFF_TM= <STDIN>;
	    chomp $$PRIMER_MAX_DIFF_TM;
	}
	elsif ($reply ==  23)
	{
	    print "Minimum percentage of Gs and Cs in any primer (PRIMER_MIN_GC)\n";
	    $$PRIMER_MIN_GC= <STDIN>;
	    chomp $$PRIMER_MIN_GC;
	}
	elsif ($reply ==  24)
	{
	    print "Optimum GC percent of primers (PRIMER_OPT_GC_PERCENT)\n";
	    $$PRIMER_OPT_GC_PERCENT= <STDIN>;
	    chomp $$PRIMER_OPT_GC_PERCENT;
	}
	elsif ($reply ==  25)
	{
	    print "Maximum percentage of Gs and Cs in any primer (PRIMER_MAX_GC)\n";
	    $$PRIMER_MAX_GC= <STDIN>;
	    chomp $$PRIMER_MAX_GC;
	}
	elsif ($reply ==  26)
	{
	    print "The maximum allowable local alignment score for self- or pairwise-complementarity (PRIMER_SELF_ANY)\n";
	    $$PRIMER_SELF_ANY= <STDIN>;
	    chomp $$PRIMER_SELF_ANY;
	}
	elsif ($reply ==  27)
	{
	    print "The maximum allowable 3'-anchored global alignment score for self- or pairwise-complementarity (PRIMER_SELF_END)\n";
	    $$PRIMER_SELF_END= <STDIN>;
	    chomp $$PRIMER_SELF_END;
	}
	elsif ($reply ==  28)
	{
	    print "The maximum allowable length of a mononucleotide repeat in primer (PRIMER_MAX_POLY_X)\n";
	    $$PRIMER_MAX_POLY_X= <STDIN>;
	    chomp $$PRIMER_MAX_POLY_X;
	}
	elsif ($reply ==  29)
	{
	    print "The maximum number of primer pairs to return for each PCR product length interval (PRIMER_NUM_RETURN)\n";
	    $$PRIMER_NUM_RETURN= <STDIN>;
	    chomp $$PRIMER_NUM_RETURN;
	}

	print SETOUT "$$del_files\n$$flank_min\n$$ampl_min\n$$mono_max\n$$non_mono_max\n$$min_mot_l\n$$max_mot_l\n$$min_rep\n$$primer3_path\n$$pcr_min\n$$pcr_max\n$$pcr_step\n$$min1s\n$$min2s\n$$min3s\n$$min4s\n$$min5s\n$$min6s\n$$syst\n$$folder\n$$select_pool\n$$PRIMER_GC_CLAMP\n$$PRIMER_OPT_SIZE\n$$PRIMER_MIN_SIZE\n$$PRIMER_MAX_SIZE\n$$PRIMER_OPT_TM\n$$PRIMER_MIN_TM\n$$PRIMER_MAX_TM\n$$PRIMER_MAX_DIFF_TM\n$$PRIMER_MIN_GC\n$$PRIMER_OPT_GC_PERCENT\n$$PRIMER_MAX_GC\n$$PRIMER_SELF_ANY\n$$PRIMER_SELF_END\n$$PRIMER_MAX_POLY_X\n$$PRIMER_NUM_RETURN\n";
    
    print "\n0: Operating system (win/linux): $$syst\n";
    print "1: Input folder: $$folder\n";
    print "2: Delete intermediate files (YES=1/NO=0): $$del_files\n";
    print "3: Minimum length of flanking region : $$flank_min\n";
    print "4: Minimum length of PCR product (in sequence selection step) : $$ampl_min\n";
    print "5: Maximum number of monobase repeats in flanking region : $$mono_max\n";
    print "6: Maximum number of di-hexabase repeats in flanking region : $$non_mono_max\n";
    print "7: Select microsatellites for primer design if the motif length is at least : $$min_mot_l\n";
    print "8: Select microsatellites for primer design if the motif length is at most : $$max_mot_l\n";
    print "9: Select microsatellites for primer design if the number of repeats is at least :$$min_rep\n";
    print "10: Select interrupted and compound microsatellites (YES=1/NO=0): $$select_pool\n";	
	print "\nPRIMER3 parameters\n";
    print "11: Pathway to Primer3 : $$primer3_path\n"; 
    print "12: Minimum length of PCR product for primer design: $$pcr_min\n";
    print "13: Maximum length of PCR product for primer design: $$pcr_max\n";
    print "14: Interval of length of PCR product for primer design: $$pcr_step\n";
	print "15: Number of consecutive Gs and Cs at the 3'of primer (PRIMER_GC_CLAMP): $$PRIMER_GC_CLAMP\n";
	print "16: Optimum length of a primer (PRIMER_OPT_SIZE ): $$PRIMER_OPT_SIZE\n";
	print "17: Minimum length of a primer (PRIMER_MIN_SIZE): $$PRIMER_MIN_SIZE\n";
	print "18: Maxuimum length of a primer (PRIMER_MAX_SIZE): $$PRIMER_MAX_SIZE\n";
	print "19: Optimum melting temperature(Celsius) for a primer(PRIMER_OPT_TM): $$PRIMER_OPT_TM\n";
	print "20: Minimum melting temperature(Celsius) for a primer(PRIMER_MIN_TM): $$PRIMER_MIN_TM\n";
	print "21: Maximum melting temperature(Celsius) for a primer(PRIMER_MAX_TM): $$PRIMER_MAX_TM\n";
	print "22: Maximum acceptable difference between the melting temperatures of primers(PRIMER_MAX_DIFF_TM): $$PRIMER_MAX_DIFF_TM\n";
	print "23: Minimum percentage of Gs and Cs in any primer (PRIMER_MIN_GC): $$PRIMER_MIN_GC\n";
	print "24: Optimum GC percent of primers (PRIMER_OPT_GC_PERCENT): $$PRIMER_OPT_GC_PERCENT\n";
	print "25: Maximum percentage of Gs and Cs in any primer (PRIMER_MAX_GC): $$PRIMER_MAX_GC\n";
	print "26: The maximum allowable local alignment score for self- or pairwise-complementarity (PRIMER_SELF_ANY): $$PRIMER_SELF_ANY\n";
	print "27: The maximum allowable 3'-anchored global alignment score for self- or pairwise-complementarity (PRIMER_SELF_END): $$PRIMER_SELF_END\n";
	print "28: The maximum allowable length of a mononucleotide repeat in primer (PRIMER_MAX_POLY_X): $$PRIMER_MAX_POLY_X\n";
	print "29: The maximum number of primer pairs to return for each PCR product length interval (PRIMER_NUM_RETURN): $$PRIMER_NUM_RETURN\n";


    print "\nPress enter if all of the settings are correct, or the number of the parameter if you whish to change the settings!\n";

	$reply = <STDIN>;

    }

    close SETOUT;
# end while ( not ($reply eq "\n"))
}
# end sub
}


