#!/usr/bin/perl -w

# Nom du programme: read_primer_3results_param.pl (modified from read_primer_3results.pl + primer3 extra parameters)

#INPUT: xxx_primer3.txt (output of primer3_input_lc.pl)
#       xxx_target_ms_stat.tbl
# run primer3, and transform outfile in a more digestable format 

#OUTPUT:
#xxx_primer3_output.txt
#xxx_primer3_output.tbl


  use warnings;
  use strict;
  use subprogramEM;

my $folder = '';
my $outfolder = '';
my $file_motif = '';
my $primer3_path = '';
my $pcr_min = '';
my $pcr_max = '';
my $pcr_step = '';
#my @min_l = (80, 320);
my $syst = '';

my $PRIMER_GC_CLAMP = '';
my $PRIMER_OPT_SIZE = '';
my $PRIMER_MIN_SIZE = '';
my $PRIMER_MAX_SIZE = '';
my $PRIMER_OPT_TM = '';
my $PRIMER_MIN_TM = '';
my $PRIMER_MAX_TM = '';
my $PRIMER_MAX_DIFF_TM = '';
my $PRIMER_MIN_GC = '';
my $PRIMER_OPT_GC_PERCENT = '';
my $PRIMER_MAX_GC = '';
my $PRIMER_SELF_ANY = '';
my $PRIMER_SELF_END = '';
my $PRIMER_MAX_POLY_X = '';
my $PRIMER_NUM_RETURN = '';

  if ( scalar@ARGV == 23 )
  {
     	$folder = $ARGV[0];
	$outfolder = $ARGV[1];
	$pcr_min = $ARGV[2];
	$pcr_max = $ARGV[3];
	$pcr_step = $ARGV[4];	
	$primer3_path = $ARGV[5];
	$file_motif = $ARGV[6];
	$syst = $ARGV[7];
	$PRIMER_GC_CLAMP = $ARGV[8];
	$PRIMER_OPT_SIZE = $ARGV[9];
	$PRIMER_MIN_SIZE = $ARGV[10];
	$PRIMER_MAX_SIZE = $ARGV[11];
	$PRIMER_OPT_TM = $ARGV[12];
	$PRIMER_MIN_TM = $ARGV[13];
	$PRIMER_MAX_TM = $ARGV[14];
	$PRIMER_MAX_DIFF_TM = $ARGV[15];
	$PRIMER_MIN_GC = $ARGV[16];
	$PRIMER_OPT_GC_PERCENT = $ARGV[17];
	$PRIMER_MAX_GC = $ARGV[18];
	$PRIMER_SELF_ANY = $ARGV[19];
	$PRIMER_SELF_END = $ARGV[20];
	$PRIMER_MAX_POLY_X = $ARGV[21];
	$PRIMER_NUM_RETURN = $ARGV[22];

  }

else
{
	$folder = 'datatemp1';
	$outfolder = 'temp1';
	$pcr_min = 80;
	$pcr_max = 350;
	$pcr_step = 50;
	$primer3_path = 'c:/primer3-1.1.4/bin/';
#	$primer3_path = '/usr/bin/';
	$file_motif = 'primer3.txt';
	$syst = 'linux';

$PRIMER_GC_CLAMP = 0;
$PRIMER_OPT_SIZE = 20;
$PRIMER_MIN_SIZE = 18;
$PRIMER_MAX_SIZE = 27;
$PRIMER_OPT_TM = 60.0;
$PRIMER_MIN_TM = 57.0;
$PRIMER_MAX_TM = 63.0;
$PRIMER_MAX_DIFF_TM = 100.0;
$PRIMER_MIN_GC = 20.0;
$PRIMER_OPT_GC_PERCENT = 50.0;
$PRIMER_MAX_GC = 80.0;
$PRIMER_SELF_ANY = 8.00;
$PRIMER_SELF_END = 3.00;
$PRIMER_MAX_POLY_X = 5;
$PRIMER_NUM_RETURN = 2;

}

  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $filename (@filenames)
{
if ($filename =~ /$file_motif/)
{
    my $out_txt = $filename;
    $out_txt = $outfolder.'/'.$out_txt; 
    $out_txt =~ s/\.txt/_output\.txt/;
	my $out_tbl = $filename;
	$out_tbl = $outfolder.'/'.$out_tbl;
	$out_tbl =~ s/3\.txt/s\.tbl/;
	$out_tbl =~ s/pipe3_select/pipe3_/;
	$out_tbl =~ s/pipe3_compound_select/pipe3_compound_/;

       my $out_temp = $filename;
	$out_temp =~ s/\./_temp\./;
	$out_temp = $outfolder.'/'.$out_temp;

    $filename = $folder.'/'.$filename; 
	my $stat_file = $filename;
	$stat_file =~ s/_primer3\.txt/_target_ms_stat\.tbl/;


    my $primer3 = '';
    my %pair =(); 
    my $primer_ok = 0;
    my $no_primer = 0;
    my %best = ();
#########################

add_length_crit_param($filename, $out_temp, $pcr_min, '1000000000', $pcr_max, $PRIMER_GC_CLAMP,$PRIMER_OPT_SIZE,$PRIMER_MIN_SIZE,$PRIMER_MAX_SIZE,$PRIMER_OPT_TM,$PRIMER_MIN_TM,$PRIMER_MAX_TM,$PRIMER_MAX_DIFF_TM,$PRIMER_MIN_GC,$PRIMER_OPT_GC_PERCENT,$PRIMER_MAX_GC,$PRIMER_SELF_ANY,$PRIMER_SELF_END,$PRIMER_MAX_POLY_X,$PRIMER_NUM_RETURN);

#    add_length_crit($filename, $out_temp, $pcr_min, '1000000000', $pcr_max);
    if ($syst eq 'win')
    {
	$primer3 = '"'.$primer3_path.'primer3_core.exe" <'.$out_temp.' > '.$out_txt;
    }
    elsif ($syst eq 'linux')
    {
	$primer3 = $primer3_path.'primer3_core <'.$out_temp.' > '.$out_txt;
    }
#	print "$primer3\n";
	system $primer3;



    open_file_in($out_txt, 'DATA');

    while (my $data = one_seq($out_txt))
    {
	$data =~ /PRIMER_SEQUENCE_ID=.+\n/;
	my $code = $&;
	$code =~ s/PRIMER_SEQUENCE_ID=//;
	chomp $code;

	my $i = 0;
	my $primer_des = 0;
	if ($data =~ /.*?PRIMER_PRODUCT_SIZE[_0-9]*=.+?\n/gs)
	{
		++$i;
		my $pair = $&;
		my $pair_info = extract_and_print_info($pair, $i, $code);
		$pair_info =~ /.*?;/;
		my $pair_code = $&;
		$best{$pair_code} = $pair_info;
#		print OUT "$pair_info\n";
		$primer_des = 1;
	}
	if ($primer_des == 0)
	{
		++$no_primer;
	}
	else
	{
		++$primer_ok;
	}
# end while
    }
close DATA;


	print "$filename;$no_primer;$primer_ok\n";

#############################
#	foreach my $min_l (@min_l)
        for (my $min_l = $pcr_min; $min_l < $pcr_max; $min_l = $min_l+$pcr_step)
	{
add_length_crit_param($filename, $out_temp, $min_l, $pcr_step, $pcr_max, $PRIMER_GC_CLAMP,$PRIMER_OPT_SIZE,$PRIMER_MIN_SIZE,$PRIMER_MAX_SIZE,$PRIMER_OPT_TM,$PRIMER_MIN_TM,$PRIMER_MAX_TM,$PRIMER_MAX_DIFF_TM,$PRIMER_MIN_GC,$PRIMER_OPT_GC_PERCENT,$PRIMER_MAX_GC,$PRIMER_SELF_ANY,$PRIMER_SELF_END,$PRIMER_MAX_POLY_X,$PRIMER_NUM_RETURN);
#		add_length_crit($filename, $out_temp, $min_l, $pcr_step, $pcr_max);

		my $primer3 = '';
		if ($syst eq 'win')
		{
		    $primer3 = '"'.$primer3_path.'primer3_core.exe" <'.$out_temp.' > '.$out_txt;
		}
		elsif ($syst eq 'linux')
		{
		    $primer3 = $primer3_path.'primer3_core <'.$out_temp.' > '.$out_txt;
		}
#		print "$primer3\n";
		system $primer3;

	open_file_in($out_txt, 'DATA');
 	while (my $data = one_seq($out_txt))
	{
		$data =~ /PRIMER_SEQUENCE_ID=.+\n/;
	       my $code = $&;
		$code =~ s/PRIMER_SEQUENCE_ID=//;
		chomp $code;

		my $i = 0;
		while ($data =~ /.*?PRIMER_PRODUCT_SIZE[_0-9]*=.+?\n/gs)
		{
			++$i;
			my $i_temp = $min_l.'_'.$i;
			my $pair = $&;
			my $pair_info = extract_and_print_info($pair, $i_temp, $code);
			$pair_info =~ /.*?;/;
			my $pair_code = $&;
			unless (exists $pair{$pair_code})
			{
				$pair{$pair_code} = $pair_info;
			}
		}
# while
    }
	close DATA;

	}

my %stat = open_file_and_hach($stat_file, '0');

open_file_out($out_tbl, 'OUT');

if ($file_motif =~ /pool/i)
{
	print OUT "SEQ_CODE;MIN_PCR_PRODUCT_SIZE;PCR_PRODUCT_SIZE;PRIMER_PAIR_PENALTY;PRIMER_LEFT_PENALTY;PRIMER_RIGHT_PENALTY;";
	print OUT "PRIMER_LEFT_SEQUENCE;PRIMER_RIGHT_SEQUENCE;PRIMER_LEFT_POS;PRIMER_LEFT_LENGTH;PRIMER_RIGHT_POS;";
	print OUT "PRIMER_RIGHT_LENGTH;PRIMER_LEFT_TM;PRIMER_RIGHT_TM;PRIMER_LEFT_GC_PERCENT;PRIMER_RIGHT_GC_PERCENT;";
	print OUT "PRIMER_LEFT_SELF_ANY;PRIMER_RIGHT_SELF_ANY;PRIMER_LEFT_SELF_END;PRIMER_RIGHT_SELF_END;";
	print OUT "PRIMER_LEFT_END_STABILITY;PRIMER_RIGHT_END_STABILITY;PRIMER_PAIR_COMPL_ANY;PRIMER_PAIR_COMPL_END;";
	print OUT "FIRST_POS;LENGTH_BP;LENGTH_REP;MS;\n";
}
else
{
	print OUT "SEQ_CODE;MIN_PCR_PRODUCT_SIZE;PCR_PRODUCT_SIZE;PRIMER_PAIR_PENALTY;PRIMER_LEFT_PENALTY;PRIMER_RIGHT_PENALTY;";
	print OUT "PRIMER_LEFT_SEQUENCE;PRIMER_RIGHT_SEQUENCE;PRIMER_LEFT_POS;PRIMER_LEFT_LENGTH;PRIMER_RIGHT_POS;";
	print OUT "PRIMER_RIGHT_LENGTH;PRIMER_LEFT_TM;PRIMER_RIGHT_TM;PRIMER_LEFT_GC_PERCENT;PRIMER_RIGHT_GC_PERCENT;";
	print OUT "PRIMER_LEFT_SELF_ANY;PRIMER_RIGHT_SELF_ANY;PRIMER_LEFT_SELF_END;PRIMER_RIGHT_SELF_END;";
	print OUT "PRIMER_LEFT_END_STABILITY;PRIMER_RIGHT_END_STABILITY;PRIMER_PAIR_COMPL_ANY;PRIMER_PAIR_COMPL_END;";
	print OUT "FIRST_POS;LENGTH_BP;LENGTH_REP;MOTIF;TRANS_MOTIF;\n";
}

my %count_prim = ();
foreach my $pair (sort keys %pair)
{
	$pair{$pair} =~ s/[^;]*;//;
	my @data = split(';', $pair{$pair});
	my $code = $data[0];
	$count_prim{$code} = '';
	my $min_p = $data[1];
	$min_p =~ s/_.*//;
	$data[1] = $min_p;
	$pair{$pair} = join(';', @data);
	
	print OUT "$pair{$pair};";
	print OUT "$stat{$code}";
	if (exists $best{$pair})
	{
	    print OUT "best;\n";
	}
	else
	{
	    print OUT "\n";
	}
}
$primer_ok = scalar keys %count_prim;
#print "$filename;$primer_ok\n";
print OUT "Total number of markers with primer: $primer_ok;\n";
close OUT;
# end if file_motif
}
#end of foreach file
}

exit;


############################################################


sub one_seq
{
#    read the data concernant one sequence

    my ($filename) = @_; 
    my ($res_seq) = ''; 

    my ($sep_entree) = $/;
    $/ = "=\n";
    $res_seq = <DATA>;
    $/ = $sep_entree;
    return $res_seq;
}


##########################################################

sub extract_and_print_info
{
my ($pair, $i, $code) = @_;

#print "$primer_pair******************\n";

		$pair =~ /PRIMER_PRODUCT_SIZE[_0-9]*=.+?\n/;
		my $pair_size = $&;
		$pair_size =~ /[0-9\.]+$/;
		$pair_size = $&;
#		print OUT "$pair_size;";

		$pair =~ /PRIMER_PAIR_PENALTY.+?\n/;
		my $pair_pen = $&;
		$pair_pen =~ /[0-9\.]+$/;
		$pair_pen = $&;
#		print OUT "$pair_pen;";

		$pair =~ /PRIMER_LEFT_[0-9_]*PENALTY.+?\n/;
		my $pair_left_pen = $&;
		$pair_left_pen =~ /[0-9\.]+$/;
		$pair_left_pen = $&;
#		print OUT "$pair_left_pen;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*PENALTY.+?\n/;
		my $pair_right_pen = $&;
		$pair_right_pen =~ /[0-9\.]+$/;
		$pair_right_pen = $&;
#		print OUT "$pair_right_pen;";

		$pair =~ /PRIMER_LEFT_[0-9_]*SEQUENCE.+?\n/;
		my $pair_left_seq = $&;
		$pair_left_seq =~ /[a-z]+$/i;
		$pair_left_seq = $&;
#		print OUT "$pair_left_seq;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*SEQUENCE.+?\n/;
		my $pair_right_seq = $&;
		$pair_right_seq =~ /[a-z]+$/i;
		$pair_right_seq = $&;
#		print OUT "$pair_right_seq;";

		$pair =~ /PRIMER_LEFT[0-9_]*=.+?\n/;
		my $pair_left = $&;
		$pair_left =~ /=[0-9]+/;
		my $pair_left_pos = $&;
		$pair_left_pos =~ s/=//;
#		print OUT "$pair_left_pos;";
		$pair_left =~ /[0-9]+$/;
		my $pair_left_l = $&;
#		print OUT "$pair_left_l;";

		$pair =~ /PRIMER_RIGHT[0-9_]*=.+?\n/;
		my $pair_right = $&;
		$pair_right =~ /=[0-9]+/;
		my $pair_right_pos = $&;
		$pair_right_pos =~ s/=//;
#		print OUT "$pair_right_pos;";
		$pair_right =~ /[0-9]+$/;
		my $pair_right_l = $&;
#		print OUT "$pair_right_l;";

		$pair =~ /PRIMER_LEFT_[0-9_]*TM.+?\n/;
		my $pair_left_tm = $&;
		$pair_left_tm =~ /[0-9\.]+$/;
		$pair_left_tm = $&;
#		print OUT "$pair_left_tm;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*TM.+?\n/;
		my $pair_right_tm = $&;
		$pair_right_tm =~ /[0-9\.]+$/;
		$pair_right_tm = $&;
#		print OUT "$pair_right_tm;";

		$pair =~ /PRIMER_LEFT_[0-9_]*GC_PERCENT.+?\n/;
		my $pair_left_gc = $&;
		$pair_left_gc =~ /[0-9\.]+$/;
		$pair_left_gc = $&;
#		print OUT "$pair_left_gc;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*GC_PERCENT.+?\n/;
		my $pair_right_gc = $&;
		$pair_right_gc =~ /[0-9\.]+$/;
		$pair_right_gc = $&;
#		print OUT "$pair_right_gc;";

		$pair =~ /PRIMER_LEFT_[0-9_]*SELF_ANY.+?\n/;
		my $pair_left_selfany = $&;
		$pair_left_selfany =~ /[0-9\.]+$/;
		$pair_left_selfany = $&;
#		print OUT "$pair_left_selfany;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*SELF_ANY.+?\n/;
		my $pair_right_selfany = $&;
		$pair_right_selfany =~ /[0-9\.]+$/;
		$pair_right_selfany = $&;
#		print OUT "$pair_right_selfany;";

		$pair =~ /PRIMER_LEFT_[0-9_]*SELF_END.+?\n/;
		my $pair_left_selfend = $&;
		$pair_left_selfend =~ /[0-9\.]+$/;
		$pair_left_selfend = $&;
#		print OUT "$pair_left_selfend;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*SELF_END.+?\n/;
		my $pair_right_selfend = $&;
		$pair_right_selfend =~ /[0-9\.]+$/;
		$pair_right_selfend = $&;
#		print OUT "$pair_right_selfend;";

		$pair =~ /PRIMER_LEFT_[0-9_]*END_STABILITY.+?\n/;
		my $pair_left_endstab = $&;
		$pair_left_endstab =~ /[0-9\.]+$/;
		$pair_left_endstab = $&;
#		print OUT "$pair_left_endstab;";

		$pair =~ /PRIMER_RIGHT_[0-9_]*END_STABILITY.+?\n/;
		my $pair_right_endstab = $&;
		$pair_right_endstab =~ /[0-9\.]+$/;
		$pair_right_endstab = $&;
#		print OUT "$pair_right_endstab;";

		$pair =~ /PRIMER_PAIR_[0-9_]*COMPL_ANY.+?\n/;
		my $pair_complany = $&;
		$pair_complany =~ /[0-9\.]+$/;
		$pair_complany = $&;
#		print OUT "$pair_complany;";

		$pair =~ /PRIMER_PAIR_[0-9_]*COMPL_END.+?\n/;
		my $pair_complend = $&;
		$pair_complend =~ /[0-9\.]+$/;
		$pair_complend = $&;
#		print OUT "$pair_complend;";

		my $pair_code = $code.'_'.$pair_left_pos.'_'.$pair_left_l.'_'.$pair_right_pos.'_'.$pair_right_l;
		
		$pair_code .= ';'.$code.';'.$i.';'.$pair_size.';'.$pair_pen.';';
		$pair_code .= $pair_left_pen.';'.$pair_right_pen.';'.$pair_left_seq.';'.$pair_right_seq.';';
		$pair_code .= $pair_left_pos.';'.$pair_left_l.';'.$pair_right_pos.';'.$pair_right_l.';';
		$pair_code .= $pair_left_tm.';'.$pair_right_tm.';'.$pair_left_gc.';'.$pair_right_gc.';';
		$pair_code .= $pair_left_selfany.';'.$pair_right_selfany.';'.$pair_left_selfend.';'.$pair_right_selfend.';';
		$pair_code .= $pair_left_endstab.';'.$pair_right_endstab.';'.$pair_complany.';'.$pair_complend.';';
return $pair_code;
}

#######################################################

sub add_length_crit
{
my ($filename, $out_temp, $min_l, $pcr_step, $pcr_max ) = @_;

my $max = '';
if (($min_l + $pcr_step)>$pcr_max )
{
    $max = $pcr_max;
}
else
{
    $max = ($min_l + $pcr_step);
}
open_file_in($filename, 'IN');
open_file_out($out_temp, 'TEMP');
my $bool = 0;
while (my $line = <IN>)
{
    $bool = 1;
	chomp $line;
	if ($line eq '=')
	{
		print TEMP "PRIMER_PRODUCT_SIZE_RANGE=$min_l-$max\n=\n";
	}
	else
	{
		print TEMP "$line\n";
	}
}
# if input file is empty, quit the program
if ($bool == 0)
{
	print "$filename;0;0;\n";
    exit;
}

close IN;
close TEMP;

}

##################################################

sub add_length_crit_param
{
my ($filename, $out_temp, $min_l, $pcr_step, $pcr_max ,$PRIMER_GC_CLAMP,$PRIMER_OPT_SIZE,$PRIMER_MIN_SIZE,$PRIMER_MAX_SIZE,$PRIMER_OPT_TM,$PRIMER_MIN_TM,$PRIMER_MAX_TM,$PRIMER_MAX_DIFF_TM,$PRIMER_MIN_GC,$PRIMER_OPT_GC_PERCENT,$PRIMER_MAX_GC,$PRIMER_SELF_ANY,$PRIMER_SELF_END,$PRIMER_MAX_POLY_X,$PRIMER_NUM_RETURN) = @_;

my $max = '';
if (($min_l + $pcr_step)>$pcr_max )
{
    $max = $pcr_max;
}
else
{
    $max = ($min_l + $pcr_step);
}
open_file_in($filename, 'IN');
open_file_out($out_temp, 'TEMP');
my $bool = 0;
while (my $line = <IN>)
{
    $bool = 1;
	chomp $line;
	if ($line eq '=')
	{
		print TEMP "PRIMER_GC_CLAMP=$PRIMER_GC_CLAMP\n";
		print TEMP "PRIMER_OPT_SIZE=$PRIMER_OPT_SIZE\n";
		print TEMP "PRIMER_MIN_SIZE=$PRIMER_MIN_SIZE\n";
		print TEMP "PRIMER_MAX_SIZE=$PRIMER_MAX_SIZE\n";
		print TEMP "PRIMER_OPT_TM=$PRIMER_OPT_TM\n";
		print TEMP "PRIMER_MIN_TM=$PRIMER_MIN_TM\n";
		print TEMP "PRIMER_MAX_TM=$PRIMER_MAX_TM\n";
		print TEMP "PRIMER_MAX_DIFF_TM=$PRIMER_MAX_DIFF_TM\n";
		print TEMP "PRIMER_MIN_GC=$PRIMER_MIN_GC\n";
		print TEMP "PRIMER_OPT_GC_PERCENT=$PRIMER_OPT_GC_PERCENT\n";
		print TEMP "PRIMER_MAX_GC=$PRIMER_MAX_GC\n";
		print TEMP "PRIMER_SELF_ANY=$PRIMER_SELF_ANY\n";
		print TEMP "PRIMER_SELF_END=$PRIMER_SELF_END\n";
		print TEMP "PRIMER_MAX_POLY_X=$PRIMER_MAX_POLY_X\n";
		print TEMP "PRIMER_NUM_RETURN=$PRIMER_NUM_RETURN\n";
		print TEMP "PRIMER_PRODUCT_SIZE_RANGE=$min_l-$max\n=\n";
	}
	else
	{
		print TEMP "$line\n";
	}
}
# if input file is empty, quit the program
if ($bool == 0)
{
	print "$filename;0;0;\n";
    exit;
}

close IN;
close TEMP;

}
