#!/usr/bin/perl -w

# Nom du programme:select_unique_only.pl 

#INPUT: xxx_pipe2_mask_multihit_final.tbl
#	 xxx_pipe2_mask_short_final.tbl
#		xxx_pipe2_mask_nr.fas (outfilser from group_seq_var2.pl)

# writes a fasta file with al sequences that are in _nr but NOT in  _multihit_final of _short_final


#OUTPUT:
#xxx_pipe3.pl


  use warnings;
  use strict;
  use subprogramEM;


	my $folder = '';
	my $outfolder = '';
	my $file_motif = '';
	my $syst = '';


  if ( scalar@ARGV == 3 )
  {
	$folder = $ARGV[0];
	$outfolder = $ARGV[1];
	$file_motif = $ARGV[2];	
  }

else
{
	$folder ='datatemp1';
	$outfolder = 'temp1';
	$file_motif = '_nr\.fas';	
}


  unless ( opendir(FOLDER, $folder) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );
closedir(FOLDER);

foreach my $filename (@filenames)
{
if ($filename =~ /$file_motif$/)
{
    my $fas_file = $filename;
    my $outfile = $fas_file; 
    $outfile =~ s/pipe2.*/pipe3\.fas/;
	$outfile = $outfolder.'/'.$outfile;

	my $multihit = $fas_file;
	$multihit =~ s/$file_motif$/_multihit_final.tbl/;
	$multihit = $folder.'/'.$multihit;
	my $hit = $fas_file;
	$hit =~ s/$file_motif$/_short_final.tbl/;
	$hit = $folder.'/'.$hit;
	$fas_file = $folder.'/'.$filename;

#print "$fas_file\n$outfile\n";
my %hit = ();
open_file_in($multihit, 'MULT');
while (my $line = <MULT>)
{
	my @line = split (' ', $line);
	$hit{$line[0]} = '';
	$hit{$line[1]} = '';
}
close MULT;

open_file_in($hit, 'HIT');
while (my $line = <HIT>)
{
	my @line = split (' ', $line);
	$hit{$line[0]} = '';
	$hit{$line[1]} = '';
}
close HIT;

open_file_in($fas_file, 'DATA');
open_file_out($outfile, 'OUT');
    while (my $seq = one_seq($filename))
    {
	if ($seq eq '>')
	{
		next;
	}
	$seq =~ /.+\n/;
	my $code = $&;
	$seq =~ s/$code//;
	$seq =~ s/>//;
	$seq =~ s/\s//g;
	chomp $seq;
	$code =~ s/\s.*//;
	chomp $code;

	unless (exists $hit{$code})
	{
		print OUT ">$code\n$seq\n";
	}
# end while
	}
close DATA;
close OUT;

# end if file_motif
}
#end of foreach file
}

exit;


############################################################


sub one_seq
{
#    read the data concernant one sequence

    my ($filename) = @_; 
    my ($res_seq) = ''; 

    my ($sep_entree) = $/;
    $/ = ">";
    $res_seq = <DATA>;
    $/ = $sep_entree;
    return $res_seq;
}


##########################################################
