  sub add_features_to_info
{
 my ($ms_feat, $ms_code, $info) = @_;
 my @codes = keys %$ms_feat;
 
 foreach my $code (@codes)
 {
     if ($$ms_feat{$code} =~ /repeat/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /gene/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /mRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /CDS/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /miscRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /miscfea/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /STS/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /snRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /tRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /snoRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /scRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /rRNA/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
     if ($$ms_feat{$code} =~ /gap/i)
     { 
	 $$info{$$ms_code{$code}} .= '1;'; 
     }
     else
     {
	 $$info{$$ms_code{$code}} .= '0;'; 
     }
 }

}

##########################################################

sub  add_number_of_hits
{
    my ($class) = @_;
    my @codes = keys %$class;

    foreach my $code (@codes)
    {
	my @ligne = split ( ';', $$class{$code});
	if ($ligne[0] eq 'grouped')
	{
	    my @hits = split ( ' ', $ligne[1]);
	    my $number_of_hits = scalar @hits;
	    $$class{$code} = $ligne[0].';'.$number_of_hits.';';
	}
	elsif ($ligne[0] eq 'CSS')
	{
	    $$class{$code} = $ligne[0].';0;'
	}
	else
	{
	    $$class{$code} = $ligne[0].';1;'	    
	}


    }
    

}

##############################################################
sub add_redundant_column
{
my ($clas_seq, $redundants) = @_;

while ( $redundants =~ /[a-z0-9]+/ig )
{
    $$clas_seq{$&} .= ';redundant';
}

}
#############################################################"

sub add_semicolon
{
  my ($taxon) = @_;
  my (@code) = keys %$taxon;

  foreach my $code (@code)
  {
      $$taxon{$code} = ';'.$$taxon{$code};
  }
  


}

##############################################################


sub AVR
{
  my (@liste) = @_;
  
  my $somme = 0;
  foreach my $liste (@liste)
  {
      $somme = $somme + $liste;
  }
  my $AVR = $somme / scalar(@liste);
  
  my $dev = 0;
  foreach my $liste (@liste)
  {
      $dev = $dev + ($AVR - $liste)** 2;
  }
  my $STD = ( $dev / (scalar(@liste) -1 ) )** 0.5; 
  
  return ($AVR, $STD);

}


###################################################################

sub add_zero_to_info
{
 my ($info) = @_;
 my @codes = keys %$info;
 
 foreach my $code (@codes)
 {
    
     my @ligne = split (';', $$info{$code});
     if (scalar @ligne < 22)
     {
	 $$info{$code} .= '0;0;0;0;0;0;0;0;0;0;0;0;0;';
     }
 }

}
################################################################

sub bootstrap
{

# select 20 sequences at random from ....WOV file
# count grouped,Css,redundant, indep like in th emain program
 
  use warnings;
  use strict;
  my ($filename, $Eblast, $seq_number, $boot_number, $redlimit, $gap, $prop_groupWOboot, $group_index) = @_;
  my %all_seq = fasta_into_hachage($filename);
  my @code = keys %all_seq;
  my @prop_group = ();



  if (scalar(@code) - 1 < $seq_number)
  {
      print "Less than $seq_number sequences in $filename\n";
      $boot_number = 0;
  }
  srand( time | $$ );

  print "BOOTSTRAP $filename\n";
for (my $i = 0; $i < $boot_number; ++$i )
{
  my %seq_temp = ();
  my @code_temp = ();
  do
  {
      my $code_temp = $code[int(rand(scalar @code))];
      $seq_temp{$code_temp} = $all_seq{$code_temp};
      @code_temp = keys %seq_temp;
  }
  until ( scalar@code_temp == $seq_number);
      
  make_fasta_file(\%seq_temp, 'temp/bootstrap.fas');
 
   my ($count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group) = group_blast('temp/bootstrap.fas', $Eblast, $redlimit, $gap);

# read data from bootstrap.clas; if sequence is grouped concatenate 1 to the value of hachage, if sequence is independent concat. 0. Thus the number of the caracters in the value is equal to the number of times the sequence was in the sample and was indep or grouped
#  collect_group_index(\%$group_index);

  push (@prop_group, $prop_group);
  if ($i =~ /0$/ ) 
  {
      print "$i ";
  }
}

# for each sequence makes the mean of the list of 1s and 0s, and replaces valu with this mean;and the number of observations(number of times the sequence was indep or grouped).
#count_group_index(\%$group_index);

print "\n";
  
  my $AVR = $prop_groupWOboot;
  my $STD = 0;

  if ( scalar @prop_group > 0 )
  {
     ($AVR, $STD) = AVR(@prop_group);
  }
return ($AVR, $STD);
}

###############################################################

sub calculate_flanking_region
{
my ($microsat_all, $longeur) = @_;
my $rf40 = 0;

if ($$microsat_all[1] > 40 )
{
    $rf40 = $$microsat_all[1];
}


if ($longeur - $$microsat_all[(scalar @$microsat_all) - 1] > 40 )
{
    $rf40 = $rf40 + ($longeur - $$microsat_all[(scalar @microsat_all) - 1]);
}
 

for (my $i = 4; $i < scalar @$microsat_all; $i = $i + 3)
{
    my $temp = $$microsat_all[$i] - $$microsat_all[$i-2];
    if ($temp > 40)
    {
	$rf40 = $rf40 + $temp;
    }
}



return $rf40;

}

################################################################ 


sub calculate_identity
{
  my ($filename, $redlimit, $gap, $Eblast) = @_;
  my $code1 = '';
  my $code2 = '';
  my $seq1 = '';
  my $seq2 = '';
  my $countN = 0;
  my $countGap = 0;
  my $countMatch = 0;
  my $countMismatch = 0; 

  unless (open(CLUSTAL, $filename))
    {
      print "Cannot open $filename\n";
      exit;
    }
  my @seqs = <CLUSTAL>;
  close(CLUSTAL);

# read the two sequences into two separate scalar 
  foreach my $ligne (@seqs)
  {
      if ( $ligne =~ /^[a-z0-9_]+\s{4,}/i )
      {
	  my $code = $&;
	  $code =~ s/\s//g;
	  # test if codes have been identified
	  unless ($code1 and $code2)
	  {
	      if ($code1)
	      {
		  $code2 = $code; 
	      }
	      else
	      {
	          $code1 = $code;
	      } 
	  }
	  if ($code eq $code1)
	  {
	      $ligne =~ /\s{4,}.+$/;
	      $seq1 .= $&;	      
	  }
	  else
	  {
	      $ligne =~ /\s{4,}.+$/;
	      $seq2 .= $&; 
	  }
      }
  }
  $seq1 =~ s/\s//g;
  $seq2 =~ s/\s//g;


# cut non-corresponding extremities
  if ($seq1 =~ /^-+/)
  {
    substr($seq1, 0, length $&, '');
    substr($seq2, 0, length $&, '');
  }

  if ($seq2 =~ /^-+/)
  {
    substr($seq1, 0, length $&, '');
    substr($seq2, 0, length $&, '');
  }

  if ($seq1 =~ /-+$/)
  {
    substr($seq1, length($seq1)-length $&, length $&, '');
    substr($seq2, length($seq2)-length $&, length $&, '');
  }

  if ($seq2 =~ /-+$/)
  {
    substr($seq1, length($seq1)-length $&, length $&, '');
    substr($seq2, length($seq2)-length $&, length $&, '');
  }

#  print "\n$code1\n$seq1\n";
#  print "$code2\n$seq2\n";

  for (my $position = 0; $position < length $seq1; ++$position)
  {
      my $base1 = substr($seq1, $position, 1); 
      my $base2 = substr($seq2, $position, 1); 
      if (($base1 eq 'N') or ($base2 eq 'N'))
      {
	  ++$countN;
      }
      elsif (($base1 eq '-') or ($base2 eq '-'))
      {
	  ++$countGap;
      }
      elsif ($base1 eq $base2)
      {
	  ++$countMatch;
      }
      else
      {
	  ++$countMismatch;
      }	     
  }

  my $booleen = '';
  my $identityGap = '';
  my $identityWOgap = '';


#occasianally Clustal does not align well and microsatellites are matched with tthe flanking sequences. It gives only matches againts Ns. If this is the case a file.fas is saved with the two sequences in it, and a small blast is run. Its results are saved in file.txt for further manual checks. In these cases both sequences are considered as grouped and not redundant.

  if ( ($countGap + $countMismatch + $countMatch) == 0 )
  {
      my $codes = extract_codes('temp/clustinp');
      my $new_file =  'temp/'.$codes.'.fas';
#      print "$new_file\n";
      call_rename('temp/clustinp', $new_file);  
      call_blast($new_file, $Eblast);
      $booleen = 2;
      $identityGap = 0;
      $identityWOgap = 0;
      delete_blast_file('temp/');
  }
  else
  {
      $identityGap = ($countMatch) / ($countGap + $countMismatch + $countMatch);
      $identityWOgap =  ($countMatch) / ($countMismatch + $countMatch);
#  print "\nIdentity $code1-$code2 with gaps: $identityGap\n";
#  print "\nIdentity $code1-$code2 without gaps: $identityWOgap\n";
      my $identity = 0;
      if ( $gap eq 'without')
      {
	  $identity = $identityWOgap;
      } 
      else
      {
	  $identity = $identityGap;
      }

      if ( $identity > $redlimit )
      {
	  $booleen = 1;
      }
      else
      {
	  $booleen = 0;
      }
  }



  return ($booleen, $identityGap,$identityWOgap);

}


######################################################################

sub call_blast
{
    my ($filename, $Eblast) = @_;
    my $filename_out = $filename;
    $filename_out =~ s/\.[a-z0-9]+/\.txt/i; 
    $filename_out =~ s/.+\//temp\//i; 
    my $formatdb = '/usr/local/bin/blast-2.2.13/bin/formatdb -i '.$filename.' -p F -o T';
    my $blast = '/usr/local/bin/blast-2.2.13/bin/blastall -p blastn -d '.$filename.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast;

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}

############################################################"


sub call_blast_adapter
{
    my ($filename, $filename_out, $adaptor_file, $Evector, $path_blast) = @_;

    my $formatdb = $path_blast.'formatdb -i '.$adaptor_file.' -p F -o T';
    my $blast = $path_blast.'blastall -p blastn -d '.$adaptor_file.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Evector.' -m 8' ;
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 

}

################################################
sub call_blast_adapter_no_filter
{
    my ($filename, $filename_out, $adaptor_file, $Evector, $path_blast) = @_;

    my $formatdb = '"'.$path_blast.'formatdb" -i '.$adaptor_file.' -p F -o T';
    my $blast = '"'.$path_blast.'blastall" -p blastn -d '.$adaptor_file.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Evector.' -m 8 -F F' ;
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 

}
################################################
sub call_blast_adapter_no_filter_word_size
{
    my ($filename, $filename_out, $adaptor_file, $Evector, $path_blast, $word_size) = @_;

    my $formatdb = '"'.$path_blast.'formatdb" -i '.$adaptor_file.' -p F -o T';
    my $blast = '"'.$path_blast.'blastall" -p blastn -d '.$adaptor_file.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Evector.' -m 8 -F F -W '.$word_size;
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 

}

##################################################
sub call_blast_m6
{
my ($blast_path, $db_file, $fas_file, $e) = @_;
    my $filename_out = $fas_file;
        $filename_out =~ s/\.fas/_m6\.txt/;
#        print "$filename_out\n";
    my $formatdb = $blast_path.'formatdb -i '.$db_file.' -p F -o T';

    my $blast = $blast_path.'blastall -p blastn -d '.$db_file.' -i '.$fas_file.' -o '.$filename_out.' -T F -e '.$e.' -m 6 -F m -U T';
#    my $blast = $blast_path.'blastall -p blastn -d '.$db_file.' -i '.$fas_file.' -o '.$filename_out.' -T F -e '.$e.' -m 6';
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n";
        return $filename_out;

}

       
##################################################
sub call_blast_m8
{
my ($blast_path, $db_file, $fas_file, $e) = @_;
    my $filename_out = $fas_file;
        $filename_out =~ s/\.fas/_m8\.tbl/;
#        print "$filename_out\n";
    my $formatdb = '"'.$blast_path.'formatdb" -i '.$db_file.' -p F -o T';

    my $blast = '"'.$blast_path.'blastall" -p blastn -d '.$db_file.' -i '.$fas_file.' -o '.$filename_out.' -T F -e '.$e.' -m 8 -F m -U T';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n";
        return $filename_out;

}

######################################################################

sub call_blast_nofilter
{
    my ($filename, $db, $filename_out, $Eblast, $blast_path) = @_;

    my $formatdb = $blast_path.'formatdb -i '.$db.' -p F -o T';
    my $blast = $blast_path.'blastall -p blastn -d '.$db.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast.' -F F -m 8  ';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}

######################################################################

sub call_megablast
{
    my ($filename, $db, $filename_out, $Eblast, $blast_path) = @_;

    my $formatdb = $blast_path.'formatdb -i '.$db.' -p F -o T';
    my $blast = $blast_path.'megablast -d '.$db.' -i '.$filename.' -o '.$filename_out. ' -e '.$Eblast.' -F "m D" -U -D 3';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}


######################################################################

sub call_blast_tbl
{
    my ($filename, $filename_out, $Eblast, $blast_path) = @_;

    my $formatdb = $blast_path.'formatdb -i '.$filename.' -p F -o T';
    my $blast = $blast_path.'blastall -p blastn -d '.$filename.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast.' -m 8';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}

############################################################"

sub call_blast_tbl_soft_filter
{
    my ($filename, $filename_out, $Eblast, $blast_path) = @_;

    my $formatdb = '"'.$blast_path.'formatdb" -i '.$filename.' -p F -o T';
    my $blast = '"'.$blast_path.'blastall" -p blastn -d '.$filename.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast.' -m 8 -F m -U T';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}

############################################################"


sub call_blast_tbl_soft_filter_2files
{
    my ($filename, $db, $filename_out, $Eblast, $blast_path) = @_;

    my $formatdb = '"'.$blast_path.'formatdb" -i '.$db.' -p F -o T';
    my $blast = '"'.$blast_path.'blastall" -p blastn -d '.$db.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast.' -m 8 -F m -U T';

    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}

############################################################"


sub call_blast_vector
{
    my ($filename, $Evector) = @_;
    my $filename_out = $filename;
    $filename_out =~ s/\.[a-z0-9]+/\.vec/i; 
    my $formatdb = '/usr/local/bin/blast-2.2.13/bin/formatdb -i Univec.fas -p F -o T';
    my $blast = '/usr/local/bin/blast-2.2.13/bin/blastall -p blastn -d Univec.fas -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Evector;
    system $formatdb;
#    print "$formatdb\n";

    system $blast;
#    print "$blast\n"; 
}



######################################################################

sub call_clustalw
{
    my ($script_file) = @_;
    my $clustal = '/usr/local/bin/clustalw1.83/clustalw<'.$script_file.'>temp/clustout';

    system $clustal;
   
}
######################################################################

sub call_clustalw2_path
{
    my ($script_file, $clust_path, $outfolder) = @_;
    my $clustal = '"'.$clust_path.'clustalw2"<'.$script_file.'>'.$outfolder.'/clustout';

    system $clustal;
   
}


######################################################################

sub call_clustalw_path
{
    my ($script_file, $clust_path, $outfolder) = @_;
    my $clustal = '"'.$clust_path.'clustalw"<'.$script_file.'>'.$outfolder.'/clustout';

    system $clustal;
   
}

############################################################"


sub call_rename
{
    my ($old_filename, $new_filename) = @_;

    unless (open (OLD_FILE, $old_filename))
    {
	print "Cannot open $old_filename!";
    }
    my @data = <OLD_FILE>;
    close (OLD_FILE);    

    unless (open (NEW_FILE, ">$new_filename"))
    {
	print "Cannot open $new_filename!";
    }

    foreach my $ligne (@data)
    {
	print NEW_FILE "$ligne";

    }

    close (NEW_FILE);      

#    my $rename = '';
#    my $blast = 'blastall -p blastn -d '.$filename.' -i '.$filename.' -o '.$filename_out. ' -T F -e '.$Eblast;

#    system $formatdb;
#    print "$formatdb\n";

#    system $blast;
#    print "$blast\n"; 
}

############################################################"


sub change_letters
 {
  use warnings;
  use strict;
   my ($seq_hach) = @_;
   my @code = keys %$seq_hach;
   my %NON_ATGC = ();

   foreach my $code (@code)
     {
       # delete spaces
       $$seq_hach{$code} =~ s/\s//g;
 
       # Check if other characters than letters are present

       # Change all letters to majuscules
       $$seq_hach{$code} = "\U$$seq_hach{$code}";

       $NON_ATGC{$code} = 'none';
       #puts non-permitted characters into a hachage
       while ($$seq_hach{$code} =~ /[^ATGCN]/g )
         {
	   $NON_ATGC{$code} .= "$&";
         }  
       if ($NON_ATGC{$code} =~ /[^a-z]/ )
       {
	   $NON_ATGC{$code} =~ s/none//;
       }

       # change all non (ATGC) into N
       $$seq_hach{$code} =~ s/[^ATCG]/N/g;
     }
   return %NON_ATGC;
 }
#############################################"
sub check_if_first_line_empty
{
my ($filename) = @_;
open_file_in($filename, 'EMPT');
my $line = <EMPT>;
$line .= 'empty';
close EMPT;
my $bool = '';
if ($line eq 'empty')
{
	$bool = 0;
}
else
{
	$bool = 1;
}

return $bool;
}

####################################################

sub check_and_delete_folder
{
my ($folder) =@_;

if ( opendir(FOLDER, $folder) )
{
	closedir(FOLDER);
		my $del = 'del /s /q "'.$folder.'"';
#		system $del;
		my $rmdir = 'rmdir /s /q "'.$folder.'"';
		system $rmdir;

}

}
####################################################
sub check_and_rename_folder
{
my ($input, $all, $folder, $syst) = @_;
# @$input is the list of input files
# @$all is the list of all files and folders in the project folder

@$all = sort @$all;
my $list = join(';', @$all);

$list = ';'.$list.';';
$list =~ s/;/;;/g;
#print "$list\n";
foreach my $inp1 (@$input)
{
	my $inp = $inp1;
	$inp =~ s/\..*//;
	my $version = 0;
	while ($list =~ /;$inp[_][0-9]+;/g)
	{
		my $temp = $&;
#		print "$temp\n";
		$temp =~ /[0-9]+;/;
		my $count = $&;
		$count =~ s/;//;
		if ($version < $count)
		{
			$version = $count;
		}
	}
	my $rename = '';
	if ($list =~ /;$inp;/)
	{
		if ($syst eq 'win')
		{
			$version = $version +1;
			$rename = 'rename "'.$folder.'\\'.$inp.'" '.$inp.'_'.$version;
#			print "$rename\n";
			system $rename;
		}
		elsif ($syst eq 'linux')
		{
			$version = $version +1;
			$rename = 'mv '.$folder.'/'.$inp.' '.$folder.'/'.$inp.'_'.$version;
#			print "$rename\n";
			system $rename;
		}
	}
} 
}


#############################################"

sub check_ms
{
my ($fragment, $screened_motif, $rep, $ms_pos) = @_;
my $booleen = 0;
foreach my $motif (@$screened_motif)
{
    while($fragment =~ /($motif){$rep,}/ig)
    {
	my $pos_end = pos($fragment);
	my $ms_l = length $&;
	my $pos_beg = pos($fragment) - $ms_l +1;
	$$ms_pos{$pos_beg} = $pos_end.';'.$motif.';';
	$booleen = 1;
#	print "$pos_beg;$pos_end;$motif;";
    }   
}


return $booleen;

}


#########################################################

sub check_ms_feature_pos

{
    my ($feature_hash, $ms, $ms_beg, $out, $booleen, $feature_name) = @_;
    my @feature = keys %$feature_hash;
    
    foreach my $feature (@feature)
    {
	if ($booleen == 1)
	{next; }
#	print "gene_beg $gene ******";
	if ( (($feature < ($$ms{$ms_beg}+1)) and ($$ms{$ms_beg} < ($$feature_hash{$feature}+1))) or ( (($ms_beg+1) > $feature) and ($ms_beg < ($$feature_hash{$feature}+1) )) )
	{
#	    print "gene_beg $gene gene_end $gene{$gene}\n\n";
	    $$out{$ms_beg} .= $feature_name.';';
	    $booleen = 1;
	}
    }

}
#####################################################

sub change_ms_into_lower_case
{
my ($fragment, $ms_pos) = @_;

	my @ms = sort {$a <=> $b} keys %$ms_pos;
	foreach my $ms (@ms)
	{
#	print "$ms;$$ms_pos{$ms}\n";
		$$ms_pos{$ms} =~ /[0-9]+/;
		my $l_ms = $& - $ms +1;
		my $fragment_temp = $fragment;
		my $ms_frag = substr($fragment_temp, $ms-1, $l_ms);
		$ms_frag =~ tr/ACGT/acgt/;
#	print "$ms_frag\n";
		substr($fragment, $ms-1, $l_ms, $ms_frag);
#	print	"$fragment\n";
	}
return $fragment;
}

#######################################################

sub check_path
{
my ($path, $syst) = @_;

if ($syst eq 'win')
{
	unless ($$path =~ /\\$/)
	{
		$$path .= '\\';
	}
}
elsif ($syst eq 'linux')
{
	unless ($$path =~ /\/$/)
	{
		$$path .= '\/';
	}
}


}
#######################################################

sub check_reciproc_hits
{
 # keep only reciproc hits


  use warnings;
  use strict;

  my ($group_seq) = @_;
  my @code = keys %$group_seq;


  foreach my $code (@code)
  {
      while ($$group_seq{$code} =~ /[a-z0-9_]+/ig)
      {
	  my $hit = $&;
	  if ( $$group_seq{$hit} )
	  {
	      if ( $$group_seq{$hit} !~ /$code/ )
	      {
	          $$group_seq{$code} =~ s/$hit//;
 #                 print "$code-$hit is not reciproc\n";
	      }
	  }
	  else
	  {
	     $$group_seq{$code} =~ s/$hit//;
#	     print "$code-$hit is not reciproc\n";   
	  }	 
      }	  
  }

}

#########################################################


sub check_redundants
{
# Check all pairs of $code-$hits for redundancy, uses Clustal for alignement
# only overlaps are considered for counting the pairwise identities, and microsat 
# motifs are eliminated

my ($clustal, $filename, $redlimit, $gap, $Eblast) =@_;
my @code = keys %$clustal;
my $tested_codes = '';
my $redundants = '';
my $idem_pairs = '';

# reads all seqences from the file (seqeunces with microsatellite motifs masqued) into a hachage
my %seq = fasta_into_hachage($filename);

# open outfile for pairwise identities

$filename =~ s/\..*/\.ide/i;
$filename =~ s/.+\//temp\//i;
open (OUTFILE, ">$filename");
print OUTFILE "        SEQ1        SEQ2   idGap idWOgap\n";
  
 for (my $i = 0; $i < scalar(@code); ++$i)
  {
      my $code = $code[$i];
#      print "code:$code\n";
      # examine each hits of a code
      while ($$clustal{$code} =~ /[a-z0-9_]+/ig)
      {
#	  print "$$clustal{$code}\n";
	  my $hit_long = my $hit = $&; 
	  $hit =~ s/Minus//i;
          $hit =~ s/Plus//i;
#	  print "hit_long:$hit_long; hit:$hit\n";

          # eliminate $code of already tested pairs
	  if (($hit eq $code) or ($tested_codes =~ $hit) or ($redundants =~ $hit) or ($redundants =~ $code))
	  {
	      next;
	  } 

	  #Make fasta files with pairs of sequences, Takes into account the strand
	  my %temp_hach = ();
          $temp_hach{$code} = $seq{$code};
	  if ( $hit_long =~ /Minus/i )
	  {
	      my $temp = $seq{$hit};
#	      print "minus:$temp\n";
	      $temp_hach{$hit} = reverse_complement($temp);
#	      print "minus:$temp_hach{$hit}\n";
	  }
	  else
	  {
	      $temp_hach{$hit} = $seq{$hit};
#	      print "plus:$temp_hach{$hit}\n";
	  }
# cut out MS to avoid errors in Clustal is length is very different
	  while ( $temp_hach{$hit} =~ /N{8,}/ig )
	  {
	      my $Ns = $&;
	      $temp_hach{$hit} =~ s/$Ns//;
	  }
	  while ( $temp_hach{$code} =~ /N{8,}/ig )
	  {
	      my $Ns = $&;
	      $temp_hach{$code} =~ s/$Ns//;
	  }

#	  $filename =~ s/\..*//;
#	  $filename .= '.'.$code.$hit;
#	  print "$filename\n";
	  make_fasta_file(\%temp_hach, 'temp/clustinp');
	  call_clustalw('script_file');


	  
          # calculate identity returns 1 if identity is greater than 0.95
	  my ($booleen, $identityGap, $identityWOgap) = calculate_identity('temp/clustinp.aln', $redlimit, $gap, $Eblast);
          if ($booleen == 1)
	  {
	      if ( length $temp_hach{$hit} > length $temp_hach{$code} )
	      {
		  $redundants .= ' '.$code;
		  $idem_pairs .= ' '.$code.'-'.$hit;
	      }
	      else
	      {
		  $redundants .= ' '.$hit;
		  $idem_pairs .= ' '.$hit.'-'.$code;
	      }   
	  }  
	  printf OUTFILE "%12s%12s   %5.3f   %5.3f\n",
          $code, $hit, $identityGap, $identityWOgap;	 

#§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§
### If differences in the length of the sequences big, the aligment can be bad
# make a fasta file with the two sequences and a blast one againts the other 

#  my $bp_seq1 = length $temp_hach{$code};
#  my $bp_seq2 = length $temp_hach{$hit};
#  print "$bp_seq1-$bp_seq2 ";

#  my $diff_length = $bp_seq1 - $bp_seq2;
#  print "$diff_length  ";

# if (  (($diff_length > 500) or ($diff_length < -500)) and $booleen != 1 )
#  {
#      my $new_file =  'temp/'.$code.'_'.$hit.'.fas';
#      print "$new_file\n";
#      call_rename('temp/clustinp', $new_file);  
#      call_blast($new_file, $Eblast);
#      delete_blast_file('temp/');
#  }


#§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§
      }
      $tested_codes .= ' '.$code;
   }

close OUTFILE;

return ($redundants, $idem_pairs);
}


#########################################################


sub check_vector_MS_pos
{
#check if vector is situated before or after the microsat
# returns 0 if vector is before the Ms and 1 if after

    my ($HSPbeg, $HSPend, $MSbeg, $MSend, $code, $vector) = @_;
   
    if ( ($HSPend <= $MSbeg) and ($HSPbeg <= $MSbeg) )
      {
	return 0;
      }
    elsif ( ($HSPend >= $MSend) and ($HSPbeg >= $MSend) )
      {
	return 1;
      }
    else
      {
	   print "Overlap between Microsat in $code and Vector $vector\n";
	   return 2;
      }
      
}



#################################################################

sub chr_into_xxx_lenght_frangments
{
 my ($hash, $empty, $fragment_length, $source) = @_;

 my @table_out = @$empty;
 my @pos = sort { $a <=> $b } keys %$hash;

foreach my $pos (@pos)
{
    for (my $i = int($pos/$fragment_length); $i < $$hash{$pos}/$fragment_length; ++$i)
    {
	$table_out[$i] = 1;
    }   
} 


return @table_out;
}
#########################################################################

sub clean_file_1
{
 # delete empty lines and concatanate the diff lines of each sequences, put sequence into a hachage
  use warnings;
  use strict;
  my @seq = @_;
  my %seq_hach = ();
  my @code = ();
  my $code = '';
  my $temp = '';

#  reads table into a hachage; sequence names are the codes sequences are the values
  while (@seq)
  {
      my $seq = shift(@seq);
      if ($seq =~ /^>[a-z0-9]+/i)
      {
	  $code = $&;
	  $code =~ s/>//;
   # change code into three letter three numbers code
	  $code =~ /[0-9]+/;

	  if (length $& == 1)
	  {
	      $temp = '00'.$&;
	      $code =~ s/$&/$temp/;
	  }
	  elsif (length $& == 2 )
	  {
	      $temp = '0'.$&;
              $code =~ s/$&/$temp/;
	  }


	  push (@code, $code);
      }
      else
      {
	  $seq_hach{$code} .= $seq;
      }
  }

  foreach my $code (@code)
  {
      $seq_hach{$code} =~ s/\s//sg;
  }

  return %seq_hach;
}

#################################################################
sub comb_step_and_ms_detail
{
my ($outfile, $chr, $ms) = @_;
my @int = sort {$a <=> $b} keys %$chr;

open (OUT, ">$outfile");

print OUT "int_beg;int_end;repeat;gene;mRNA;CDS;miscRNA;miscfea;STS;snRNA;tRNA;snoRNA;scRNA;rRNA;gap;MS_length;tranp_RM;RNA_RM;SatelliteRM;mono_ms_length;mono_class;di_ms_length;di_class;tri_ms_length;tri_class;tetra_ms_length;tetra_class;penta_ms_length;penta_class;hexa_ms_length;hexa_class;\n";


foreach my $int (@int)
{
    print OUT "$int;$$chr{$int}";
    if (exists $$ms{$int})
    {
	print OUT "$$ms{$int};\n";
    }
    else
    {
	print OUT "0;-1;0;-1;0;-1;0;-1;0;-1;0;-1;\n"
    }
}

close OUT;
}
#######################################################################

sub copie_hachage
{
# makes a copie of a hachage

my ($hachage, $hachage_copie) = @_;
my @code = keys %$hachage;

foreach my $code (@code)
{
    $$hachage_copie{$code} = $$hachage{$code};
}

}

#####################################################################

sub correct_code
{
# add 0 into the code to ave the three letter Three number code

my ($code_noncorr) = @_;

my %code = ();
@code_noncorr = keys %$code_noncorr;

foreach my $code_non (@code_noncorr)
{
    my $count = 6 - length $code_non;
    my $code = uc $code_non;
    if ($count == 1)
    {
	substr($code, 3, 0, '0');	
    }
    elsif ($count == 2)
    {
	substr($code, 3, 0, '00');
    }
    $code{$code} = $$code_noncorr{$code_non};
}

#print_hachage(\%$code1);
return (%code);

}

########################################################################

sub correct_for_non_reciproc
{
 my ($group_seq, $clas_seq) = @_;
 my @code = keys %$group_seq;
 
 foreach my $code (@code)
 {
     my @data = split ( ' ', $$group_seq{$code});
     if (scalar @data < 2 )
     {
	 $$clas_seq{$code} = 'independent';
     }
 }


}

####################################################################
sub clean_seq_from_vector
{
    my ($vector_beg, $vector_end, $seqtemp) = @_;
    if ( $vector_end < 100000 )
    {
	$seqtemp = substr($seqtemp, 0, $vector_end);
    }
    if ( $vector_beg > 0 )
    {
	$seqtemp = substr($seqtemp, $vector_beg, length($seqtemp)-$vector_beg);
    }	
  return $seqtemp;
}


################################################################

sub collect_group_index
{
  my ($group_index) = @_;

  unless ( open(GROUP,'temp/bootstrap.clas'))
    {
      print "Cannot open temp/bootstrap.clas\n";
      exit;
    }
  my (@data) = <GROUP>;
  close(GROUP);


  foreach my $data (@data)
  {
      $data =~ /[a-z0-9]+/i;
      my $code = $&; 

      if ($data =~ /\s+independent/ )
      {
	  $$group_index{$code} .= '0';
      }
      elsif ($data =~ /\s+group/ )
      {
	  $$group_index{$code} .= '1';
      }
  }




}

###############################################################

sub comb_clas_and_group_seq_wo_red
{

# put all info into clas_seq; is eiter CSS, indep, grouped (in the "first coloumn of value"). If grouped put all reciproc hits produced by the sequence in the "second coloumn of value"

 my ($clas_seq, $group_seq) = @_;

 my @codes = sort (keys %$clas_seq);

 foreach my $code (@codes)
 {
     if ( exists $$group_seq{$code} )
     {
	  $$clas_seq{$code} .= ';'.$$group_seq{$code};
     }
     else
     {
	 $$clas_seq{$code} .= ';';
     }
 }

}

###############################################################

sub comb_clas_and_group_seq
{

# put all info into clas_seq; is eiter CSS, indep, idem, or grouped. If grouped put all reciproc hits produced by the sequence

 my ($clas_seq, $group_seq) = @_;

 my @codes = sort (keys %$clas_seq);

 foreach my $code (@codes)
 {
     if ( exists $$group_seq{$code} )
     {
	 unless ( $$group_seq{$code} =~ /redundant/i )
         {
		 $$clas_seq{$code} = $$group_seq{$code};
         }
     }
 }

}

################################################################

sub comb_hashages
{
    my ($outfile1,$source, $repeat, $gene, $mRNA, $CDS, $miscRNA, $miscfea, $STS, $snRNA, $tRNA, $snoRNA, $scRNA, $rRNA, $gap) = @_;

    open (OUTFEA, ">$outfile1");
    for ( my $i = 1; $i < $source ; ++$i)
    {
	if ( exists $$repeat{$i} )
	{
	    print OUTFEA "$i;$$repeat{$i};repeat_region;\n";
	}
	if ( exists $$gene{$i} )
	{
	    print OUTFEA "$i;$$gene{$i};gene;\n";
	}
	if ( exists $$mRNA{$i} )
	{
	    print OUTFEA "$i;$$mRNA{$i};mRNA;\n";
	}
	if ( exists $$CDS{$i} )
	{
	    print OUTFEA "$i;$$CDS{$i};CDS;\n";
	}
	if ( exists $$miscRNA{$i} )
	{
	    print OUTFEA "$i;$$miscRNA{$i};miscRNA;\n";
	}
	if ( exists $$miscfea{$i} )
	{
	    print OUTFEA "$i;$$miscfea{$i};misc_fea;\n";
	}
	if ( exists $$STS{$i} )
	{
	    print OUTFEA "$i;$$STS{$i};STS;\n";
	}
	if ( exists $$snRNA{$i} )
	{
	    print OUTFEA "$i;$$snRNA{$i};snRNA;\n";
	}
	if ( exists $$tRNA{$i} )
	{
	    print OUTFEA "$i;$$tRNA{$i};tRNA;\n";
	}
	if ( exists $$snoRNA{$i} )
	{
	    print OUTFEA "$i;$$snoRNA{$i};snoRNA;\n";
	}
	if ( exists $$scRNA{$i} )
	{
	    print OUTFEA "$i;$$scRNA{$i};scRNA;\n";
	}
	if ( exists $$rRNA{$i} )
	{
	    print OUTFEA "$i;$$rRNA{$i};rRNA;\n";
	}
	if ( exists $$gap{$i} )
	{
	    print OUTFEA "$i;$$gap{$i};gap;\n";
	}

    }
    print OUTFEA "$source;;END";

    

}

################################################################

sub comb_hashages_short
{
    my ($outfile1,$source, $repeat, $gene, $mRNA, $CDS, $gap) = @_;

    open (OUTFEA, ">$outfile1");
    for ( my $i = 1; $i < $source ; ++$i)
    {
	if ( exists $$repeat{$i} )
	{
	    print OUTFEA "$i;$$repeat{$i};repeat_region;\n";
	}
	if ( exists $$gene{$i} )
	{
	    print OUTFEA "$i;$$gene{$i};gene;\n";
	}
	if ( exists $$mRNA{$i} )
	{
	    print OUTFEA "$i;$$mRNA{$i};mRNA;\n";
	}
	if ( exists $$CDS{$i} )
	{
	    print OUTFEA "$i;$$CDS{$i};CDS;\n";
	}
	if ( exists $$gap{$i} )
	{
	    print OUTFEA "$i;$$gap{$i};gap;\n";
	}

    }
    print OUTFEA "$source;;END";

    

}

####################################################################

sub comb_hachages_into_bp_file_2
{
 my ($outchr, $source, $repeat, $gene, $mRNA, $CDS, $gap) = @_;
 my %chr = ();
unless (open (OUT, ">$outchr"))
{ print "Cannot open $outchr\n";
exit;
}


#print_hachage(\%$CDS);


my @gene = sort {$a <=> $b} keys %$gene;
my @mRNA = sort {$a <=> $b} keys %$mRNA;
my @CDS = sort {$a <=> $b} keys %$CDS;
my @gap = sort {$a <=> $b} keys %$gap;
my @repeat = sort {$a <=> $b} keys %$repeat;

push (@gene, $source+1);
push (@mRNA, $source+1);
push (@CDS, $source+1);
push (@gap, $source+1);
push (@repeat, $source+1);

my $gene_code = shift @gene;
my $mRNA_code = shift @mRNA;
my $CDS_code = shift @CDS;
my $gap_code = shift @gap;
my $repeat_code = shift @repeat;

print_hachage_into_file_number(\%$repeat, 'temp1/repeat.txt');
print_hachage_into_file_number(\%$gap, 'temp1/gap.txt');
print_hachage_into_file_number(\%$gene, 'temp1/gene.txt');
print_hachage_into_file_number(\%$mRNA, 'temp1/mRNA.txt');
print_hachage_into_file_number(\%$CDS, 'temp1/CDS.txt');

my $line = '';

  for (my $i = 1; $i < $source+1; ++$i)
  {
      $line = '';
my $gap_ = 0;
my $CDS_ = 0;
my $mRNA_ = 0;
my $gene_ = 0;

# test repeat
      if (($repeat_code-1 < $i) and ($i < $$repeat{$repeat_code}+1))
      {
#	  print OUT "$repeat_code-$$repeat{$repeat_code} ";
	      $line = '1;';
	      if ($i == $$repeat{$repeat_code})
	      {
		      $repeat_code = shift @repeat;
	      }
      }
      else
      {
#	  print OUT "norep$i ";
	  $line = '0;';
      }
#test gap, gene, mRNA, CDS 
      if (($gap_code-1 < $i) and ($i < $$gap{$gap_code}+1))
      {
#	  print OUT "gap$i\n";
	      $gap_ = -1;
	      if ($i == $$gap{$gap_code})
	      {
		      $gap_code = shift @gap;
	      }
      }
      if (($CDS_code-1 < $i) and ($i < $$CDS{$CDS_code}+1))
      {
#	  print OUT "CDS$i\n";
#	      print "3";
	      $CDS_ = 3;
	      if ($i == $$CDS{$CDS_code})
	      {
		      $CDS_code = shift @CDS;
	      }
      }

      if (($mRNA_code-1 < $i) and ($i < $$mRNA{$mRNA_code}+1))
      {
#	  print OUT "mRNA$i\n";
#	      print "2";
	      $mRNA_ = 2;
	      if ($i == $$mRNA{$mRNA_code})
	      {
		      $mRNA_code = shift @mRNA;
	      }
      }

      if (($gene_code-1 < $i) and ($i < $$gene{$gene_code}+1))
      {
#	  print OUT "gene$i\n";
#	      print "1";
	      $gene_ = 1;
	      if ($i == $$gene{$gene_code})
	      {
		      $gene_code = shift @gene;
	      }
      }

if ($gap_ == -1)
{$line .= '-1;';}
elsif ($CDS_ == 3)
{$line .= '3;';}
elsif ($mRNA_ == 2)
{$line .= '2;';}
elsif ($gene_ == 1)
{$line .= '1;';}
else
{$line .= '0;';}

print OUT "$i;$line\n";	  
      
  }


}



###################################################################
sub comb_ms_feature_pos_into_file
{
 my ($ms_chr, $feature_chr, $filename) = @_;

my @chr_sort = keys %$ms_chr;
 my @chr_feature = keys %$feature_chr;

 open (OUTFILE, ">$filename");

#makes one table with first pos of all ms and all features
foreach my $feature (@chr_feature)
{
    push (@chr_sort, $feature);
}
@chr_sort = sort {$a <=> $b} @chr_sort; 


for (my $i = 0; $i < scalar @chr_sort; ++$i)
{
    if ($chr_sort[$i] == $chr_sort[$i-1])
    {
	next;
    }
    if (exists $$feature_chr{$chr_sort[$i]})
    {
	print OUTFILE "$chr_sort[$i];$$feature_chr{$chr_sort[$i]}\n";
    }
    if (exists $$ms_chr{$chr_sort[$i]})
    {
	print OUTFILE "$chr_sort[$i];$$ms_chr{$chr_sort[$i]}\n";
#	my @ms = split ( ';', $$ms_chr{$chr_sort[$i]});
#	my $j = $i-1;
#	do 
#	{
#	    my @feat = split ( ';', $$feature_chr{$chr_sort[$j]});
#	    my $j = $j-1;
#	}
#	while ($feat[1] =~ /[0-9]/)
#	if ($ms[0] < $feat[0])
#        {
	    
#	}
    }   
}

close OUTFILE;

}

####################################################################

sub comb_ms_feature_step
{
my ($hach_ms, $hach_fe, $filename) =@_;

my @codes = sort {$a <=> $b} keys %$hach_ms;
my @steps = sort {$a <=> $b} keys %$hach_fe;
#print "@steps\n";
my @table_ms = ();
#print " $steps[1] - $steps[0]\n";
my $step_bp = $steps[1] - $steps[0];

for ($k=0; $k < scalar @steps; ++$k)
{
    $table_ms[$k] = 0;
}

foreach my $code (@codes)
{
    my $i = int($code/$step_bp);
    my $i_end = int($$hach_ms{$code}/$step_bp);
    if ( $i == $i_end)
    {
	$table_ms[$i] += $$hach_ms{$code} - $code +1;
    }
    else
    {
	$table_ms[$i] += ($i+1)*$step_bp - $code;
	for ( my $j = $i+1 ; $j < $i_end; ++$j )
	{
	    $table_ms[$j] += $step_bp;
	}
	$table_ms[$i_end] += $$hach_ms{$code} - $i_end*$step_bp +1;
    } 
}

open (OUT, ">$filename");
print OUT "int_beg;int_end;repeat;gene;mRNA;CDS;miscRNA;miscfea;STS;snRNA;tRNA;snoRNA;scRNA;rRNA;gap;MS_length\n";
foreach my $step (@steps)
{
    my $index = $step/$step_bp;
    print OUT "$step;$$hach_fe{$step}$table_ms[$index];\n";
}

close OUT;

}
####################################################################

sub correct_redundants
{
  my ($clas_seq, $group_seq, $redundants, $idem_pairs) = @_;
  my @code = keys %$group_seq;

  while ( $redundants =~ /[a-z0-9_]+/ig )
  {
      my $redundant_code = $&;
      $idem_pairs =~ /$redundant_code-[^\s]+/;
      my $idem = $&;
      $idem =~ s/$redundant_code-//;
      $$clas_seq{$redundant_code} = 'IDEM_'.$idem;
      $$group_seq{$redundant_code} = 'REDUNDANT';
      foreach my $code (@code)
      {
	  $$group_seq{$code} =~ s/\s$redundant_code//; 
      }      

# change seq into independent if all memeber of the group but one became redundant
      foreach my $code (@code)
      {
	     unless ($$group_seq{$code} =~ /(\s[a-z0-9_]+){2,}/i)
	     {
		 unless ($$group_seq{$code} =~ /REDUNDANT/)
		 {
		   $$clas_seq{$code} = 'INDEPENDENT';
		   $$group_seq{$code} = 'INDEPENDENT';
	         }
	     }
      }
  }
}


##############################################################

sub count_classes
{
 my ($clas_seq) = @_;
 my @code = keys %$clas_seq;
 my $count_CSS = 0;
 my $count_indep = 0;
 my $count_group = 0;
 my $count_redundant = 0;

 foreach my $code (@code)
 {
     if ( $$clas_seq{$code} =~ /CSS/i )
     {
	 ++$count_CSS;
     }
     elsif ( $$clas_seq{$code} =~ /indep/i )
     {
	 ++$count_indep;
     }
     elsif ( $$clas_seq{$code} =~ /idem/i )
     {
	 ++$count_redundant;
     }    
     else
     {
	 ++$count_group;
     }
 }
 my $non_CSS_red = $count_indep + $count_group;
 my $total = $non_CSS_red + $count_CSS + $count_redundant;
 my $prop_group = 0;

 if ( $non_CSS_red > 0 )
 {
     $prop_group = $count_group/$non_CSS_red;
 }

 return ($count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group);

}

##############################################################

sub count_classes_wo_red
{
 my ($clas_seq) = @_;
 my @code = keys %$clas_seq;
 my $count_CSS = 0;
 my $count_indep = 0;
 my $count_group = 0;
 
 foreach my $code (@code)
 {
     if ( $$clas_seq{$code} =~ /CSS/i )
     {
	 ++$count_CSS;
     }
     elsif ( $$clas_seq{$code} =~ /indep/i )
     {
	 ++$count_indep;
     }
     else
     {
	 ++$count_group;
     }
 }
 my $total = $count_indep + $count_group + $count_CSS;
 my $prop_group = 0;

 if ( ($count_indep + $count_group) > 0 )
 {
     $prop_group = $count_group/($count_indep + $count_group);
 }

 return ($count_CSS, $count_indep, $count_group, $total, $prop_group);

}

###############################################################

sub count_group_index
{
my ($group_index) = @_;

my (@code) = keys %$group_index;

  foreach my $code (@code)
  {
      my $group = 0;
      my $n = length $$group_index{$code};
      while ( $$group_index{$code} =~ /1/g )
      {
	  ++$group;
      }
      my $index = $group/$n;
      $index = int(($index*100)+0.5)/100;
      $$group_index{$code} = $index.';'.$n;
  }


}

###############################################################

sub count_rf_length
{
  my ($filename) = @_;
  my (%length) = ();

  my (%seq_hach) = fasta_into_hachage($filename);

  my (@code) = keys %seq_hach;

  foreach my $code (@code)
  {
      my $seq = $seq_hach{$code};
      my @seq = split('',$seq);
      my $compteur = 0;
      foreach my $base (@seq)
      {
	  if ($base eq 'A' or $base eq 'T' or $base eq 'C' or $base eq 'G')
	  {
	      ++$compteur;
	  }
      }
      $length{$code} = $compteur;
  }

  return (%length);
}

#################################################

sub count_total_length
{
# hash key is a first pos, value is a last pos of feature
# calculate the total length of the feature in the genome

    my ($hash) = @_;
    my @codes = sort {$a <=> $b}(keys %$hash);
    my $total_length = 0;
    my $last_pos_buffer = 0;


    foreach my $code (@codes)
    {
	if ( $code > $last_pos_buffer )
	{
#	    print "$last_pos_buffer\n";
	    $total_length = $total_length + $$hash{$code} - $code +1;
        }
	else
	{
	    $total_length = $total_length + $$hash{$code} - $last_pos_buffer;
	}
	$last_pos_buffer = $$hash{$code};
    }

    return ($total_length);
}



################################################################
sub delete_Ns
  {
  use warnings;
  use strict;
    my ($seq_hach) = @_;
    my @code = keys %$seq_hach;
    my @seq = values %$seq_hach;
    my $n = 0;
    my %N_hach = ();

   foreach my $code (@code)
     {
       my $seq = $$seq_hach{$code}; 
       my $orig_length = length($seq);
       # delete ininterrupted Ns at the begining
       $seq =~ s/^N*//g;
      
       # if more than 2 Ns in the 10 bp at the begining delete positions till 
       # N (included), but keep ATGC
      
       do
         {
            $n = 0;
            my $windowbeg = substr ($seq, 0, 10);
            my @windowbeg = split('', $windowbeg);
  
            for (my $j = 0; $j < 10; ++$j)
               {
	          if ($windowbeg[$j] eq 'N' )
	          {
		    ++$n;
	          }
               }
            if ($n > 2)
	      {
	          $windowbeg =~ /[ACTG]*$/;
	          $windowbeg = $&; 
	      } 
            substr ($seq, 0, 10, $windowbeg);
	 } until ($n < 3);
       #count the number of bases cut at the beginning
       my $beg = $orig_length-length($seq);

       # if more than 2 Ns in the 10 bp at the end, delete positions beween the first
       # N (included) and the end

    # delete ininterrupted Ns at the end
       $seq =~ s/N*$//g;
       do
         {
            $n = 0;
            my $window = substr ($seq, length($seq)-10, 10);
            my @window = split('', $window);
  
            for (my $j = 0; $j < 10; ++$j)
               {
	          if ($window[$j] eq 'N' )
	          {
		    ++$n;
	          }
               }
            if ($n > 2)
	      {
	          $window =~ /^[ACTG]*/;
	          $window = $&; 
	      } 
            substr ($seq, length($seq)-10, 10, $window);
	 } until ($n < 3);
       #count the number of bases cut at the end
       my $end =  $orig_length-length($seq)- $beg;
       $N_hach{$code} .= "$beg $end";

        $$seq_hach{$code} = $seq;
    }
#  print "The number of bases deleted from the begining and from the end of the file are strored in N_hach\nseq_hach is over-written with the shortened sequences\n";
   return (%N_hach);
 }

####################################################################

sub delete_seq_WOmicrosat
{
    my ($seq_hach, $ms_hachage) = @_;
    my @code = keys %$seq_hach;
    my %seg_hach_WOmicrosat = ();


    foreach my $code (@code)
    {
	if ($$ms_hachage{$code} =~ /[0-9]/)
	{
	    $seq_hach_WOmicrosat{$code} = $$seq_hach{$code};
	}	
    }
    return %seq_hach_WOmicrosat;
}


######################################################################

sub delete_file
{
    my ($filename) = @_;

      my $del = 'rm '.$filename;
#    print "$del\n";
      system $del;
}

######################################################################

sub delete_file_win
{
    my ($filename) = @_;

# !!!!!!!!!!!!!!!!!check if it works all rigth
        $filename =~ s/\//\\/;
#     $filename =~ /.*\//;
#     my $temp = $&;
#     $temp =~ s/\///;

      my $del = 'del '.$filename;
#    print "$del\n";
      system $del;
}



######################################################################

sub delete_files
{
  my (@filenames) = @_;

  foreach my $filename (@filenames)
  {
      my $del = 'rm '.$filename;
      system $del;
  }
}

######################################################################

sub delete_all_files_in_folder
{
  my ($folder) = @_;

      my $del = 'rm '.$folder.'/*';
      system $del;

}


######################################################################

sub delete_blast_txt
{
  my ($folder) = @_;


  my $txt = 'rm '.$folder.'*.txt';
 
    system $txt;

}


######################################################################

sub delete_temp_file
{
  my ($folder) = @_;


  my $boot = 'rm '.$folder.'bootstrap.*';
  my $clustinp = 'rm '.$folder.'clust*';
  my $won = 'rm '.$folder.'*.WON';
  my $blast = 'rm '.$folder.'*.*.*';

    system $boot;
    system $clustinp;
    system $won;
    system $blast;

}

######################################################################

sub delete_blast_temp_files
{
  my ($folder) = @_;

  my $blast = 'rm '.$folder.'/*.*.*';
    system $blast;
}

######################################################################

sub delete_blast_temp_files1
{
  my ($folder) = @_;

  my $blast = 'rm '.$folder.'/*.nsq';
    system $blast;
  $blast = 'rm '.$folder.'/*.nsi';
    system $blast;
  $blast = 'rm '.$folder.'/*.nsd';
    system $blast;
  $blast = 'rm '.$folder.'/*.nin';
    system $blast;
  $blast = 'rm '.$folder.'/*.nhr';
    system $blast;
}

######################################################################

sub delete_blast_temp_files_win1
{
  my ($folder) = @_;

  my $blast = 'del '.$folder.'\*.nsq';
    system $blast;
  $blast = 'del '.$folder.'\*.nsi';
    system $blast;
  $blast = 'del '.$folder.'\*.nsd';
    system $blast;
  $blast = 'del '.$folder.'\*.nin';
    system $blast;
  $blast = 'del '.$folder.'\*.nhr';
    system $blast;



}

######################################################################

sub delete_files_motif
{
  my ($folder, $motif) = @_;

  my $del = 'rm '.$folder.'/*'.$motif;
#  print "$del\n";
    system $del;


}

######################################################################

sub delete_files_motif_win
{
  my ($folder, $motif) = @_;

  my $del = 'del '.$folder.'\*'.$motif;
#  print "$del\n";
    system $del;


}

######################################################################

sub delete_blast_file
{
  my ($folder) = @_;


#  my $boot = 'rm '.$folder.'bootstrap.*';
#  my $clustinp = 'rm '.$folder.'clust*';
#  my $won = 'rm '.$folder.'*.WON';
  my $blast = 'rm '.$folder.'*.*.*';

#    system $boot;
#    system $clustinp;
#    system $won;
    system $blast;

}

######################################################################

sub delete_temp_gb_file
{
  my ($folder) = @_;


  my $boot = 'rm '.$folder.'bootstrap.*';
  my $clustinp = 'rm '.$folder.'clust*';
#  my $won = 'rm '.$folder.'*.WON';
#  my $blast = 'rm '.$folder.'*.*.*';

    system $boot;
    system $clustinp;
#    system $won;
#    system $blast;

}


#####################################################################

sub delete_win_linux
{
my ($file, $folder, $syst) = @_;
my $del = '';
if ($syst eq 'win')
{
   $del =  'del '.$folder.'\\'.$file;
}
elsif ($syst eq 'linux')
{
    $del = 'rm '.$folder.'/'.$file; 
}
system $del;
}

##############################################################""

sub extract_accession
{
     my ($block) = @_;

     $block =~ /^ACCESSION.*$/m;
     my $accession = $&;
     $accession =~ /[A-Z0-9]+$/;
     $accession = $&;

     $block =~ /ORGANISM.*?REFERENCE/s;
     my $taxon = $&;
     $taxon =~ /ORGANISM.*$/m;
     my $species = $&;
     $species =~ s/ORGANISM\s+//;
     $species =~ s/$//;
    
     $taxon =~ s/REFERENCE//;
     $taxon =~ /.+Insecta;/s;
     $taxon =~ s/$&//;
     $taxon =~ s/\s//g;

     my @authors = ();
     while ( $block =~ /^\s+AUTHORS.*$/mg )
     {
	 my $authors = $&;
	 $authors =~ /\s+AUTHORS\s+/;
	 $authors =~ s/$&//;
	 $authors =~ s/,/;/g;
	 push (@authors, $authors);
     }
  
      my @journal = ();
     while ( $block =~ /^\s+JOURNAL.*$/mg )
     {
	 my $journal = $&;
	 $journal =~ /\s+JOURNAL\s+/;
	 $journal =~ s/$&//;
	 $journal =~ s/,/;/g;
	 push (@journal, $journal);
     }
        

     $block =~ /ORIGIN.*/s;
     my $seq = $&;
     $seq =~ s/[^a-z]//g;

     if (scalar@authors < 2 )
     {
	 $authors[1] = '*******';
	 $journal[1] = '*******';
     }
    
  return ($accession, $species, $taxon, $seq, $authors[0], $authors[1], $journal[0], $journal[1] );
     

}
     
###################################################################

sub extract_codes
{
 my ($filename) = @_;
# print "$filename\n";
 my $codes = '';
    unless (open (FILE, "$filename"))
    {
	print "Cannot open $filename!";
    }
    my @data = <FILE>;
    close (FILE);  
# print "@data\n";

 foreach my $ligne (@data)
 {
     if ($ligne =~ /^>.+/ )
     {
	 $codes .= $&;
     }
 }

 $codes =~ s/>//;
 $codes =~ s/>/_/g;

 return $codes;
}

#############################################################

sub extract_feature_pos
{

my ($data, $feature_motif, $feature) = @_;

my   $i = 0;
my %feature_temp = ();
    while ($data =~ /$feature_motif.+?\//ig)
    {
	++$i;
	my $pos = $&;
	while ( $pos =~ /[0-9]+\.{2}>*[0-9]+/g)
	{
	    my $beg_end = $&;
	    $beg_end =~ s/[0-9]+//;
	    my $beg = $&;
	    $beg_end =~ /[0-9]+/;
	    my $end = $&;
	    if (exists $feature_temp{$beg} and $end < $feature_temp{$beg} )
	    {
		next;
	    }
	    $feature_temp{$beg} = $end;
	}	
    }
my @pos = sort {$a <=> $b}keys %feature_temp;
my $booleen = 0;

#merges overlaping regions
for (my $i=1; $i < scalar @pos; ++$i )
{
    if ( ($pos[$i] - $feature_temp{$pos[$i-1]} < 2) and ($feature_temp{$pos[$i]} > $feature_temp{$pos[$i-1]}) )
    {
	$feature_temp{$pos[$i-1]} = $feature_temp{$pos[$i]};
	$pos[$i] = -1;
	@pos = sort { $a <=> $b }@pos;
	$booleen = 1;
    }
}

if ($booleen == 0)
{
    %$feature = %feature_temp;
}
else
{
    foreach my $pos (@pos)
    {
	if ($pos > 0)
	{
	    $$feature{$pos} = $feature_temp{$pos};
	}
    }
}
#print "$booleen\n";


}

#############################################################

sub extract_feature_pos_1
{

my ($data, $feature_motif, $feature) = @_;

my   $i = 0;
my %feature_temp = ();
    while ($data =~ /$feature_motif.+?\//ig)
    {
	++$i;
	my $pos = $&;
	while ( $pos =~ /[0-9]+\.{2}>*[0-9]+/g)
	{
	    my $beg_end = $&;
	    $beg_end =~ s/[0-9]+//;
	    my $beg = $&;
	    $beg_end =~ /[0-9]+/;
	    my $end = $&;
	    if (exists $feature_temp{$beg} and $end < $feature_temp{$beg} )
	    {
		next;
	    }
	    $feature_temp{$beg} = $end;
	}	
    }
my @pos = sort {$a <=> $b}keys %feature_temp;
my $booleen = 0;

#merges overlaping regions
for (my $i=1; $i < scalar @pos; ++$i )
{
# patial overlap
    if ( ($pos[$i] - $feature_temp{$pos[$i-1]} < 2) and ($feature_temp{$pos[$i]} > $feature_temp{$pos[$i-1]}) )
    {
	$feature_temp{$pos[$i-1]} = $feature_temp{$pos[$i]};
	$pos[$i] = -1;
	@pos = sort { $a <=> $b }@pos;
	$booleen = 1;
    }
# complet overlap (second interval is shorter)
    elsif ( ($pos[$i] - $feature_temp{$pos[$i-1]} < 2) and ($feature_temp{$pos[$i]} < $feature_temp{$pos[$i-1]}+1) )
    {
	$pos[$i] = -1;
	@pos = sort { $a <=> $b }@pos;
	$booleen = 1;
    }
}

%$feature = ();
# if no overlap at all
if ($booleen == 0)
{
    %$feature = %feature_temp;
}
# at least one overlap
else
{
    foreach my $pos (@pos)
    {
	if ($pos > 0)
	{
	    $$feature{$pos} = $feature_temp{$pos};
	}
    }
}
#print "$booleen\n";


}

###############################################################

sub extract_first_positions_on_chr
{
    my($positions, $Nseq_pos, $gap_pos) = @_;

    foreach my $ligne (@$positions)
    {
	my @data = split(';', $ligne);
	my $code = $data[0];
	if ($code =~ /[a-z]+_[0-9]+_[0-9]N/i)
	{
	    $$Nseq_pos{$code} = $data[1];
	}
	else
	{
	    $$gap_pos{$code} = $data[1];
	}
    }

}

#####################################################################

sub extract_info
{
 my ($ligne) = @_;

 my $code =  substr($ligne, 0, 9);
 my $non_ACGT =  substr($ligne, 19, 9);
 my $vec_beg =  substr($ligne, 55, 9);
 my $vec_end =  substr($ligne, 73, 9);
 my $longeur = substr($ligne, 81, 9);
 my $l_ligne = length $ligne;
 my $microsat = substr($ligne, 92, ($l_ligne - 92));
 $code =~ s/\s//g;
 $longeur =~ s/\s//g;
 $non_ACGT =~ s/\s//g;
 $vec_beg =~ s/\s//g;
 $vec_end =~ s/\s//g;

 my $vector = ''; 
 if ($vec_beg eq 'none' and $vec_end eq 'none')
 {
     $vector = 'no';
 }
 else
 {
     $vector = 'yes';
 }


 return ($code, $non_ACGT, $vector, $longeur, $microsat);

}

################################################################

sub extract_microsat_info_on_chr
{
 my ($microsat_input, $microsat, $Nseq_pos, $seq_pos) = @_;

 shift(@$microsat_input);
 my $code_seq_buffer = 0;
 my $i = 1;
 my $code_ms = 0;
 foreach my $ligne (@$microsat_input)
 {
     my $seq_ms_corr = 0;
     my @ligne = split (';', $ligne);
     my $code_seq = $ligne[0];
     if ( not($code_seq eq $code_seq_buffer))
     {
	 $i = 1;
	 $code_ms = $code_seq.'_001';
	 $seq_ms_corr = 1;
     }
     else
     {
	 $i++;
	 my $temp = 9000 + $i;
	 $temp =~ s/^9/_/;
	 $code_ms = $code_seq.$temp;
	 $seq_ms_corr = 2;
     }
     $code_seq_buffer = $code_seq;

     $code_seq =~ /[a-z]+_[0-9]+_[0-9]+N[0-9]{4}/i;
#     print "$code_seq\n";
     my $code_Nseq = $&;
#     print "$code_Nseq\n";
     $code_seq =~ /[a-z]+_[0-9]+_[0-9]+/i;
     my $code_chr = $&;
#     print "$code_chr\n";
# makes a hachage with sequenes as keys and their first pos. on chr as a value
     unless (exists $$seq_pos{$code_seq})
     {
	 $$seq_pos{$code_seq} = $$Nseq_pos{$code_Nseq} + $ligne[1] -1;
     }
     my $first_pos = $ligne[2] + $$Nseq_pos{$code_Nseq} -1;
#     print "$first_pos\n";
     my $last_pos = $ligne[3] + $$Nseq_pos{$code_Nseq} -1;
#     print "$last_pos\n";
     my $ms_length = $last_pos - $first_pos +1;
#     print "$ms_length\n";
     my $motif_length = length($ligne[4]);
#     print "$motif_length\n";
     my $ms_length_rep = $ms_length/$motif_length;
#     print "$ms_length_rep\n";
     chomp $ligne[5];

     $$microsat{$code_ms} = $code_seq.';'.$seq_ms_corr.';'.$code_Nseq.';'.$code_chr.';'.$first_pos.';'.$last_pos.';'.$ms_length.';'.$ms_length_rep.';'.$ligne[4].';'.$ligne[5].';'.$motif_length.';';  
  }

}  
################################################################

sub extract_microsat_info_on_chr_1
{
 my ($ms, $Nseq_pos, $chr, $outfolder) = @_;
 my %microsat = ();
 my $chr_list = '';
 open_file_in($ms, 'IN');
 my $title = <IN>;

 my $code_seq_buffer = 0;
 my $i = 1;
 my $code_ms = 0;
 while (my $ligne = <IN>)
 {
     my $seq_ms_corr = 0;
     my @ligne = split (';', $ligne);
     my $code_seq = $ligne[0];
     if ( not($code_seq eq $code_seq_buffer))
     {
	 $i = 1;
	 $code_ms = $code_seq.'_001';
	 $seq_ms_corr = 1;
     }
     else
     {
	 $i++;
	 my $temp = 9000 + $i;
	 $temp =~ s/^9/_/;
	 $code_ms = $code_seq.$temp;
	 $seq_ms_corr = 2;
     }
     $code_seq_buffer = $code_seq;

     $code_seq =~ /[a-z]+_[0-9]+_[0-9]+N[0-9]{4}/i;
#     print "$code_seq\n";
     my $code_Nseq = $&;
#     print "$code_Nseq\n";
     $code_seq =~ /[a-z]+_[0-9]+_[0-9]+/i;
     my $code_chr = $&;
#     print "$code_chr\n";

     my $first_pos = $ligne[2] + $$Nseq_pos{$code_Nseq} -1;
#     print "$first_pos\n";
     my $last_pos = $ligne[3] + $$Nseq_pos{$code_Nseq} -1;
#     print "$last_pos\n";
     my $ms_length = $last_pos - $first_pos +1;
#     print "$ms_length\n";
     my $motif_length = length($ligne[4]);
#     print "$motif_length\n";
     my $ms_length_rep = $ms_length/$motif_length;
#     print "$ms_length_rep\n";
     chomp $ligne[5];

     $microsat = $code_ms.';'.$code_seq.';'.$seq_ms_corr.';'.$code_Nseq.';'.$code_chr.';'.$first_pos.';'.$last_pos.';'.$ms_length.';'.$ms_length_rep.';'.$ligne[4].';'.$ligne[5].';'.$motif_length.';';  

     	$code_seq =~ /[a-z0-9_]{10}[0-9]+/i;
	my $temp = $&;
	my $chr_short = $$chr{$temp};
	unless ($chr_list =~ /$chr_short/)
	{
	    close OUT;
	    print "$chr_short\n";
	    $chr_list .= ' '.$chr_short;
	    $outfile = $outfolder.'/'.$chr_short.'_ms_info_no_clas.txt';
	    open (OUT, ">$outfile");
	    print OUT "MS_code;Seq_code;1_if_firstMS_in_seq;Nseq_code;Chromosome;1st_pos_MS_on_chr;last_pos_MS_on_chr;MS_length_in_bp;MS_length_in_repeat;MS_motif_orig;MS_motif_traduit;MS motif_length;\n";    
	}
	$microsat =~ s/$temp;/$chr_short;/;
	print OUT "$microsat\n";
   
     
  }

}  


#################################################################

sub extract_ms_length_and_class
{
my ($chr, $ms, $step) = @_;
my $class = 0;

my @ligne = split ( ';', $ms);
my $int_beg = int($ligne[5]/$step)*100;
my $int_end = int($ligne [6]/$step)*100;
my $motif_l = length $ligne[10];

#determine number of hits 
	if ($ligne[12] =~ /independent/i)
	{
	    $class = 1;
	}
	elsif ($ligne[12] =~ /CSS/i)
	{
	    $class = 0;
	}
	else
	{
	    $class = $ligne[13];
	}
# number of bp of microsatellites within the 100 bp interval
	for (my $i = $int_beg; $i < ($int_end+1); $i = $i+100)
	{
	    my $ms_length = 0;
	    if ($int_beg == $int_end)
	    {
		$ms_length = $ligne[6] - $ligne[5] +1;
	    }
	    elsif ( $i == $int_beg)
	    {
		$ms_length = $int_beg +100 - $ligne[5];
	    }
	    elsif ($i == $int_end )
	    {
		$ms_length = $ligne[6] - $int_end +1;
	    }
	    else 
	    {$ms_length = 100;}   

# write info into a hachage (first two colpumn for mono-motif, second two for di...)
	    unless (exists $$chr{$i})
	    {
		$$chr{$i} = ('0;-1;0;-1;0;-1;0;-1;0;-1;0;-1;');
	    } 
	    my @ms_inf = split (';', $$chr{$i});
	    if ($motif_l == 1)
	    {
		$ms_inf[0] = $ms_length;
		$ms_inf[1] = $class;
	    }
	    if ($motif_l == 2)
	    {
		$ms_inf[2] = $ms_length;
		$ms_inf[3] = $class;
	    }
	    if ($motif_l == 3)
	    {
		$ms_inf[4] = $ms_length;
		$ms_inf[5] = $class;
	    }
	    if ($motif_l == 4)
	    {
		$ms_inf[6] = $ms_length;
		$ms_inf[7] = $class;
	    }
	    if ($motif_l == 5)
	    {
		$ms_inf[8] = $ms_length;
		$ms_inf[9] = $class;
	    }
	    if ($motif_l == 6)
	    {
		$ms_inf[10] = $ms_length;
		$ms_inf[11] = $class;
	    }
	    $$chr{$i} = join(';', @ms_inf);
	}

}


##############################################################

sub extract_repeat_masker
{
 my ($data, $data_extr) = @_;
 
 foreach my $ligne (@$data)
 {
     if ($ligne =~ /^\s*[0-9]/ )
     {
	 $ligne =~ s/^\s*//;
	 my @ligne = split ('\s+', $ligne);
	 my $code = $ligne[4];
	 $$data_extr{$code} = $ligne[9].';'.$ligne[10];
#	 print "$code  $$data_extr{$code}\n";
     }

 }


}

#################################################################

sub extract_repeat_masker_genome
{
 my ($data, $RM_extr, $seq_code) = @_;
 
 foreach my $ligne (@$data)
 {
     if ($ligne =~ /^\s*[0-9]/ )
     {
	 $ligne =~ s/^\s*//;
	 my @ligne = split ('\s+', $ligne);
	 my $code = $ligne[4];
	 if ( ($ligne[10] eq 'Low_complexity') or ($ligne[10] eq 'Simple_repeat'))
	 {
	     next;
	 }
	 my $hit_first_pos = $ligne[5] + $$seq_code{$code} -1;
	 my $hit_last_pos = $ligne[6] + $$seq_code{$code} -1;
	 unless (exists $$RM_extr{$code})
	 {
	     $$RM_extr{$code} = $ligne[9].';'.$ligne[10].';'.$hit_first_pos.';'.$hit_last_pos.';';
#	     print "$code  $$data_extr{$code}\n";
         }
	 else
	 {
	     $$RM_extr{$code} .= $ligne[9].';'.$ligne[10].';'.$hit_first_pos.';'.$hit_last_pos.';';
	 }
     }

 }


}

#################################################################

sub extract_repeat_masker_short
{
    my ($RM_extr, $RM_short ) = @_;
    my @codes = sort (keys %$RM_extr);

    foreach my $code (@codes)
    {
	my $ligne = $$RM_extr{$code};
	my @ligne = split ( ';', $ligne);
	my $number_of_hits = scalar@ligne/4;
	$$RM_short{$code} = $number_of_hits.';'.$ligne[0].';'.$ligne[1].';'.$ligne[2].';'.$ligne[3].';';
    }


}
#################################################################

sub extract_sequence_code
{
    my ($res_seq) = @_;
    $$res_seq =~ /^Query=.*/m;
    $code = $&;
    @code = split(/\s+/, $code);
    $code = $code[1];
    return $code;
}


###################################################################

sub extract_vector_res
{
# 
    my ($res_seq, $ms_hachage)= @_; 
    my $res_seq_vec = '';
    my $code = '';    
    my @code = ();
    my $vector = '';
    my $HSP = '';
    my $HSPbeg = '';
    my $HSPend = '';
    my $HSPend1 = '';
    my $vector_beg = 0;
    my $vector_end = 100000;
    my $vector_name_beg = '';
    my $vector_name_end = '';
    my $booleen = 0;

# extract sequence name
    $$res_seq =~ /^Query=.*/m;
    $code = $&;
    @code = split(/\s+/, $code);
    $code = $code[1];
# extract extrem positions of the Ms in the sequence
    my ($MSbeg, $MSend) = MS_extrem_pos(\%$ms_hachage, $code);
#    print "\n****$code*****\n";
#    print "\nMSpos:$MSbeg-$MSend\n";


# extract info sur une seq et une vector
 while ($$res_seq =~ />[^>]+/sg)
    {
	if ($booleen)
	{
	    next;
	}
	$res_seq_vec = $&;

#extract vector name	
	$res_seq_vec =~ /^>.+$/mi;
	$vector = $&;
#	print "\n/////$vector/////\n";

#extract HSP and HSP positions in sequence

	$res_seq_vec =~ s/Score/§core/g;
        while ($res_seq_vec =~ /§[^§]+/sg)
	{
	    if ($booleen)
	    {
		next;
	    }
	    $HSP = $&;
	    $HSP =~ /Query:\s[0-9]+/;
	    $HSPbeg = $&;
	    $HSPbeg =~ /[0-9]+/; 
	    $HSPbeg = $&;
	    while ($HSP =~ /^Query:.*$/gim)
                {
		   $HSPend = $&;
		}
      	    $HSPend =~ /[a-z]+\s+[0-9]+/;
	    $HSPend = $&;
	    $HSPend =~ /[0-9]+/;
	    $HSPend = $&;

	    my $i =check_vector_MS_pos($HSPbeg, $HSPend, $MSbeg, $MSend, $code, $vector);
#	    print "$HSPbeg-$HSPend-------$i\n";

#  keep only the most intern positions of the vector and the name of 
# the corresponding vector
	   
	    if ($i == 1)
	    {
		if ($HSPbeg <= $vector_end)
	        {
	             $vector_end = $HSPbeg;
	             $vector_name_end = $vector;
	        }
	    }
	    elsif ($i == 0)
	    {
		if ($HSPend >= $vector_beg)
		{
		    $vector_beg = $HSPend;	
		    $vector_name_beg = $vector;
		}    
	    }
	    else
	    {
		print "Vector:$vector\n$HSPbeg-$HSPend, MS: $MSbeg-MSend, OVERLAP!!!\n";
		$vector_name_beg = 'overlap';
		$vector_name_end = 'overlap';
		$booleen = 1;
	    }
	}
    }
     
   
    return ($code, $vector_beg, $vector_name_beg, $vector_end, $vector_name_end);

 #   print "POSBEG: $vector_beg $vector_name_beg\n";
 #   print "POSEND: $vector_end $vector_name_end\n"; 

 }

####################################################################

sub fasta_into_hachage
{
 # delete empty lines and concatanate the diff lines of each sequences, put sequence into a hachage
  use warnings;
  use strict;
  my ($filename) = @_;
  my @seq = ();
  my %seq_hach = ();
  my @code = ();
  my $code = '';

  unless ( open(FASTA, $filename))
    {
      print "Cannot open $filename\n";
      exit;
    }
  @seq = <FASTA>;
  close(FASTA);

#  reads table into a hachage; sequence names are the codes sequences are the values
  while (@seq)
  {
      my $seq = shift(@seq);
      if ($seq =~ /^>[a-z0-9_]+/i)
      {
	  $code = $&;
	  $code =~ s/>//;
	  push (@code, $code);
      }
      else
      {
	  $seq_hach{$code} .= $seq;
      }
  }

  foreach my $code (@code)
  {
      $seq_hach{$code} =~ s/\s//sg;
  }

  return %seq_hach;
}


###################################################################"

sub find_microsat_gb
{
    my ($seq, $ms_motif, $ms_pos) = @_;
    my $bp = length $seq;

    for (my $i= 0; $i < $bp; ++$i)
    {
#	print "$i ";
#Check for motif of single base pair
	my $motif = substr($seq, $i, 1);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	my $j = $i+1;
	if ($j > $bp-1 )
	{
	    next;
	}
	while ( substr($seq, $j, 1) eq $motif )
	{
	    ++$j;
	}
	if ($j - $i > 7)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;
	}
#Check for motif of two base pair
	$motif = substr($seq, $i, 2);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+2;
	if ($j > $bp-2 )
	{
	    next;
	}	
	while ( substr($seq, $j, 2) eq $motif )
	{
	    $j +=2;
	}
	if ($j - $i > 7)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of three base pair
	$motif = substr($seq, $i, 3);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+3;
	if ($j > $bp-3 )
	{
	    next;
	}	
	while ( substr($seq, $j, 3) eq $motif )
	{
	    $j +=3;
	}
	if ($j - $i > 11)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;   
	}
#Check for motif of 4 base pair
	$motif = substr($seq, $i, 4);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+4;
	if ($j > $bp-4 )
	{
	    next;
	}	
	while ( substr($seq, $j, 4) eq $motif )
	{
	    $j +=4;
	}
	if ($j - $i > 15)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of 5 base pair
	$motif = substr($seq, $i, 5);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+5;
	if ($j > $bp-5 )
	{
	    next;
	}	
	while ( substr($seq, $j, 5) eq $motif )
	{
	    $j +=5;
	}
	if ($j - $i > 19)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of 6 base pair
	$motif = substr($seq, $i, 6);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+6;
	if ($j > $bp-6 )
	{
	    next;
	}	
	while ( substr($seq, $j, 6) eq $motif )
	{
	    $j +=6;
	}
	if ($j - $i > 23)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;	 
	    next;
	}
    }
    
#    print "\n\n";

}


###################################################################"

sub find_microsat_gb_motif_def
{
    my ($seq, $ms_motif, $ms_pos, $min, $min_single) = @_;
    my $bp = length $seq;

    for (my $i= 0; $i < $bp; ++$i)
    {
#	print "$i ";
#Check for motif of single base pair
	my $motif = substr($seq, $i, 1);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	my $j = $i+1;
	if ($j > $bp-1 )
	{
	    next;
	}
	while ( substr($seq, $j, 1) eq $motif )
	{
	    ++$j;
	}
	if ($j - $i > ($min_single-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}


#Check for motif of two base pair
	$motif = substr($seq, $i, 2);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+2;
	if ($j > $bp-2 )
	{
	    next;
	}	
	while ( substr($seq, $j, 2) eq $motif )
	{
	    $j +=2;
	}
	if ($j - $i > ($min*2-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of three base pair
	$motif = substr($seq, $i, 3);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+3;
	if ($j > $bp-3 )
	{
	    next;
	}	
	while ( substr($seq, $j, 3) eq $motif )
	{
	    $j +=3;
	}
	if ($j - $i > ($min*3-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;   
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of 4 base pair
	$motif = substr($seq, $i, 4);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+4;
	if ($j > $bp-4 )
	{
	    next;
	}	
	while ( substr($seq, $j, 4) eq $motif )
	{
	    $j +=4;
	}
	if ($j - $i > ($min*4-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 5 base pair
	$motif = substr($seq, $i, 5);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+5;
	if ($j > $bp-5 )
	{
	    next;
	}	
	while ( substr($seq, $j, 5) eq $motif )
	{
	    $j +=5;
	}
	if ($j - $i > ($min*5-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 6 base pair
	$motif = substr($seq, $i, 6);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+6;
	if ($j > $bp-6 )
	{
	    next;
	}	
	while ( substr($seq, $j, 6) eq $motif )
	{
	    $j +=6;
	}
	if ($j - $i > ($min*6-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;	 
	    next;
	}

    }
    
#    print "\n\n";

}

###################################################################"

sub find_microsat_gb_motif_def_6
{
    my ($seq, $ms_motif, $ms_pos, $min_single, $min2, $min3, $min4, $min5, $min6) = @_;
    my $bp = length $seq;

    for (my $i= 0; $i < $bp; ++$i)
    {
#	print "$i ";
#Check for motif of single base pair
	my $motif = substr($seq, $i, 1);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	my $j = $i+1;
	if ($j > $bp-1 )
	{
	    next;
	}
	while ( substr($seq, $j, 1) eq $motif )
	{
	    ++$j;
	}
	if ($j - $i > ($min_single-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of two base pair
	$motif = substr($seq, $i, 2);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+2;
	if ($j > $bp-2 )
	{
	    next;
	}	
	while ( substr($seq, $j, 2) eq $motif )
	{
	    $j +=2;
	}
	if ($j - $i > (($min2*2)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of three base pair
	$motif = substr($seq, $i, 3);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+3;
	if ($j > $bp-3 )
	{
	    next;
	}	
	while ( substr($seq, $j, 3) eq $motif )
	{
	    $j +=3;
	}
	if ($j - $i > (($min3*3)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;   
	}
	elsif ($j - $i > 6)
	{
		$i = $j-6;
		next;
	}

#Check for motif of 4 base pair
	$motif = substr($seq, $i, 4);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+4;
	if ($j > $bp-4 )
	{
	    next;
	}	
	while ( substr($seq, $j, 4) eq $motif )
	{
	    $j +=4;
	}
	if ($j - $i > (($min4*4)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 5 base pair
	$motif = substr($seq, $i, 5);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+5;
	if ($j > $bp-5 )
	{
	    next;
	}	
	while ( substr($seq, $j, 5) eq $motif )
	{
	    $j +=5;
	}
	if ($j - $i > (($min5*5)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}

#Check for motif of 6 base pair
	$motif = substr($seq, $i, 6);
	if ( $motif =~ /N/i )
	{
	    next;
	}
	$j = $i+6;
	if ($j > $bp-6 )
	{
	    next;
	}	
	while ( substr($seq, $j, 6) eq $motif )
	{
	    $j +=6;
	}
	if ($j - $i > (($min6*6)-1))
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;	 
	    next;
	}

    }
    
#    print "\n\n";

}


###################################################################"

sub find_microsat_gb_WO_single
{
    my ($seq, $ms_motif, $ms_pos) = @_;
    my $bp = length $seq;

    for (my $i= 0; $i < $bp; ++$i)
    {
#	print "$i ";

#Check for motif of two base pair
	$motif = substr($seq, $i, 2);
# Check if motif is not a double of a shorter motif (e.g. AA)
#¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤
	my $base1= substr($motif,0,1);
	my $base2 = substr($motif,1,1);
	if ($base1 eq $base2)
         {
	     next;
	 }
#¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤¤

	$j = $i+2;
	if ($j > $bp-2 )
	{
	    next;
	}	
	while ( substr($seq, $j, 2) eq $motif )
	{
	    $j +=2;
	}
	if ($j - $i > 7)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of three base pair
	$motif = substr($seq, $i, 3);
	$j = $i+3;
	if ($j > $bp-3 )
	{
	    next;
	}	
	while ( substr($seq, $j, 3) eq $motif )
	{
	    $j +=3;
	}
	if ($j - $i > 11)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;   
	}
#Check for motif of 4 base pair
	$motif = substr($seq, $i, 4);
	$j = $i+4;
	if ($j > $bp-4 )
	{
	    next;
	}	
	while ( substr($seq, $j, 4) eq $motif )
	{
	    $j +=4;
	}
	if ($j - $i > 15)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of 5 base pair
	$motif = substr($seq, $i, 5);
	$j = $i+5;
	if ($j > $bp-5 )
	{
	    next;
	}	
	while ( substr($seq, $j, 5) eq $motif )
	{
	    $j +=5;
	}
	if ($j - $i > 19)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;
	    next;	    
	}
#Check for motif of 6 base pair
	$motif = substr($seq, $i, 6);
	$j = $i+6;
	if ($j > $bp-6 )
	{
	    next;
	}	
	while ( substr($seq, $j, 6) eq $motif )
	{
	    $j +=6;
	}
	if ($j - $i > 23)
	{
	    $$ms_pos{$i+1}= $j;
	    $$ms_motif{$i+1}= $motif;
	    $i = $j-1;	 
	    next;
	}
    }
    
#    print "\n\n";

}


##################################################################

sub first_group
{
    my ($filename, $clas_seq, $group_seq, $clustal) = @_;

# open file with the results of the Blast

    $filename =~ s/\.[a-z0-9]+/\.txt/i;
    $filename =~ s/.+\//temp\//i;
    unless ( open(BLASTRES, $filename) )
    {
       print "Cannot open $filename!\n";
    }

#read the blast results for one sequence

    my $res_seq = '';
    while ($res_seq = one_seq_result($filename))
    {
       # avoide last scalar with only  a few characters 
       if ($res_seq !~ /Query/) 
       {
	   next;
       }

       my @subjects = ();
       my $subjects ='';
       my $strands = '';
       my $code = extract_sequence_code(\$res_seq);
 #  eliminate CSS
       if ($res_seq =~ / \*{5}\sNo\shits\sfound\s\*{5}/ )
       {
	   $$clas_seq{$code} = 'CSS';
       }
       else 
       { 
#extract subjects 
         while ($res_seq =~ />[^>]+/sg)
         {
	     my $res_seq_subj = $&;
	     $res_seq_subj =~ /^>.+$/mi;
	     my $subject = $&;
	     $subject =~ /[a-z0-9_]+/i;
	     $subject = $&;
	     push (@subjects, $subject);
	     $subjects .= " $subject";
	     $res_seq_subj =~ /Strand.+$/mi;
	     my $strand = $&;
	     $strand =~ s/.+\/\s//;
	     $strand .= $subject;
	     $strands .= " $strand";
	     
         }
         if ( scalar@subjects == 1 )
	 {
	    $$clas_seq{$code} = 'independent'; 
	 }
	 else
	 {
	    $$clas_seq{$code} = 'grouped'; 
	    $$group_seq{$code} = $subjects;
	    $$clustal{$code} = $strands;
	 }
       }   
    }
 close BLASTRES;

}

##################################################################

sub first_group_WO_red
{
    my ($filename, $clas_seq, $group_seq) = @_;

# open file with the results of the Blast

    $filename =~ s/\.[a-z0-9]+/\.txt/i;
    $filename =~ s/.+\//temp\//i;
    unless ( open(BLASTRES, $filename) )
    {
       print "Cannot open $filename!\n";
    }

#read the blast results for one sequence

    my $res_seq = '';
    while ($res_seq = one_seq_result($filename))
    {
       # avoide last scalar with only  a few characters 
       if ($res_seq !~ /Query/) 
       {
	   next;
       }

       my @subjects = ();
       my $subjects ='';
       my $code = extract_sequence_code(\$res_seq);
 #  eliminate CSS
       if ($res_seq =~ / \*{5}\sNo\shits\sfound\s\*{5}/ )
       {
	   $$clas_seq{$code} = 'CSS';
       }
       else 
       { 
#extract subjects 
         while ($res_seq =~ />[^>]+/sg)
         {
	     my $res_seq_subj = $&;
	     $res_seq_subj =~ /^>.+$/mi;
	     my $subject = $&;
	     $subject =~ /[a-z0-9_]+/i;
	     $subject = $&;
	     push (@subjects, $subject);
	     $subjects .= " $subject";
	     $res_seq_subj =~ /Strand.+$/mi;
         }
         if ( scalar@subjects == 1 )
	 {
	    $$clas_seq{$code} = 'independent'; 
	 }
	 else
	 {
	    $$clas_seq{$code} = 'grouped'; 
	    $$group_seq{$code} = $subjects;
	 }
       }   
    }
 close BLASTRES;

}


#########################################################


sub group_microsatellites
{
 my ($ms_motif, $ms_pos, $seq, $ms_sum) = @_;
 my @posMSbeg = sort { $a <=> $b } keys %$ms_pos;
 my @posMSend = sort { $a <=> $b } values %$ms_pos;



# print "@posMSbeg\n";
# print "@posMSend\n";
# group microsatellites that do not have at least 300 bp of flanking region between
my @beg = ();
my @end = ();
 my $ms_number = scalar(@posMSbeg);
# print "$ms_number\n";
 my $i = 0;


if ($ms_number == 1)
{
#    print "posMSbeg: @posMSbeg\n";
    @beg = @posMSbeg;
}
else
{
    my $beg1 = shift @posMSbeg;
    my $end1 = shift @posMSend;

while ( @posMSend )
{
    ++$i;
#    print "ms$i ";
    my $beg2 = shift @posMSbeg;
    my $end2 = shift @posMSend;
 
    if ( $beg2 - $end1 > 300 )
    {
	push (@beg, $beg1);
	push (@end, $end1);
	$beg1 = $beg2;
	$end1 = $end2;
    }
    else
    {
	$end1 = $end2;
	$$ms_sum{$beg1} .= $beg2.';'; 
	unless (@posMSend)
	{
	push (@beg, $beg1);
	push (@end, $end1);	    
	}
    }	
}
}

foreach $pos_beg (@beg)
{
#    print "$pos_beg\n";
    if ( exists $$ms_sum{$pos_beg} )
    {
       $$ms_sum{$pos_beg} = $pos_beg.';'.$$ms_sum{$pos_beg};
    }
    else
    {
	$$ms_sum{$pos_beg} = $pos_beg.';';
    }
}

#    print "\n\n";

#print "******\n@beg\n@end\n";
#print_hachage(\%$ms_sum);

}

#########################################################


sub group_microsatellites_1
{

# group microsatellites that are closer than 300 bp to each other. %ms_sum gives the first position of the first Ms in the group as a key and the first position of all of the MSs in the group

 my ($ms_motif, $ms_pos, $ms_sum) = @_;
 my @posMSbeg = sort { $a <=> $b } keys %$ms_pos;
 my @posMSend = sort { $a <=> $b } values %$ms_pos;

 for (my $i = 0; $i < scalar@posMSbeg; ++$i)
 {
     if ($i == 0)
     {
	 $$ms_sum{$posMSbeg[$i]} = $posMSbeg[$i].';';	 
     }
     elsif ( $posMSbeg[$i] -  $posMSend[$i-1] > 300 )
     {
	 $$ms_sum{$posMSbeg[$i]} = $posMSbeg[$i].';';
     }
     else 
     {
	 my @temp_ms_sum = sort { $a <=> $b } keys %$ms_sum;
	 my $beg_temp = pop @temp_ms_sum;
	 $$ms_sum{$beg_temp} .= $posMSbeg[$i].';';
     }
 }

}

#########################################################


sub group_microsatellites_2
{

# group microsatellites that are closer than 300 bp to each other. %ms_sum gives the first position of the first Ms in the group as a key and the first position of all of the MSs in the group

 my ($ms_motif, $ms_pos, $ms_sum, $l_between_ms) = @_;
 my @posMSbeg = sort { $a <=> $b } keys %$ms_pos;
 my @posMSend = sort { $a <=> $b } values %$ms_pos;

#print_hachage(\%$ms_pos);
#print "@posMSbeg\n";

 for (my $i = 0; $i < scalar@posMSbeg; ++$i)
 {
     if ($i == 0)
     {
	 $$ms_sum{$posMSbeg[$i]} = $posMSbeg[$i].';';	 
     }
     elsif ( $posMSbeg[$i] -  $posMSend[$i-1] > $l_between_ms )
     {
	 $$ms_sum{$posMSbeg[$i]} = $posMSbeg[$i].';';
     }
     else 
     {
	 my @temp_ms_sum = sort { $a <=> $b } keys %$ms_sum;
	 my $beg_temp = pop @temp_ms_sum;
	 $$ms_sum{$beg_temp} .= $posMSbeg[$i].';';
     }
 }

}

#####################################################################
sub group_overlap_hach
{
my ($hash) = @_;
my @pos = sort {$a <=> $b} keys %$hash;
%feature_temp = %$hash;
my $booleen = 0;

#merges overlaping regions
for (my $i=1; $i < scalar @pos; ++$i )
{
# partial overlap
    if ( ($pos[$i] - $feature_temp{$pos[$i-1]} < 2) and ($feature_temp{$pos[$i]} > $feature_temp{$pos[$i-1]}) )
    {
	$feature_temp{$pos[$i-1]} = $feature_temp{$pos[$i]};
	$pos[$i] = -1;
	@pos = sort { $a <=> $b }@pos;
	$booleen = 1;
    }
# complet overlap (second interval is shorter)
    elsif ( ($pos[$i] - $feature_temp{$pos[$i-1]} < 2) and ($feature_temp{$pos[$i]} < $feature_temp{$pos[$i-1]}+1) )
    {
	$pos[$i] = -1;
	@pos = sort { $a <=> $b }@pos;
	$booleen = 1;
    }
}

%$hash = ();
# if no overlap at all
if ($booleen == 0)
{
    %$hash = %feature_temp;
}
# at least one overlap

else
{
    foreach my $pos (@pos)
    {
	if ($pos > 0)
	{
	    $$hash{$pos} = $feature_temp{$pos};
	}
    }
}
#print "@pos\n";
# print_hachage(\%$hash);


}

###################################################################


sub group_seq_into_fasta
{
# puts sequences into fasta files for each species separatelly
   my ($seq, $group_accession) = @_;

   @spec = keys %$group_accession;

   foreach my $spec (@spec)
   {
       my %hach = ();
       my $i = 0;
       while ( $$group_accession{$spec} =~ /[a-z0-9]+/ig )
       {
	   my $accession = $&;
	   $hach{$accession} = $$seq{$accession};
       }
       #create the nzme of the fasta file by taking the first letter of the genus and the first two of the species then adds G for genbank

       $filename = $spec;
       $filename =~ s/\s/_/g;
       $filename =~ s/[^a-z_]//gi;
#	$spec =~ /[a-z]+/i;
#       my $filename = substr( $&, 0, 3 );
#       $spec =~ /\s[a-z]+/;
#       $filename .= $&;
#       $filename =~ s/\s//g;
#       my $temp = substr( $&, 1, 4 );
#       $filename .= $temp;
       $filename = uc $filename;
       $filename = 'temp/'.$filename.'.fas';
       
       make_fasta_file(\%hach, $filename); 
   }


}

##############################################################"


sub groupe_species
{
  my ($species, $group_accession) = @_;
  my @code = keys %$species;
  my $tested_spec = '';

  foreach my $accession (@code)
  {
      my $spec = $$species{$accession};
      $$group_accession{$spec} .= ' ';
      $$group_accession{$spec} .= $accession;
    
  }
#  print_hachage(\%group_accession);

}

##############################################################

sub length_sequences
{
    my ($hach) = @_;
    my @code = keys %$hach;
    my %orig_length  = ();

    foreach my $code (@code)
    {
	$orig_length{$code} = length($$hach{$code});
    }
    return %orig_length;
}

##############################################################

sub length_sequences_same_hach
{
# takes hach with sequences and replaces seq with its length
    my ($hach) = @_;
    my @code = keys %$hach;

    foreach my $code (@code)
    {
	$$hach{$code} = length($$hach{$code});
    }
 }

############################################################

sub make_empty_table
{
 my ($empty, $source, $chr_step) = @_;
 
 for (my $i = 0; $i < $source/$chr_step; ++$i)
 {
     push (@$empty, '0');
 }

}

###########################################################

sub make_fasta_file
  {
  use warnings;
  use strict;
   my ($seq_hach, $filename) = @_;
    my @code = keys %$seq_hach;

    unless (open (FASTA, ">$filename"))
    {
	print "Cannot open $filename\n";
    }
    foreach my $code (@code)
    {
        my $seq = $$seq_hach{$code};
        print FASTA ">$code\n";
	for (my $pos = 0; $pos < length $seq; $pos += 50)
	{
	    print FASTA substr($seq, $pos, 50), "\n";
        }        

    }
  close (FASTA);

  }

############################################################


sub make_fasta_file_masqued
  {
  use warnings;
  use strict;
   my ($seq_hach, $ms_hachage, $filename) = @_;
    my @code = keys %$seq_hach;

    open (FASTA, ">$filename");
    foreach my $code (@code)
    {
        my $seq = $$seq_hach{$code};
	my $replacement = $seq;
	$replacement =~ s/[a-z]/N/ig;
	while ( $$ms_hachage{$code} =~ /[0-9]+-[0-9]+,/g )
	{
	    my $temp = $&;
	    $temp =~ /[0-9]+-/;
            my $pos_beg = $&;
	    $pos_beg =~ s/-//;
	    $temp =~ /[0-9]+,/;
            my $pos_end = $&;
	    $pos_end =~ s/,//;
	    my $long = $pos_end - $pos_beg +1;
	    $replacement =~ /N{$long}/;
	    substr ($seq, $pos_beg-1, $long, $&); 
         }   
	print FASTA ">$code\n";
	for (my $pos = 0; $pos < length $seq; $pos += 50)
	{
	    print FASTA substr($seq, $pos, 50), "\n";
	}  
    }

  }

###################################################################

sub mask_sequence
{
    my ($seq, $ms_beg, $ms_end, $seq_beg) = @_;

#    print "$seq\n";
#    print "$ms_beg\n";
#    print "$ms_end\n";
#    print "$seq_beg\n";
    my $replacement = $seq;
    $replacement =~ s/[a-z]/N/ig;
    my $pos_beg = $ms_beg - $seq_beg; 
    my $long = $ms_end - $ms_beg +1;
    $replacement =~ /N{$long}/;
    substr ($seq, $pos_beg, $long, $&); 


    return $seq;
}


#############################################################

sub merge_groups_1
{

    my ($group_seq) = @_;
    my @codes = sort (keys %$group_seq);
    
#    $$group_seq{REDUNDANT} = 'REDUNDANT';

    foreach my $code (@codes)
    {
#	print "\ncode:$code****\n";
	if ($$group_seq{$code} =~ /REDUNDANT/)
	{
	    next;
	}
	my @hits = split ( ' ', $$group_seq{$code});
#	print "***@hits***\n";
	foreach my $hit (@hits)
	{
#	    print "code:$code,hit:$hit*\n";
	    for ( my $i = 0; $i < scalar@hits; ++$i )
	    {
#		print "$hit*";
		unless ( $$group_seq{$hit} =~ /$hits[$i]/)
		{
		    $$group_seq{$hit} .= ' '.$hits[$i];
		}
	    }
	}
    }

   # keep hits for only first member of the group, delete de value of the hachage for the others
    
    foreach my $code (@codes)
    {
	if ($$group_seq{$code =~ /REDUNDANT/})
	{
	    next;
	}
	my @hits = sort (split ( ' ', $$group_seq{$code}));
	for ( my $i = 1; $i < scalar@hits; ++$i )
	{
	    $$group_seq{$hits[$i]} = '';
	}
    }
}


####################################################################

sub merge_groups
{
 # compare actual groups and merge them if at least one seqeunce 
 # links them together

  use warnings;
  use strict;

  my ($group_seq) = @_;
  my @code = keys %$group_seq;
  my %large_group_seq = %$group_seq;

#  print "\n\n";

  for (my $i = 0; $i < scalar(@code); ++$i)
  {
      my $booleen = 0;
      my $code1 = $code[$i];
      while ($$group_seq{$code1} =~ /[a-z0-9]+/ig)
      {
	if ($booleen or $$group_seq{$code1} =~ /REDUNDANT/)
	{
	    next;
	}
	else
	{
	  my $hit = $&;

	  for (my $j = $i+1; $j < scalar(@code); ++$j)
	  {
	      if ($booleen)
	      {
		  next;
	      }
	      my $code2 = $code[$j];
# if sequence is grouped to others, empty the hit line in hachage and transfer hits into 
# a subsequent group In this way only the last sequence in the group has the code of
#  all others of the same group
	      if ( $$group_seq{$code2} =~ /$hit/ )
	      {
		  $large_group_seq{$code2} = $large_group_seq{$code1} . $large_group_seq{$code2};
	          $large_group_seq{$code1} = '';
	          
#	          $booleen = 1;
	      }
	   }
         }	  
      }
   }
 
#  print_hachage(\%large_group_seq);
  return %large_group_seq; 
}



#########################################################################

sub microsat_into_fasta
{
 my ($ms_motif, $ms_pos, $sequence, $ms_sum, $seq_code_beg, $ms, $seq, $mask, $counter_ms) = @_;

 my @code = sort { $a <=> $b }(keys %$ms_sum);
 my $longeur_seq = length $sequence;
 my $i = 0;
 my $zero = '00000';


foreach my $code (@code)
{
    ++$i;
#    print "seq$i ";
# extract first pos of last MS in the seq
    $$ms_sum{$code} =~ /[0-9]+;$/;
    my $seq_end = $&;
    $seq_end =~ s/;//;
# extract last pos of last MS and then calculate the end pos of the seq
    $seq_end = $$ms_pos{$seq_end};
    $seq_end = $seq_end + 150;
    if ($seq_end >  $longeur_seq)
    {
	$seq_end = $longeur_seq;
    }
#    print "$seq_code_beg: $seq_end\n";
# calculate the first pos of the seq    
    $seq_beg = $code -150;
    if ($seq_beg < 1 )
    {
	$seq_beg = 1;
    }
    my $bp_seq = $seq_end - $seq_beg +1;

#substract seq and put into fasta hachage
    my $fragment = substr ($sequence, $seq_beg-1, $bp_seq); 
    my $zeros = substr($zero, 0, 6-length $i);
    if (length$i > 6)
    {
	print "Attention, there are more than 999999 microsatellites in Sequence! Problems of numerotation!!";
    }

    my $code_seq = $seq_code_beg.$zeros.$i;
    
# !!!!!   $$fasta{$code_seq} = $fragment;
  
#gather all info on MSs in the same sequence and masque the Microsat at the same time in the $fragment
    my $ms_numb = 0;
    while ( $$ms_sum{$code} =~ /[0-9]+/g )
    {
	++$ms_numb;
	++$counter_ms;
# mask MS in fragment
	my $ms_beg = $&;
	my $ms_end = $$ms_pos{$ms_beg};
	$fragment = mask_sequence($fragment, $ms_beg, $ms_end, $seq_beg);
# collect info on MSs and Seq and pout it inot a hachage
	my $motif = $$ms_motif{$ms_beg};
	my $motif_trans = transfer_ms_motif($motif);
	$$seq{$code_seq} .= $ms_beg.';'.$ms_end.';'.$motif.';';
	$$ms{$counter_ms} = $code_seq.';'.$seq_beg.';'.$ms_beg.';'.$ms_end.';'.$motif.';'.$motif_trans;
    }

# mask MS in fragment and put it into hachage
    $$mask{$code_seq} = $fragment;
# add info on sequence
    $$seq{$code_seq} = $seq_beg.';'.$seq_end.';'.$ms_numb.';'.$$seq{$code_seq};

} 

return $counter_ms;

}

#########################################################################

sub microsat_into_fasta_soft_mask
{
 my ($ms_motif, $ms_pos, $sequence, $ms_sum, $seq_code_beg, $ms, $seq, $mask, $counter_ms, $flank_l) = @_;

 my @code = sort { $a <=> $b }(keys %$ms_sum);
 my $longeur_seq = length $sequence;
 my $i = 0;
 my $zero = '00000';


foreach my $code (@code)
{
    ++$i;
#    print "seq$i ";
# extract first pos of last MS in the seq
    $$ms_sum{$code} =~ /[0-9]+;$/;
    my $seq_end = $&;
    $seq_end =~ s/;//;
# extract last pos of last MS and then calculate the end pos of the seq
    $seq_end = $$ms_pos{$seq_end};
    $seq_end = $seq_end + $flank_l;
    if ($seq_end >  $longeur_seq)
    {
	$seq_end = $longeur_seq;
    }
#    print "$seq_code_beg: $seq_end\n";
# calculate the first pos of the seq    
    $seq_beg = $code - $flank_l;
    if ($seq_beg < 1 )
    {
	$seq_beg = 1;
    }
    my $bp_seq = $seq_end - $seq_beg +1;

#substract seq and put into fasta hachage
    my $fragment = substr ($sequence, $seq_beg-1, $bp_seq); 
    my $zeros = substr($zero, 0, 6-length $i);
    if (length$i > 6)
    {
	print "Attention, there are more than 999999 microsatellites in Sequence! Problems of numerotation!!";
    }

    my $code_seq = $seq_code_beg.$zeros.$i;
    
# !!!!!   $$fasta{$code_seq} = $fragment;
  
#gather all info on MSs in the same sequence and masque the Microsat at the same time in the $fragment
    my $ms_numb = 0;
    while ( $$ms_sum{$code} =~ /[0-9]+/g )
    {
	++$ms_numb;
	++$counter_ms;
# mask MS in fragment
	my $ms_beg = $&;
	my $ms_end = $$ms_pos{$ms_beg};
	my %ms_temp = ();
	$ms_temp{$ms_beg} = $ms_end;
	$fragment = change_ms_into_lower_case($fragment, \%ms_temp);
# collect info on MSs and Seq and put it into a hachage
	my $motif = $$ms_motif{$ms_beg};
	my $motif_trans = transfer_ms_motif($motif);
	$$seq{$code_seq} .= $ms_beg.';'.$ms_end.';'.$motif.';';
	$$ms{$counter_ms} = $code_seq.';'.$seq_beg.';'.$ms_beg.';'.$ms_end.';'.$motif.';'.$motif_trans;
    }

# mask MS in fragment and put it into hachage
    $$mask{$code_seq} = $fragment;
# add info on sequence
    $$seq{$code_seq} = $seq_beg.';'.$seq_end.';'.$ms_numb.';'.$$seq{$code_seq};

} 

return $counter_ms;

}

#######################################################################

sub move_files
{
 my ($folder_orig, $folder_end) = @_;
  
unless ( opendir(FOLDER, $folder_orig) )
  {
      print "Cannot access to folder $folder\n";
      exit;
  }
 my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );

#print "@filenames\n";

  foreach my $filename (@filenames)
  {
      if ($filename =~ /\./)
      {
      my $filename_out = $folder_end.'/'.$filename;

     $filename = $folder_orig.'/'.$filename; 
#      print "$filename\n";
      my $replace = 'mv '.$filename.' '.$filename_out;
      system $replace;
      }
  }

closedir(FOLDER);

}

#####################################################################

sub MS_extrem_pos
{
# Extract from ms_hachage the begining of the first 
# MS and the end of the last
    my($ms_hachage, $code) = @_;
    my $MSbeg = 10000;
    my $MSend = 0;

   	while ( $$ms_hachage{$code} =~ /[0-9]+/g )
	{ 
	    my $temp = $&;
	    if ( $temp < $MSbeg )
	    {
		$MSbeg = $temp;
	    }
	    if ( $temp > $MSend )
	    {
		$MSend = $temp;
	    }
        }
    return ($MSbeg, $MSend);
}

#############################

sub ms_length_in_fragment
{
    my ($chr, $ms_beg, $ms_end, $fragment) = @_;

	    my $code = int($ms_beg/$fragment);
	    my $code_top = int($ms_end/$fragment);
	    for (my $i = $code; $i < ($code_top + 1); ++$i)
	    {
# whole ms falls into the same interval
		if ($i==$code and $ms_end< ($code+1)*$fragment )
		{
		    unless (exists $$chr{$code})
		    {
			$$chr{$code} = 0;
		    }
		    $$chr{$code} = $$chr{$code} + $ms_end - $ms_beg +1;
		}
# ms starts in the interval and ends in another
		elsif ($i==$code)
		{
		    unless (exists $$chr{$code})
		    {
			$$chr{$code} = 0;
		    }
		    $$chr{$code} = $$chr{$code} + ($code+1)*$fragment - $ms_beg +1;	            
		}
# ms starts before the interval and ends in this one
		elsif ($ms_end< ($i+1)*$fragment)
		{
		    unless (exists $$chr{$i})
		    {
			$$chr{$i} = 0;
		    }
		    $$chr{$i} = $$chr{$i} + $ms_end - $i*$fragment +1;	
		}
# ms covers the wole interval
		else
		{
		    $$chr{$i} = $fragment;			    
		}
# end for	   
	    }

}

################################################################

sub numbering_large_group
{
 # Give number to each group and make a hachage 

  use warnings;
  use strict;

  my ($large_group_seq, $clas_seq) = @_;
  my @code = keys %$large_group_seq;
  

#  print "\n\n";

# eliminate redundant hits (hits that appear more than once) due to the 
# algotithme of the merge_group sub-program

  foreach my $code (@code)
  {
     my $buffer = '';
     while ( $$large_group_seq{$code} =~ /[a-z0-9_]+/ig )
     {
	 $buffer .= "$& ";
	 $$large_group_seq{$code} =~ s/$&//ig;
     }
     $$large_group_seq{$code} = $buffer;
  }

# modify clas_seq (precise group number and correct for non-reciproc hits
 
  my $i = 1;
  foreach my $code (@code)
  {
      if ( $$large_group_seq{$code} =~ /REDUNDANT/ )
      {
	  next;
      }
      elsif ( $$large_group_seq{$code} =~ /^[a-z0-9_]+\s$/i )
      {
	  $$clas_seq{$code} = 'independent';
      }
      elsif ( $$large_group_seq{$code} )
      {
	  while ( $$large_group_seq{$code} =~ /[a-z0-9_]+/ig)
	  {
	      my $temp = $&;
	      $$clas_seq{$temp} = "group$i";
	  }
	  ++$i;
      }
  }

}


##############################################################

sub open_file_and_hach
{
    my ($filename, $first_line) = @_;
#   print "$first_line"; 
	  unless ( open (FILE, "$filename"))
	  { print "Cannot open $filename\n"; exit;}
	  my @data = <FILE>;
    if ($first_line == 0)
    {
	shift (@data);
    }
#	  print "@data";
	  my %hach = txt_into_hachage_1(@data);
	  close FILE;

    return %hach;
}

#############################################################

sub open_file_in
{
 my ($filename, $handle) = @_;
 
 unless (open($handle, "$filename"))
 {
     print "Cannot open $filename\n";
     exit;
 }

}
######################################################


sub open_file_out
{
 my ($filename, $handle) = @_;
 
 unless (open($handle, ">$filename"))
 {
     print "Cannot open $filename\n";
     exit;
 }

}
######################################################

sub pool_fas_files
{
    my ($outfile, $filenames) = @_;
    
    
    open (OUTFILE, ">$outfile");
    my @sorted_filenames = sort @$filenames;

    foreach my $filename (@sorted_filenames)
    {
      # open file and read row by row into a table
     open (INFILE, $filename);
     my @seq = <INFILE>;
     close(INFILE); 
    
     # write everything unchanged into a single fasta file
     foreach my $line (@seq)
     {
      	 print OUTFILE $line;
     }
    }

    close(OUTFILE);
 

}
##############################################################


sub pool_info_files
{
    my ($outfile, $filenames) = @_;
    my $headline = 1;
    

    open (OUTFILE, ">$outfile");
    my @sorted_filenames = sort @$filenames;

    foreach my $filename (@sorted_filenames)
    {
      # open file and read row by row into a table
     open (INFILE, $filename);
     my @seq = <INFILE>;
     close(INFILE); 
    
     # write everything unchanged into a single file, but omit the headline for subsequent files
       
       if ($headline == 1)
       {
	   foreach my $line (@seq)
	   {
	       print OUTFILE $line;
	   }     
	   $headline = 0;
       }
      else
      {
	  shift (@seq);
	  foreach my $line (@seq)
	  {
	       print OUTFILE $line;
	  }     	  
      }


    }

    close(OUTFILE);
 

}

##############################################################

sub print_hachage
 {
 # print out a hachage in a human readable format
  use warnings;
  use strict;   
   my ($hach) = @_;
   my @cles = keys %$hach;
   my @sorted_keys = sort @cles;

   foreach my $sorted_key (@sorted_keys)
     {
       print "$sorted_key     $$hach{$sorted_key}\n";
     }
  print "\n\n";
  }

##################################################################



sub print_hachage_number
 {
 # print out a hachage in a human readable format
  use warnings;
  use strict;   
   my ($hach) = @_;
   my @cles = keys %$hach;
   my @sorted_keys = sort { $a <=> $b }@cles;

   foreach my $sorted_key (@sorted_keys)
     {
       print "$sorted_key     $$hach{$sorted_key}\n";
     }
  print "\n\n";
  }


################################################################

sub print_hachage_into_fasta
{
my ($hash, $filename) = @_;
   my @code = keys %$hash;
#print "@code\n";
   my @sorted_code = sort @code;



   open (HACH, ">$filename");
   foreach my $code (@sorted_code)
     {
        print HACH ">$code\n$$hash{$code}\n";
     }
  close (HACH);

}

##################################################################



sub print_hachage_into_file
 {
 # print out a hachage in a human readable format into a file
  use warnings;
  use strict;   
   my ($hach, $filename) = @_;
   my @code = keys %$hach;
   my @sorted_code = sort @code;

   open (HACH, ">$filename");
   foreach my $code (@sorted_code)
     {
        print HACH "$code   $$hach{$code}\n";
     }
  close (HACH);

  }
   
################################################################

sub print_hachage_into_file_1
 {
 # print out a hachage in a human readable format into a file, keyw and values are separated by ;
  use warnings;
  use strict;   
   my ($hach, $filename) = @_;
   my @code = keys %$hach;
   my @sorted_code = sort @code;

   open (HACH, ">$filename");
   foreach my $code (@sorted_code)
     {
        print HACH "$code;$$hach{$code}\n";
     }
close HACH;
  }

#########################################################   

sub print_hachage_into_file_heading
 {
 # print out a hachage in a human readable format into a file, keyw and values are separated by ;
  use warnings;
  use strict;   
   my ($hach, $filename, $heading ) = @_;
   my @code = keys %$hach;
   my @sorted_code = sort @code;

   open (HACH, ">$filename");
  print HACH "$heading\n";
   foreach my $code (@sorted_code)
     {
        print HACH "$code;$$hach{$code}\n";
     }
close HACH;
  }
   

#########################################################


sub print_hachage_into_file_number
 {
 # print out a hachage in a human readable format into a file, keyw and values are separated by ;
  use warnings;
  use strict;   
   my ($hach, $filename) = @_;
   my @code = keys %$hach;
   my @sorted_code = sort { $a <=> $b }@code;

   open (HACH, ">$filename");
   foreach my $code (@sorted_code)
     {
        print HACH "$code;$$hach{$code}\n";
     }
close HACH;
  }
   

#########################################################

sub print_info_into_file
{
    my ($outfile, $class, $RM_short, $microsat) = @_;

    my @codes = sort (keys%$microsat);

open (OUTFILE, ">$outfile");
print OUTFILE "MS_code;Seq_code;1_if_firstMS_in_seq;Nseq_code;Chromosome;1st_pos_MS_on_chr;last_pos_MS_on_chr;MS_length_in_bp;MS_length_in_repeat;MS_motif_orig;MS_motif_traduit;MS motif_length;class;Number_of_hits;RM_hit_number;RM_hit_name(first);RM_hit_class(first);RM_hit_1st_pos_on_chr;RM_hit_last_pos_on_chr;\n";    

    foreach my $code (@codes)
    {
	print OUTFILE "$code;$$microsat{$code}";
	$$microsat{$code} =~ /.*?;/;
	my $seq_code = $&;
#	print "$seq_code\n";
	$seq_code =~ s/;//;
	print OUTFILE "$$class{$seq_code}";
	if (exists $$RM_short{$seq_code})
	{
	    print OUTFILE "$$RM_short{$seq_code}\n";
	}
	else
	{
	    print OUTFILE "0;NA;NA;NA;NA;\n";
	}

    
    }




close OUTFILE
}


#########################################################

sub print_info_into_file_chr
{
    my ($chr, $class, $microsat, $outfolder) = @_;

    my @codes = sort (keys%$microsat);
# filenames are determined on the basis of the chr code. %chr contains chr_code-chr abbreviation pairs

my $chr_list = ''; 
my $chr_short = '';
    foreach my $code (@codes)
    {
	$code =~ /[a-z0-9_]{10}[0-9]+/i;
	my $temp = $&;
	$chr_short = $$chr{$temp};
	unless ($chr_list =~ /$chr_short/)
	{
	    close OUT;
	    print "$chr_short\n";
	    $chr_list .= ' '.$chr_short;
	    $outfile = $outfolder.'/'.$chr_short.'_ms_info.txt';
	    open (OUT, ">$outfile");
	    print OUT "MS_code;Seq_code;1_if_firstMS_in_seq;Nseq_code;Chromosome;1st_pos_MS_on_chr;last_pos_MS_on_chr;MS_length_in_bp;MS_length_in_repeat;MS_motif_orig;MS_motif_traduit;MS motif_length;class;Number_of_hits;\n";    
	}
	$$microsat{$code} =~ s/$temp;/$chr_short;/;
	print OUT "$code;$$microsat{$code}";
	$$microsat{$code} =~ /.*?;/;
	my $seq_code = $&;
#	print "$seq_code\n";
	$seq_code =~ s/;//;
	print OUT "$$class{$seq_code}\n";
    
    }

close OUT;
}
#########################################################

sub print_info_into_file_chr_wo_class
{
    my ($chr, $microsat, $outfolder) = @_;

    my @codes = sort (keys%$microsat);
# filenames are determined on the basis of the chr code. %chr contains chr_code-chr abbreviation pairs

my $chr_list = ''; 
my $chr_short = '';
    foreach my $code (@codes)
    {
	$code =~ /[a-z0-9_]{10}[0-9]+/i;
	my $temp = $&;
	$chr_short = $$chr{$temp};
	unless ($chr_list =~ /$chr_short/)
	{
	    close OUT;
	    print "$chr_short\n";
	    $chr_list .= ' '.$chr_short;
	    $outfile = $outfolder.'/'.$chr_short.'_ms_info.txt';
	    open (OUT, ">$outfile");
	    print OUT "MS_code;Seq_code;1_if_firstMS_in_seq;Nseq_code;Chromosome;1st_pos_MS_on_chr;last_pos_MS_on_chr;MS_length_in_bp;MS_length_in_repeat;MS_motif_orig;MS_motif_traduit;MS motif_length;\n";    
	}
	$$microsat{$code} =~ s/$temp;/$chr_short;/;
	print OUT "$code;$$microsat{$code}\n";
   
    }

close OUT;
}



##########################################################



sub print_into_file
 {
 # print out a hachage in a human readable format into a file, keyw and values are separated by ;
  use warnings;
  use strict;   
   my ($red, $idem, $filename) = @_;


   open (OUTFILE, ">$filename");
   
   print OUTFILE "REDUNDANTS:\n$red\\nIDEM_PAIRS:\n$idem\n";
  close OUTFILE;
  }
   
##########################################################################

sub print_tables
{
 my ($outfile2, $source, $chr_step, $repeat, $gene, $mRNA, $CDS, $miscRNA, $miscfea, $STS, $snRNA, $tRNA, $snoRNA, $scRNA, $rRNA, $gap) = @_;

open (OUT, ">$outfile2"); 

 print OUT "int_beg;int_end;repeat;gene;mRNA;CDS;miscRNA;miscfea;STS;snRNA;tRNA;snoRNA;scRNA;rRNA;gap\n";

for (my $i = 0; $i < scalar @$gene; ++$i)
{
    my $beg_step = $i*$chr_step;
    my $end_step = ($i*$chr_step) + $chr_step-1;
#    print "$chr_step ** ";
#    print "$beg_step-$end_step ";
    print OUT "$beg_step;$end_step;$$repeat[$i];$$gene[$i];$$mRNA[$i];$$CDS[$i];$$miscRNA[$i];$$miscfea[$i];$$STS[$i];$$snRNA[$i];$$tRNA[$i];$$snoRNA[$i];$$scRNA[$i];$$rRNA[$i];$$gap[$i];\n";
}
close OUT;

}

#########################################################################

sub print_tables_condense
{
 my ($outfile, $repeat, $gene, $mRNA, $CDS, $gap) = @_;

open (OUT, ">$outfile"); 

# gene -1 if gap, 1 if gene only, 2 if gene and mRNA, 3 if CDS, 0 if none of the above
#misc:  1 if rRNA; 2 if tRNA; 3 if snRNA; 4 if snoRNA; 5 if scRNA; 6 if miscRNA; 7 if miscfea; 8 if STS;
# transp 1 if trnasp 0 in not

 print OUT "bp;gene;transp;\n";

for (my $i = 1; $i < (scalar @$gene +1); ++$i)
{
    my $line = "$i;";
    if ($$gap[$i]==1)
     {$line .= '-1;';}
    elsif ($$CDS[$i]==1)
     {$line .= '3;';}
    elsif ($$mRNA[$i]==1)
     {$line .= '2;';}
    elsif ($$gene[$i]==1)
     {$line .= '1;';}
    else
     {$line .= '0;';}
   
#    if ($$rRNA[$i]==1)
#     {$line .= '1;';}
#    if ($$tRNA[$i]==1)
#     {$line .= '2;';}
#    elsif ($$snRNA[$i]==1)
#     {$line .= '3;';}
#    elsif ($$snoRNA[$i]==1)
#     {$line .= '4;';}
#    elsif ($$csRNA[$i]==1)
#     {$line .= '5;';}
#    elsif ($$miscRNA[$i]==1)
#     {$line .= '6;';}
#    elsif ($$miscfea[$i]==1)
#     {$line .= '7;';}
#    elsif ($$STS[$i]==1)
#     {$line .= '8;';}
#    else
#     {$line .= '0;';}

    if ($$repeat[$i]==1)
     {$line .= '1;';}
    else
     {$line .= '0;';}

    print OUT "$line\n";
}
close OUT;

}

#########################################################################

sub print_two_hachage_into_file
{
my ($hach1, $hach2, $filename) = @_;

my @code = keys %$hach1;
   my @sorted_code = sort @code;

   open (HACH, ">$filename");
   foreach my $code (@sorted_code)
     {
        print HACH "$code;$$hach1{$code};$$hach2{$code}\n";
     }
close HACH;

}
##################################

sub random_number
{
#If number begins with 0s, zeros are kept
my ($number) =@_;
	my $digit = length $number;
	my $ok = 1;
	while ($ok == 1)
	{
		my $random_numb = '';
		for (my $i = 0; $i < $digit; ++$i)
		{
			my $l = int rand 10;
#			print "$l ";
		$random_numb .= $l;
 	#end for $i
		}
		if ($random_numb < ($number +1))
		{
			$ok = 0;
			return $random_numb;
		}
	}
}

##################################

sub random_number_1
{
#If number begins with 0s, zeros are deleted; random number is smaller than nuber
my ($number) =@_;
	my $digit = length $number;
	my $ok = 1;
	while ($ok == 1)
	{
		my $random_numb = '';
		for (my $i = 0; $i < $digit; ++$i)
		{
			my $l = int rand 10;
#			print "$l ";
		$random_numb .= $l;
 	#end for $i
		}
		if ($random_numb < ($number))
		{
			$random_numb =~ s/^0+//;
			if ($random_numb eq '')
			{
				$random_numb = 0;
			}
			$ok = 0;
			return $random_numb;	
		}
	}
}



##########################################
sub read_hash_from_fasta
{
my ($filename) = @_; 
my %hash = ();

unless (open (DATA, $filename))
{
    print "Unable to open $filename!";
    exit;
}
my @data = <DATA>;
close DATA;
my $code = ''; 
my $all_codes = '';
my $code_temp = '';

foreach my $line (@data)
{
    if ( $line =~ />\s*[^\s]+/i)
    {
	$code = $&;
	$code =~ s/>\s*//;
# check if the same filecode exist twice. if yes quits the program
	$code_temp = $code.';';
	if ( $all_codes =~ /$code_temp/)
	{
	    print "Attention: $code is present at least twice in the file!\n";
	    exit;
	}
	$all_codes .= $code_temp;
	next;
    }
    $hash{$code} .= $line; 
}

@data = ();
@codes = keys %hash;


foreach my $clone (@codes)
{
    $hash{$clone} =~ s/\s//g;
}

return %hash;

}



#################################################################


sub read_hach_from_fasta_code_wo_space
{
my ($filename) = @_;
my %seq = ();
	my $i = 0;
	open_file_in($filename, 'IN');
	$/ = ">";
	while (my $seq = <IN>)
	{
		$seq =~ s/>//;
		unless ($seq eq '')
		{
			$seq =~ /.*\n/;
			my $code = $&;
			$seq =~ s/$code//;
			$seq =~ s/\s//g;
			$code =~ s/\s.*//;
			$code =~ s/\s//;
			if (exists $seq{$code})
			{
				++$i;
			}
			$seq{$code} = $seq;	
		}
	}
	if ($i>0)
	{
		print "number of sequences with code already used by other sequence: $i\n";
	}
	$/ = "\n";
return %seq;
}


#######################################################################

sub read_hachage_from_file
{
    my ($filename) = @_;
    my %hach = ();
# open file 
  unless ( open(FILE, $filename) )
    {
       print "Cannot open $filename!\n";
    }
   my @data = <FILE>; 
#   print @data; 
   close FILE;

   foreach my $ligne (@data) 
   {
       $ligne =~ /[a-z0-9_]+/i;
       my $code = $&;
       $ligne =~ /\s{5}.*/;
       my $value = $&;
       $value =~ s/     //;
       $hach{$code} = "$value";
   }
    return %hach;
}






###########################################################


sub read_hachage_from_file_1

# everything befor the first ; is key after value
{
    my ($filename) = @_;
    my %hach = ();
# open file 
  unless ( open(FILE, $filename) )
    {
       print "Cannot open $filename!\n";
    }
   my @data = <FILE>; 
#   print @data; 
   close FILE;

   foreach my $ligne (@data) 
   {
       $ligne =~ /.*;/i;
       my $code = $&;
       $ligne =~ s/$code//;
       $hach{$code} = "$ligne";
   }
    return %hach;
}



###########################################################

sub read_hachage_from_file_2

# everything before the first ; is key after value
{
    my ($filename) = @_;
    my %hach = ();
# open file 
  unless ( open(FILE, $filename) )
    {
       print "Cannot open $filename!\n";
    }
   my @data = <FILE>; 
#   print @data; 
   close FILE;

   foreach my $ligne (@data) 
   {
       $ligne =~ /.*?;/i;
       my $code = $&;
       $ligne =~ s/$code//;
       $code =~ s/;//;
 #      $ligne =~ s/\s{2,}/\s/g;
       chomp $ligne;
       $hach{$code} = "$ligne";
   }
   @data = ();
    return %hach;
}



###########################################################


sub read_hachage_from_file_3

# everything befor the first \s is key after value
{
    my ($filename) = @_;
    my %hach = ();
# open file 
  unless ( open(FILE, $filename) )
    {
       print "Cannot open $filename!\n";
    }
   my @data = <FILE>; 
#   print @data; 
   close FILE;

   foreach my $ligne (@data) 
   {
       $ligne =~ /.*?\s/i;
       my $code = $&;
       $ligne =~ s/$code//;
       $liggne =~ s/\s//g;
       $hach{$code} = "$ligne";
   }
    return %hach;
}

######################################################
sub recalculate_MS_pos
{
  my ($ms_hachage, $vector) = @_;
  my @code = keys %$vector;
  
  
  foreach my $code (@code)
  {
      $$vector{$code} =~ /[0-9]+/;
      my $vec_beg = $&;
      if ($vec_beg != 0 )
      {
#	  print "$code  $vec_beg\n";
	  my $temp = $$ms_hachage{$code};
	  while ($$ms_hachage{$code} =~ /[0-9]+/g )
	  {
	      my $old_pos = $&;
	#      print "$old_pos ";
	      my $new_pos = $old_pos - $vec_beg;
	 #     print "$new_pos, ";
	      $temp =~ s/$old_pos/$new_pos/;
	 #     print "$temp\n";
	  }
	  $$ms_hachage{$code} = $temp;
	#  print "\n";
      }
  }
}

###########################################################

sub recalculate_MS_pos_1
{
  my ($ms_hachage, $vector) = @_;
  my @code = keys %$vector;
  
  
  foreach my $code (@code)
  {
      $$vector{$code} =~ /[0-9]+/;
      my $vec_beg = $&;
      if ($vec_beg != 0 )
      {
	#  print "$code  $vec_beg\n";
	  my @temp_ms = split ( ' ', $$ms_hachage{$code});
	#  print "$$ms_hachage{$code}\n";
	  for (my $i = 0; $i < scalar @temp_ms; ++$i)
	  {
	      if ($temp_ms[$i] =~ /[0-9]+-/ )
	      {
		  my $ms_beg = $&;
		  $ms_beg =~ s/-//;
		  $ms_beg = $ms_beg - $vec_beg;
		  
		  $temp_ms[$i] =~ /[0-9]+,/;
                  my $ms_end = $&;
		  $ms_end =~ s/,//;
		  $ms_end = $ms_end - $vec_beg;
		  $temp_ms[$i] = $ms_beg.'-'.$ms_end.','
	      }
	  }
	  $$ms_hachage{$code} = join ( ' ', @temp_ms );
#	  print "$$ms_hachage{$code}\n";

      }
  }
}

##########################################################"

sub reverse_complement
{
    my ($temp) = @_;
    my $revcomp = reverse $temp;
    $revcomp =~ tr/ATCGatcg/TAGCtagc/;
    return $revcomp;
}

###########################################################

sub sort_files
{
    my ($folder, $maskfas, $fas, $ms, $seq) = @_;


    unless ( opendir(FOLDER, $folder) )
    {
      print "Cannot access to folder $folder\n";
      exit;
    }
    my @filenames = grep ( !/^\.\.?$/, readdir(FOLDER) );

    closedir(FOLDER);    
    
    foreach my $filename (@filenames)
    {
	$filename = $folder.'/'.$filename;

	if ( $filename =~ /mask.*\.fas/ )
	{
	    push (@$maskfas, $filename);
	}

	if ( $filename !~ /mask/ and $filename =~ /\.fas/ )
	{
	    push (@$fas, $filename);
	}

	if ( $filename =~ /\.ms/ )
	{
	    push (@$ms, $filename);
	}

	if ( $filename =~ /\.seq/ )
	{
	    push (@$seq, $filename);
	}
    }

}

############################################################

sub sort_microsat
{

    my ($microsat, $microsat_all) = @_;

    my (@sorted_microsat) = ();
    my (@microsat_temp) = ();
 
# extract microsat positions and aranges them in order; put motif pos_beg pos end into a table     
	      while ($microsat =~ /[0-9]+-/g )
	      {
		  my $ms_beg = $&;
		  $ms_beg =~ s/-//;
		  push (@microsat_temp, $ms_beg);
		  @sorted_microsat = sort { $a <=> $b } @microsat_temp;
	      }
    my ($microsat_number) = scalar (@sorted_microsat);

	# finds microsat motif for each position and puts everything in @microsat      
    
	      for (my $i = 0; $i < scalar(@sorted_microsat); ++$i)
		  {
		      $microsat =~ /[ATGC]+\s$sorted_microsat[$i]-[0-9]+/;
		      my $ms = $&;
		      $ms =~ /[ATGC]+/;
		      my $temp = $&;
		      my $ms_motif = transfer_ms_motif($temp);

		      push (@$microsat_all, $ms_motif);
		      push (@$microsat_all, $sorted_microsat[$i]);  
		      $ms =~ /-[0-9]+/;
		      my $ms_end = $&;
		      $ms_end =~ s/-//;
		      push (@$microsat_all, $ms_end);
		  }

    return $microsat_number;

}

##############################################################




sub table_into_hach2
  {
  use warnings;
  use strict;
  # convert table into hachage
  my @seqint = @_;
  my %seq_hach = ();
  my $code = ();
  my $seq = ();
  my @code = ();

  while (@seqint)
    {
      $code = shift(@seqint);

      # delete the > at the begining of the code
      $code =~ s/>//g;

      # keep only the first non-interriupted characters of the code
      @code = split(/\s+/, $code);
      $code = shift(@code);

      $seq = shift(@seqint);
      $seq_hach{$code} = $seq;
    }
  return %seq_hach;
  }

###################################################

sub take_best_hits
{
my ($blast_out) =@_;
my %bl = ();
open_file_in($blast_out, 'BL');
my %bl_e = ();
while (my $line = <BL>)
{
	if ($line =~ /#/)
	{
		next;
	}
 	my @line = split(' ', $line);
	if (exists $bl{$line[0]})
	{
		if ($line[10] < $bl_e{$line[0]})
		{
			$bl{$line[0]} = $line;
			$bl_e{$line[0]} = $line[10]; 
		}
	}
	else
	{
		$bl{$line[0]} = $line;
		$bl_e{$line[0]} = $line[10]; 
	}
}
%bl_e = ();

#print_hachage_into_file_1(\%bl, 'temp1/test.tbl');
close BL;
return %bl;
}


#########################################################

sub transfer_ms_motif
{
# among all possibilities of writing the same MS motif, choses the one that
# is the first in the alfabetical order 
    my ($motif) = @_;
   
    my $numb_base = length $motif;

    my @ms_var = ();
    push (@ms_var, $motif);
    for (my $i = 1; $i < $numb_base; ++$i)
    {
	my @motif = split('',$motif);
	my $base = shift @motif;
	push (@motif, $base);
	$motif = join('', @motif);
        push (@ms_var, $motif);
    }

    for (my $j = 0; $j < $numb_base; ++$j)
    {
	$temp = $ms_var[$j];
	$temp =~ tr/ACGT/TGCA/;
	push (@ms_var, $temp);
    }
    my (@sort_ms) = sort @ms_var;
    
   my $motif_1 = shift @sort_ms;


return ($motif_1);

}

###########################################################

sub transpose_file
{
 my ($outfile) = @_;
 my %hach = open_file_and_hach($outfile, '1');
 my $out_transp = $outfile;
 $out_transp =~ s/\./_transp\./;
 open_file_out($out_transp, 'OUT');

 my @codes = sort keys %hach;

 my $max = 0;
 foreach my $chr (@codes)
 {
     my @chr = split(';', $hach{$chr});
     if (scalar@chr > $max)
     {
	 $max = scalar@chr;
     }
 }

 foreach my $chr (@codes)
 {
     my @chr = split(';', $hach{$chr});
     print OUT "$chr;";
     if (scalar@chr < $max)
     {
	 for (my $j = scalar@chr; $j< ($max+1); ++$j)
	 {
	     $hach{$chr} .= 'NA;'
	 }
     }
 }
 print OUT "\n";

for (my $i = 0; $i<$max; ++$i)
{
    foreach my $chr (@codes)
    {
	$hach{$chr} =~ s/[0-9a-z]+;//i;
	my $temp = $&;
	print OUT "$temp";
    }
    print OUT "\n";
}
close OUT;


}

##########################################################

sub txt_into_hachage
{
# reads each line into a hachache. First element before first space is the code all other in the lines are values, separates element of the line by ;
    my (@data) = @_;
    my %hach = ();

foreach my $ligne (@data)
{
    
    $ligne =~ s/\s+/;/g;
    $ligne =~ /.+?;/;
    my $code = $&;
    $ligne =~ s/$code//;
    $code =~ s/;//;
    $hach{$code} = $ligne;
}

return %hach;

}
###########################################################

sub txt_into_hachage_1
{
# reads each line into a hachache. First element before first ';' is the code all other in the lines are values, separates element of the line by ;
    my (@data) = @_;
    my %hach = ();

foreach my $ligne (@data)
{
    
#    $ligne =~ s/\s+/\s/g;
    chomp $ligne;
    $ligne =~ /.+?;/;
    my $code = $&;
    $ligne =~ s/$code//;
    $code =~ s/;//;
    $hach{$code} = $ligne;
}

return %hach;

}

#########################################################

sub write_info
{
my ($orig_length, $NON_ATGC, $N_hach, $vector, $clean_length, $ms_hachage, $filename) = @_;
my @code_total = keys %$N_hach;
my @sorted_code = sort @code_total;
my %vector_code = ();
my $i = 1;

my @short_code = keys %$vector;
my $short_code = join( ' ', @short_code ); 
$short_code .= ' ';
    
open (OUTFILE, ">$filename");

print OUTFILE "     CODE  OR_LENG NON_ATGC     NBEG     NEND VEC_BEGp VEC_BEGn VEC_ENDp VEC_ENDn   C_LENG MICROSAT MOTIF and POS\n";


foreach my $code (@sorted_code)
{
    # extract the number of bases deleted from the begining and from the end 
    #of the sequence due to Ns
    my @N = split( /\s+/, $$N_hach{$code} );
    my $Nend = pop @N;
    my $Nbeg = pop @N;
 
    my $vec_pos_beg = '';
    my $vec_pos_end = '';
    my $vec_beg = '';
    my $vec_end = '';
    my $ms = '';

    if ($short_code =~ /$code\s/)
    {
	$booleen = 1;
    
    # Extract the positions of the most far reaching vectors (0 and 10000 for no hits)
   
	$$vector{$code} =~ /BEG:\s[0-9]+/;
	$vec_pos_beg = $&;
	$vec_pos_beg =~ s/[^0-9]//g;

	$$vector{$code} =~ /SEND:\s[0-9]+/;
	$vec_pos_end = $&;
	$vec_pos_end =~ s/[^0-9]//g;

	# Extract vector names, gives code for vectors and puts the vector with the 
	# code into a hachage   
	$vec_beg = 'none';
	$vector_code{'none'} = 'none';
	if ($vec_pos_beg != 0)
	{
	    $$vector{$code} =~ />.+POSEND/;
	    $vec_beg = $&;
	    $vec_beg =~ s/\s+POSEND//;
	    unless( $vector_code{$vec_beg} )
	    {
		$vector_code{$vec_beg} = $i;
		++$i;
	    }
	}
	$vec_end = 'none';
	if ($vec_pos_end != 100000)
	{
	    $$vector{$code} =~ /POSEND.*/;
	    $vec_end = $&;
	    $vec_end =~ /POSEND.*>/;
	    my $temp = $&;
	    $vec_end =~ s/$temp/>/;
	    unless( $vector_code{$vec_end} )
	    {
		$vector_code{$vec_end} = $i;
		++$i;
	    }
	}


    #extract ms motifs and positions
    $ms = $$ms_hachage{$code};
    $ms =~ s/motif://;
#    $ms =~ s/\s//g;

    }

    else
    {
	$vec_pos_beg = 'NO MS';
	$vec_pos_end = 'NO MS';
        $vector_code{$vec_beg} = 'NO MS';
	$vector_code{$vec_end} = 'NO MS';
	$$clean_length{$code} = 'NO MS';
	$ms = 'NO MS';
    }   

   
format OUTFILE = 

@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>>@>>>>>>>> ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$code, $$orig_length{$code}, $$NON_ATGC{$code}, $Nbeg, $Nend, $vec_pos_beg, $vector_code{$vec_beg}, $vec_pos_end, $vector_code{$vec_end}, $$clean_length{$code}, $ms
.
write OUTFILE;
}

my @cles = keys %vector_code;
my @valeurs = values %vector_code;
print OUTFILE "\n\n";
  while (@cles)
     {
       my $vector = shift(@cles);
       my $number = shift(@valeurs);
       print OUTFILE "$number     $vector\n";
     }


close OUTFILE;
print "Information on the cleaned sequences are written in $filename\n";

}

##########################################################

sub write_clas_wo_red
{
my ($desc, $filename, $count_CSS, $count_indep, $count_group, $total, $prop_group) = @_;

  $filename =~ /\/.+\./i;
  $filename = $&;
  $filename =~ s/^\///;
  $filename =~ s/\.$//; 



printf $desc "%32s%8d%8d%8d%8d   %5.3f\n",
$filename, $count_CSS, $count_indep, $count_group, $total, $prop_group;

}

##########################################################

sub write_clas_all_seq_bootstrap
{
my ($desc, $filename, $count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group, $AVR_prop, $STD_prop) = @_;

  $filename =~ /\/.+\./i;
  $filename = $&;
  $filename =~ s/^\///;
  $filename =~ s/\.$//; 



printf $desc "%32s%8d%8d%8d%8d%8d   %5.3f   %5.3f  %6.4f\n",
$filename, $count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group, $AVR_prop, $STD_prop;

}

###########################################################


sub write_clas_all_seq_bootstrap_gb
{
my ($desc, $filename, $count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group, $AVR_prop, $STD_prop, $count_CSS_WO_red, $count_indep_WO_red, $count_group_WO_red, $prop_group_WO_red) = @_;

  $filename =~ /\/.+\./i;
  $filename = $&;
  $filename =~ s/^\///;
  $filename =~ s/\.$//; 
 

printf $desc "%32s%8d%8d%8d%8d%8d   %5.3f   %5.3f  %6.4f%8d%8d%8d   %5.3f\n",
$filename, $count_CSS, $count_redundant, $count_indep, $count_group, $total, $prop_group, $AVR_prop, $STD_prop, $count_CSS_WO_red, $count_indep_WO_red, $count_group_WO_red, $prop_group_WO_red;

}

###########################################################


sub write_spec_seq_group_lenght
{
my ($desc2, $filename, $clas_seq, $length, $group_index) = @_;

  $filename =~ /\/.*\./;
  my $species = $&;
  $species =~ s/\.//;
  $species =~ s/\///;
  @code = keys %$clas_seq;
  
  foreach my $code (@code)
  {
      unless (exists $$group_index{$code})
      {
	  $$group_index{$code} = 'NA;NA';
      }
      printf $desc2 "$code;$species;$$clas_seq{$code};$$length{$code};$$group_index{$code}\n";
  }

}

########################################################

1;
